      module mo_lin_matrix
      use chem_mods, only: veclen
      private
      public :: linmat
      contains
      subroutine linmat01( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,554) = -( rxt(k,20) + het_rates(k,1) )
         mat(k,531) = -( rxt(k,21) + het_rates(k,2) )
         mat(k,1) = -( het_rates(k,3) )
         mat(k,2) = -( het_rates(k,4) )
         mat(k,853) = -( het_rates(k,5) )
         mat(k,87) = -( het_rates(k,6) )
         mat(k,277) = -( rxt(k,22) + het_rates(k,7) )
         mat(k,93) = -( rxt(k,23) + het_rates(k,8) )
         mat(k,283) = -( rxt(k,24) + het_rates(k,9) )
         mat(k,340) = -( rxt(k,25) + het_rates(k,10) )
         mat(k,278) = .500_r8*rxt(k,22)
         mat(k,94) = rxt(k,23)
         mat(k,494) = .200_r8*rxt(k,71)
         mat(k,582) = .060_r8*rxt(k,73)
         mat(k,197) = -( rxt(k,26) + het_rates(k,11) )
         mat(k,493) = .200_r8*rxt(k,71)
         mat(k,580) = .200_r8*rxt(k,73)
         mat(k,518) = -( rxt(k,27) + het_rates(k,12) )
         mat(k,159) = rxt(k,47)
         mat(k,748) = rxt(k,57)
         mat(k,496) = .200_r8*rxt(k,71)
         mat(k,583) = .150_r8*rxt(k,73)
         mat(k,232) = -( rxt(k,28) + het_rates(k,13) )
         mat(k,581) = .210_r8*rxt(k,73)
         mat(k,163) = -( het_rates(k,14) )
         mat(k,269) = -( het_rates(k,15) )
         mat(k,1326) = -( het_rates(k,16) )
         mat(k,167) = rxt(k,75)
         mat(k,1447) = rxt(k,76)
         mat(k,442) = rxt(k,78)
         mat(k,758) = rxt(k,100)
         mat(k,651) = rxt(k,106)
         mat(k,1661) = rxt(k,245)*y(k,33) + rxt(k,271)*y(k,34) &
                      + 3.000_r8*rxt(k,272)*y(k,54) + 2.000_r8*rxt(k,273)*y(k,76) &
                      + 2.000_r8*rxt(k,294)*y(k,40) + rxt(k,295)*y(k,42)
         mat(k,1903) = 2.000_r8*rxt(k,282)*y(k,40) + rxt(k,284)*y(k,42) &
                      + 3.000_r8*rxt(k,289)*y(k,54)
         mat(k,1635) = 2.000_r8*rxt(k,283)*y(k,40) + rxt(k,285)*y(k,42) &
                      + 3.000_r8*rxt(k,290)*y(k,54)
         mat(k,166) = -( rxt(k,75) + het_rates(k,17) )
         mat(k,1450) = -( rxt(k,76) + het_rates(k,18) )
         mat(k,443) = rxt(k,77)
         mat(k,440) = -( rxt(k,77) + rxt(k,78) + rxt(k,545) + rxt(k,548) + rxt(k,553) &
                 + het_rates(k,19) )
         mat(k,169) = -( het_rates(k,21) )
         mat(k,247) = rxt(k,29)
         mat(k,248) = -( rxt(k,29) + het_rates(k,22) )
         mat(k,200) = -( het_rates(k,23) )
         mat(k,448) = -( het_rates(k,24) )
         mat(k,177) = -( het_rates(k,25) )
         mat(k,253) = -( rxt(k,30) + het_rates(k,26) )
         mat(k,206) = -( het_rates(k,27) )
         mat(k,935) = -( het_rates(k,28) )
         mat(k,1217) = .700_r8*rxt(k,56)
         mat(k,301) = -( rxt(k,31) + het_rates(k,29) )
         mat(k,56) = -( het_rates(k,30) )
         mat(k,181) = -( rxt(k,32) + het_rates(k,31) )
         mat(k,1425) = -( rxt(k,33) + rxt(k,34) + het_rates(k,41) )
         mat(k,560) = .100_r8*rxt(k,20)
         mat(k,538) = .100_r8*rxt(k,21)
         mat(k,309) = rxt(k,39)
         mat(k,988) = rxt(k,44)
         mat(k,1018) = .330_r8*rxt(k,46)
         mat(k,1030) = rxt(k,48)
         mat(k,577) = .690_r8*rxt(k,50)
         mat(k,1117) = 1.340_r8*rxt(k,51)
         mat(k,776) = rxt(k,58)
         mat(k,436) = rxt(k,63)
         mat(k,298) = rxt(k,64)
         mat(k,490) = .375_r8*rxt(k,66)
         mat(k,377) = .400_r8*rxt(k,68)
         mat(k,972) = .680_r8*rxt(k,70)
         mat(k,329) = rxt(k,314)
         mat(k,346) = 2.000_r8*rxt(k,341)
         mat(k,1664) = rxt(k,156)*y(k,53) + rxt(k,157)*y(k,53)
         mat(k,1047) = -( rxt(k,35) + het_rates(k,44) )
         mat(k,558) = .400_r8*rxt(k,20)
         mat(k,536) = .400_r8*rxt(k,21)
         mat(k,255) = rxt(k,30)
         mat(k,1015) = .330_r8*rxt(k,46)
         mat(k,219) = rxt(k,54)
         mat(k,435) = rxt(k,63)
         mat(k,53) = -( het_rates(k,46) )
         mat(k,906) = -( rxt(k,36) + het_rates(k,47) )
         mat(k,557) = .250_r8*rxt(k,20)
         mat(k,535) = .250_r8*rxt(k,21)
         mat(k,303) = .820_r8*rxt(k,31)
         mat(k,1009) = .170_r8*rxt(k,46)
         mat(k,485) = .300_r8*rxt(k,66)
         mat(k,376) = .050_r8*rxt(k,68)
         mat(k,966) = .500_r8*rxt(k,70)
         mat(k,1124) = -( rxt(k,37) + het_rates(k,48) )
         mat(k,286) = .180_r8*rxt(k,24)
         mat(k,234) = rxt(k,28)
         mat(k,501) = .400_r8*rxt(k,71)
         mat(k,591) = .540_r8*rxt(k,73)
         mat(k,316) = .510_r8*rxt(k,74)
         mat(k,464) = -( het_rates(k,49) )
         mat(k,404) = -( rxt(k,38) + het_rates(k,50) )
         mat(k,703) = -( het_rates(k,51) )
         mat(k,307) = -( rxt(k,39) + het_rates(k,52) )
         mat(k,1915) = -( rxt(k,220)*y(k,53) + rxt(k,282)*y(k,40) + rxt(k,284)*y(k,42) &
                      + rxt(k,287)*y(k,45) + rxt(k,289)*y(k,54) + het_rates(k,55) )
         mat(k,168) = rxt(k,75)
         mat(k,103) = 2.000_r8*rxt(k,92)
         mat(k,48) = 2.000_r8*rxt(k,93)
         mat(k,1942) = rxt(k,94)
         mat(k,927) = rxt(k,95)
         mat(k,135) = rxt(k,98)
         mat(k,1319) = rxt(k,104)
         mat(k,770) = rxt(k,107)
         mat(k,1673) = 4.000_r8*rxt(k,244)*y(k,32) + rxt(k,245)*y(k,33) &
                      + 2.000_r8*rxt(k,246)*y(k,35) + 2.000_r8*rxt(k,247)*y(k,36) &
                      + 2.000_r8*rxt(k,248)*y(k,37) + rxt(k,249)*y(k,38) &
                      + 2.000_r8*rxt(k,250)*y(k,39) + rxt(k,296)*y(k,80) &
                      + rxt(k,297)*y(k,81) + rxt(k,298)*y(k,82)
         mat(k,1647) = 3.000_r8*rxt(k,286)*y(k,43) + rxt(k,288)*y(k,45) &
                      + rxt(k,291)*y(k,80) + rxt(k,292)*y(k,81) + rxt(k,293)*y(k,82)
         mat(k,102) = -( rxt(k,92) + het_rates(k,56) )
         mat(k,47) = -( rxt(k,93) + rxt(k,254) + het_rates(k,57) )
         mat(k,1943) = -( rxt(k,94) + het_rates(k,58) )
         mat(k,928) = rxt(k,96)
         mat(k,241) = rxt(k,108)
         mat(k,49) = 2.000_r8*rxt(k,254)
         mat(k,921) = -( rxt(k,95) + rxt(k,96) + rxt(k,547) + rxt(k,552) + rxt(k,558) &
                 + het_rates(k,59) )
         mat(k,1023) = -( het_rates(k,61) )
         mat(k,95) = 1.500_r8*rxt(k,23)
         mat(k,285) = .450_r8*rxt(k,24)
         mat(k,520) = .600_r8*rxt(k,27)
         mat(k,233) = rxt(k,28)
         mat(k,1419) = rxt(k,33) + rxt(k,34)
         mat(k,1046) = rxt(k,35)
         mat(k,1123) = rxt(k,37)
         mat(k,987) = rxt(k,44)
         mat(k,803) = 2.000_r8*rxt(k,45)
         mat(k,1012) = .330_r8*rxt(k,46)
         mat(k,1111) = 1.340_r8*rxt(k,52)
         mat(k,1218) = .700_r8*rxt(k,56)
         mat(k,126) = 1.500_r8*rxt(k,65)
         mat(k,489) = .250_r8*rxt(k,66)
         mat(k,886) = rxt(k,69)
         mat(k,968) = 1.700_r8*rxt(k,70)
         mat(k,264) = rxt(k,137)
         mat(k,1898) = rxt(k,287)*y(k,45)
         mat(k,515) = rxt(k,572)*y(k,62)
         mat(k,60) = -( rxt(k,97) + het_rates(k,63) )
         mat(k,1653) = rxt(k,245)*y(k,33) + rxt(k,247)*y(k,36) &
                      + 2.000_r8*rxt(k,248)*y(k,37) + 2.000_r8*rxt(k,249)*y(k,38) &
                      + rxt(k,250)*y(k,39) + rxt(k,271)*y(k,34) &
                      + 2.000_r8*rxt(k,273)*y(k,76) + rxt(k,297)*y(k,81) &
                      + rxt(k,298)*y(k,82)
         mat(k,1515) = rxt(k,292)*y(k,81) + rxt(k,293)*y(k,82)
         mat(k,132) = -( rxt(k,98) + het_rates(k,64) )
         mat(k,1656) = rxt(k,246)*y(k,35) + rxt(k,247)*y(k,36) + rxt(k,296)*y(k,80)
         mat(k,1526) = rxt(k,291)*y(k,80)
         mat(k,120) = -( het_rates(k,65) )
         mat(k,191) = -( het_rates(k,66) )
         mat(k,3) = -( het_rates(k,67) )
         mat(k,4) = -( het_rates(k,68) )
         mat(k,5) = -( het_rates(k,69) )
         mat(k,63) = -( rxt(k,43) + het_rates(k,70) )
         mat(k,658) = -( rxt(k,276)*y(k,53) + het_rates(k,71) )
         mat(k,61) = 2.000_r8*rxt(k,97)
         mat(k,133) = rxt(k,98)
         mat(k,156) = rxt(k,105)
         mat(k,1657) = rxt(k,249)*y(k,38) + rxt(k,271)*y(k,34)
         mat(k,986) = -( rxt(k,44) + het_rates(k,72) )
         mat(k,1010) = .330_r8*rxt(k,46)
         mat(k,487) = .250_r8*rxt(k,66)
         mat(k,802) = -( rxt(k,45) + rxt(k,522) + het_rates(k,73) )
         mat(k,280) = rxt(k,22)
         mat(k,284) = .130_r8*rxt(k,24)
         mat(k,244) = .700_r8*rxt(k,62)
         mat(k,500) = .600_r8*rxt(k,71)
         mat(k,588) = .340_r8*rxt(k,73)
         mat(k,315) = .170_r8*rxt(k,74)
         mat(k,2119) = -( het_rates(k,74) )
         mat(k,2145) = 2.000_r8*rxt(k,2) + rxt(k,3)
         mat(k,1438) = 2.000_r8*rxt(k,33)
         mat(k,311) = rxt(k,39)
         mat(k,763) = rxt(k,100)
         mat(k,1322) = rxt(k,104)
         mat(k,157) = rxt(k,105)
         mat(k,1677) = rxt(k,156)*y(k,53)
         mat(k,1058) = -( het_rates(k,75) )
         mat(k,2126) = rxt(k,1)
         mat(k,1420) = rxt(k,34)
         mat(k,1659) = rxt(k,157)*y(k,53)
         mat(k,504) = -( rxt(k,4) + het_rates(k,77) )
         mat(k,1979) = .500_r8*rxt(k,523)
         mat(k,66) = -( rxt(k,136) + het_rates(k,78) )
         mat(k,757) = -( rxt(k,100) + het_rates(k,79) )
         mat(k,1311) = -( rxt(k,104) + het_rates(k,83) )
         mat(k,1902) = rxt(k,220)*y(k,53) + rxt(k,282)*y(k,40) + rxt(k,284)*y(k,42) &
                      + 2.000_r8*rxt(k,287)*y(k,45) + rxt(k,289)*y(k,54)
         mat(k,104) = -( het_rates(k,84) )
         mat(k,707) = -( het_rates(k,85) )
         mat(k,155) = -( rxt(k,105) + het_rates(k,86) )
         mat(k,657) = rxt(k,276)*y(k,53)
         mat(k,1691) = -( rxt(k,9) + het_rates(k,87) )
         mat(k,187) = 2.000_r8*rxt(k,524) + 2.000_r8*rxt(k,543) + 2.000_r8*rxt(k,546) &
                      + 2.000_r8*rxt(k,557)
         mat(k,1814) = .500_r8*rxt(k,527)
         mat(k,2091) = rxt(k,528)
         mat(k,445) = rxt(k,545) + rxt(k,548) + rxt(k,553)
         mat(k,925) = rxt(k,547) + rxt(k,552) + rxt(k,558)
      end do
      end subroutine linmat01
      subroutine linmat02( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,366) = -( rxt(k,10) + rxt(k,11) + rxt(k,217) + het_rates(k,88) )
         mat(k,649) = -( rxt(k,106) + het_rates(k,89) )
         mat(k,441) = rxt(k,545) + rxt(k,548) + rxt(k,553)
         mat(k,766) = -( rxt(k,107) + het_rates(k,90) )
         mat(k,920) = rxt(k,547) + rxt(k,552) + rxt(k,558)
         mat(k,1011) = -( rxt(k,46) + het_rates(k,91) )
         mat(k,158) = -( rxt(k,47) + het_rates(k,92) )
         mat(k,1132) = rxt(k,415)
         mat(k,1027) = -( rxt(k,48) + het_rates(k,93) )
         mat(k,1013) = .170_r8*rxt(k,46)
         mat(k,258) = -( het_rates(k,94) )
         mat(k,69) = -( het_rates(k,95) )
         mat(k,785) = -( het_rates(k,96) )
         mat(k,456) = -( het_rates(k,97) )
         mat(k,348) = -( het_rates(k,98) )
         mat(k,1097) = -( het_rates(k,99) )
         mat(k,289) = -( rxt(k,49) + het_rates(k,100) )
         mat(k,573) = -( rxt(k,50) + het_rates(k,101) )
         mat(k,290) = rxt(k,49)
         mat(k,40) = -( het_rates(k,102) )
         mat(k,1112) = -( rxt(k,51) + rxt(k,52) + het_rates(k,103) )
         mat(k,575) = .288_r8*rxt(k,50)
         mat(k,212) = -( het_rates(k,104) )
         mat(k,410) = -( rxt(k,53) + het_rates(k,105) )
         mat(k,553) = .800_r8*rxt(k,20)
         mat(k,530) = .800_r8*rxt(k,21)
         mat(k,217) = -( rxt(k,54) + het_rates(k,106) )
         mat(k,476) = -( rxt(k,55) + rxt(k,397) + het_rates(k,107) )
         mat(k,827) = -( het_rates(k,108) )
         mat(k,1223) = -( rxt(k,56) + het_rates(k,109) )
         mat(k,576) = .402_r8*rxt(k,50)
         mat(k,739) = -( rxt(k,111) + het_rates(k,110) )
         mat(k,1735) = rxt(k,15)
         mat(k,514) = rxt(k,573)
         mat(k,185) = -( rxt(k,13) + rxt(k,14) + rxt(k,218) + rxt(k,524) + rxt(k,543) &
                      + rxt(k,546) + rxt(k,557) + het_rates(k,112) )
         mat(k,222) = -( het_rates(k,113) )
         mat(k,749) = -( rxt(k,57) + het_rates(k,114) )
         mat(k,6) = -( het_rates(k,115) )
         mat(k,7) = -( het_rates(k,116) )
         mat(k,8) = -( het_rates(k,117) )
         mat(k,50) = -( het_rates(k,118) )
         mat(k,9) = -( rxt(k,526) + het_rates(k,119) )
         mat(k,10) = -( rxt(k,525) + het_rates(k,120) )
         mat(k,1773) = -( rxt(k,15) + rxt(k,16) + het_rates(k,121) )
         mat(k,188) = rxt(k,14)
         mat(k,1815) = rxt(k,17) + .500_r8*rxt(k,527)
         mat(k,2092) = rxt(k,19)
         mat(k,683) = rxt(k,570)
         mat(k,1670) = 2.000_r8*rxt(k,211)*y(k,111)
         mat(k,1816) = -( rxt(k,17) + rxt(k,527) + het_rates(k,122) )
         mat(k,1693) = rxt(k,9)
         mat(k,369) = rxt(k,11) + rxt(k,217)
         mat(k,189) = rxt(k,13) + rxt(k,218)
         mat(k,2093) = rxt(k,18)
         mat(k,562) = rxt(k,20)
         mat(k,1020) = rxt(k,46)
         mat(k,293) = rxt(k,49)
         mat(k,481) = rxt(k,55) + rxt(k,397)
         mat(k,755) = rxt(k,57)
         mat(k,778) = rxt(k,58)
         mat(k,231) = rxt(k,59)
         mat(k,73) = rxt(k,60)
         mat(k,360) = .600_r8*rxt(k,61) + rxt(k,348)
         mat(k,418) = rxt(k,67)
         mat(k,446) = rxt(k,77)
         mat(k,926) = rxt(k,96)
         mat(k,76) = rxt(k,472)
         mat(k,2098) = -( rxt(k,18) + rxt(k,19) + rxt(k,528) + het_rates(k,123) )
         mat(k,371) = rxt(k,10)
         mat(k,190) = rxt(k,13) + rxt(k,14) + rxt(k,218)
         mat(k,361) = .400_r8*rxt(k,61)
         mat(k,447) = rxt(k,78)
         mat(k,929) = rxt(k,95)
         mat(k,773) = -( rxt(k,58) + het_rates(k,124) )
         mat(k,227) = -( rxt(k,59) + het_rates(k,125) )
         mat(k,11) = -( het_rates(k,126) )
         mat(k,12) = -( het_rates(k,127) )
         mat(k,13) = -( het_rates(k,128) )
         mat(k,14) = -( het_rates(k,129) )
         mat(k,1492) = -( rxt(k,120) + rxt(k,121) + rxt(k,122) + rxt(k,123) + rxt(k,124) &
                      + rxt(k,125) + het_rates(k,130) )
         mat(k,2134) = rxt(k,2)
         mat(k,1405) = 2.000_r8*rxt(k,5) + rxt(k,6) + rxt(k,127) + rxt(k,128) + rxt(k,129) &
                      + rxt(k,131) + rxt(k,132) + rxt(k,133) + 2.000_r8*rxt(k,134) &
                      + 2.000_r8*rxt(k,135)
         mat(k,1873) = rxt(k,8)
         mat(k,186) = rxt(k,14)
         mat(k,1769) = rxt(k,15)
         mat(k,1811) = rxt(k,17)
         mat(k,2088) = rxt(k,18)
         mat(k,1451) = rxt(k,76)
         mat(k,1935) = rxt(k,94)
         mat(k,240) = rxt(k,108)
         mat(k,1296) = rxt(k,138)
         mat(k,915) = rxt(k,139)
         mat(k,175) = rxt(k,140)
         mat(k,1666) = rxt(k,160)
         mat(k,1402) = -( rxt(k,5) + rxt(k,6) + rxt(k,126) + rxt(k,127) + rxt(k,128) &
                      + rxt(k,129) + rxt(k,130) + rxt(k,131) + rxt(k,132) + rxt(k,133) &
                      + rxt(k,134) + rxt(k,135) + het_rates(k,131) )
         mat(k,1870) = rxt(k,8)
         mat(k,2085) = rxt(k,19)
         mat(k,78) = rxt(k,153) + rxt(k,164)
         mat(k,81) = rxt(k,154)
         mat(k,1663) = rxt(k,212)*y(k,111)
         mat(k,1879) = -( rxt(k,7) + rxt(k,8) + het_rates(k,132) )
         mat(k,237) = -( rxt(k,108) + het_rates(k,134) )
         mat(k,261) = -( rxt(k,137) + het_rates(k,135) )
         mat(k,72) = -( rxt(k,60) + het_rates(k,136) )
         mat(k,355) = -( rxt(k,61) + rxt(k,348) + het_rates(k,137) )
         mat(k,74) = -( rxt(k,472) + het_rates(k,138) )
         mat(k,362) = -( het_rates(k,139) )
         mat(k,182) = rxt(k,32)
         mat(k,97) = -( het_rates(k,140) )
         mat(k,242) = -( rxt(k,62) + het_rates(k,141) )
         mat(k,15) = -( het_rates(k,142) )
         mat(k,16) = -( het_rates(k,143) )
         mat(k,432) = -( rxt(k,63) + het_rates(k,144) )
         mat(k,295) = -( rxt(k,64) + het_rates(k,145) )
         mat(k,595) = -( het_rates(k,146) )
         mat(k,262) = rxt(k,137)
         mat(k,1290) = rxt(k,138)
         mat(k,1292) = -( rxt(k,138) + het_rates(k,148) )
         mat(k,914) = rxt(k,139)
         mat(k,913) = -( rxt(k,139) + het_rates(k,149) )
         mat(k,174) = rxt(k,140)
         mat(k,173) = -( rxt(k,140) + het_rates(k,150) )
         mat(k,67) = rxt(k,136)
         mat(k,17) = -( het_rates(k,151) )
         mat(k,18) = -( het_rates(k,152) )
         mat(k,19) = -( het_rates(k,153) )
         mat(k,20) = -( rxt(k,143) + het_rates(k,154) )
         mat(k,21) = -( rxt(k,144) + het_rates(k,155) )
         mat(k,22) = -( rxt(k,145) + het_rates(k,156) )
         mat(k,23) = -( rxt(k,146) + het_rates(k,157) )
         mat(k,24) = -( rxt(k,147) + het_rates(k,158) )
         mat(k,25) = -( rxt(k,148) + het_rates(k,159) )
         mat(k,26) = -( rxt(k,149) + het_rates(k,160) )
         mat(k,27) = -( rxt(k,150) + het_rates(k,161) )
         mat(k,28) = -( rxt(k,151) + het_rates(k,162) )
         mat(k,29) = -( rxt(k,152) + het_rates(k,163) )
         mat(k,30) = -( het_rates(k,164) )
         mat(k,801) = rxt(k,522)
         mat(k,31) = -( het_rates(k,165) )
         mat(k,32) = -( het_rates(k,166) )
         mat(k,33) = -( het_rates(k,167) )
         mat(k,34) = -( het_rates(k,168) )
         mat(k,46) = -( het_rates(k,169) )
         mat(k,125) = -( rxt(k,65) + het_rates(k,170) )
         mat(k,484) = -( rxt(k,66) + het_rates(k,171) )
         mat(k,415) = -( rxt(k,67) + het_rates(k,172) )
         mat(k,373) = -( rxt(k,68) + het_rates(k,173) )
         mat(k,882) = -( rxt(k,69) + het_rates(k,174) )
         mat(k,228) = rxt(k,59)
         mat(k,416) = rxt(k,67)
         mat(k,375) = rxt(k,68)
         mat(k,967) = -( rxt(k,70) + het_rates(k,175) )
         mat(k,486) = rxt(k,66)
         mat(k,884) = rxt(k,69)
         mat(k,495) = -( rxt(k,71) + het_rates(k,176) )
         mat(k,113) = -( het_rates(k,177) )
         mat(k,129) = -( rxt(k,72) + het_rates(k,178) )
         mat(k,142) = -( het_rates(k,179) )
         mat(k,584) = -( rxt(k,73) + het_rates(k,180) )
         mat(k,150) = -( het_rates(k,181) )
         mat(k,313) = -( rxt(k,74) + het_rates(k,182) )
         mat(k,421) = -( het_rates(k,185) )
         mat(k,75) = rxt(k,472)
         mat(k,895) = -( het_rates(k,186) )
         mat(k,382) = -( het_rates(k,187) )
         mat(k,321) = -( het_rates(k,188) )
         mat(k,809) = -( het_rates(k,189) )
         mat(k,412) = rxt(k,53)
         mat(k,723) = -( het_rates(k,190) )
         mat(k,524) = -( het_rates(k,191) )
         mat(k,1276) = -( het_rates(k,192) )
         mat(k,287) = .130_r8*rxt(k,24)
         mat(k,235) = rxt(k,28)
         mat(k,908) = rxt(k,36)
         mat(k,1125) = rxt(k,37)
         mat(k,1016) = .330_r8*rxt(k,46)
         mat(k,1029) = rxt(k,48)
         mat(k,1116) = 1.340_r8*rxt(k,51)
         mat(k,413) = rxt(k,53)
         mat(k,220) = rxt(k,54)
         mat(k,1225) = .300_r8*rxt(k,56)
         mat(k,775) = rxt(k,58)
         mat(k,356) = .600_r8*rxt(k,61) + rxt(k,348)
         mat(k,297) = rxt(k,64)
         mat(k,127) = .500_r8*rxt(k,65)
         mat(k,970) = .650_r8*rxt(k,70)
         mat(k,1371) = -( het_rates(k,193) )
         mat(k,1049) = rxt(k,35)
         mat(k,909) = rxt(k,36)
         mat(k,406) = rxt(k,38)
         mat(k,1226) = .300_r8*rxt(k,56)
         mat(k,357) = .400_r8*rxt(k,61)
         mat(k,1662) = rxt(k,155)*y(k,53)
         mat(k,1904) = rxt(k,220)*y(k,53)
         mat(k,660) = rxt(k,276)*y(k,53)
         mat(k,1636) = rxt(k,309)*y(k,53)
      end do
      end subroutine linmat02
      subroutine linmat03( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,640) = -( het_rates(k,194) )
         mat(k,198) = .600_r8*rxt(k,26)
         mat(k,696) = -( het_rates(k,195) )
         mat(k,1731) = rxt(k,16)
         mat(k,738) = rxt(k,111)
         mat(k,1477) = rxt(k,120) + rxt(k,121) + rxt(k,122) + rxt(k,123) + rxt(k,124) &
                      + rxt(k,125)
         mat(k,1395) = rxt(k,126) + rxt(k,127) + rxt(k,128) + rxt(k,129) + rxt(k,130) &
                      + rxt(k,131) + rxt(k,132) + rxt(k,133)
         mat(k,468) = -( het_rates(k,196) )
         mat(k,343) = -( rxt(k,341) + het_rates(k,197) )
         mat(k,64) = rxt(k,43)
         mat(k,668) = -( het_rates(k,198) )
         mat(k,2039) = -( rxt(k,523) + het_rates(k,199) )
         mat(k,370) = rxt(k,11) + rxt(k,217)
         mat(k,563) = rxt(k,20)
         mat(k,540) = .900_r8*rxt(k,21)
         mat(k,282) = rxt(k,22)
         mat(k,96) = 1.500_r8*rxt(k,23)
         mat(k,288) = .560_r8*rxt(k,24)
         mat(k,342) = rxt(k,25)
         mat(k,199) = .600_r8*rxt(k,26)
         mat(k,521) = .600_r8*rxt(k,27)
         mat(k,236) = rxt(k,28)
         mat(k,252) = rxt(k,29)
         mat(k,257) = rxt(k,30)
         mat(k,305) = rxt(k,31)
         mat(k,1052) = rxt(k,35)
         mat(k,1128) = rxt(k,37)
         mat(k,990) = 2.000_r8*rxt(k,44)
         mat(k,805) = 2.000_r8*rxt(k,45)
         mat(k,1021) = .670_r8*rxt(k,46)
         mat(k,162) = rxt(k,47)
         mat(k,1032) = rxt(k,48)
         mat(k,294) = rxt(k,49)
         mat(k,579) = rxt(k,50)
         mat(k,1120) = 1.340_r8*rxt(k,51) + .660_r8*rxt(k,52)
         mat(k,756) = rxt(k,57)
         mat(k,246) = rxt(k,62)
         mat(k,438) = rxt(k,63)
         mat(k,128) = rxt(k,65)
         mat(k,492) = rxt(k,66)
         mat(k,419) = rxt(k,67)
         mat(k,379) = rxt(k,68)
         mat(k,888) = rxt(k,69)
         mat(k,974) = 1.200_r8*rxt(k,70)
         mat(k,503) = rxt(k,71)
         mat(k,594) = rxt(k,73)
         mat(k,318) = rxt(k,74)
         mat(k,332) = rxt(k,314)
         mat(k,347) = rxt(k,341)
         mat(k,1162) = rxt(k,415)
         mat(k,1675) = rxt(k,156)*y(k,53)
         mat(k,1917) = rxt(k,284)*y(k,42) + rxt(k,287)*y(k,45)
         mat(k,1649) = rxt(k,285)*y(k,42) + rxt(k,288)*y(k,45)
         mat(k,327) = -( rxt(k,314) + het_rates(k,200) )
         mat(k,1178) = -( het_rates(k,201) )
         mat(k,1150) = -( rxt(k,415) + het_rates(k,202) )
         mat(k,1203) = -( het_rates(k,203) )
         mat(k,602) = -( het_rates(k,204) )
         mat(k,341) = .600_r8*rxt(k,25)
         mat(k,1243) = -( het_rates(k,205) )
         mat(k,1115) = .660_r8*rxt(k,51)
         mat(k,478) = rxt(k,55) + rxt(k,397)
         mat(k,977) = -( het_rates(k,206) )
         mat(k,519) = .600_r8*rxt(k,27)
         mat(k,565) = -( het_rates(k,207) )
         mat(k,427) = -( het_rates(k,208) )
         mat(k,543) = -( het_rates(k,209) )
         mat(k,685) = -( het_rates(k,210) )
         mat(k,1730) = rxt(k,16)
         mat(k,677) = rxt(k,570)
         mat(k,513) = rxt(k,573)
         mat(k,389) = -( het_rates(k,211) )
         mat(k,734) = rxt(k,111)
         mat(k,955) = -( het_rates(k,212) )
         mat(k,1668) = -( rxt(k,160) + rxt(k,155)*y(k,53) + rxt(k,156)*y(k,53) &
                      + rxt(k,157)*y(k,53) + rxt(k,211)*y(k,111) + rxt(k,212)*y(k,111) &
                      + rxt(k,244)*y(k,32) + rxt(k,245)*y(k,33) + rxt(k,246)*y(k,35) &
                      + rxt(k,247)*y(k,36) + rxt(k,248)*y(k,37) + rxt(k,249)*y(k,38) &
                      + rxt(k,250)*y(k,39) + rxt(k,271)*y(k,34) + rxt(k,272)*y(k,54) &
                      + rxt(k,273)*y(k,76) + rxt(k,294)*y(k,40) + rxt(k,295)*y(k,42) &
                      + rxt(k,296)*y(k,80) + rxt(k,297)*y(k,81) + rxt(k,298)*y(k,82) &
                 + het_rates(k,213) )
         mat(k,2136) = rxt(k,1)
         mat(k,1407) = rxt(k,6)
         mat(k,1875) = rxt(k,7)
         mat(k,77) = -( rxt(k,153) + rxt(k,164) + het_rates(k,214) )
         mat(k,1829) = rxt(k,7)
         mat(k,79) = rxt(k,168) + rxt(k,167)*y(k,62)
         mat(k,80) = -( rxt(k,154) + rxt(k,168) + rxt(k,167)*y(k,62) + het_rates(k,215) )
         mat(k,676) = -( rxt(k,570) + het_rates(k,216) )
         mat(k,1393) = rxt(k,126) + rxt(k,130)
         mat(k,512) = rxt(k,572)*y(k,62)
         mat(k,1641) = -( rxt(k,283)*y(k,40) + rxt(k,285)*y(k,42) + rxt(k,286)*y(k,43) &
                      + rxt(k,288)*y(k,45) + rxt(k,290)*y(k,54) + rxt(k,291)*y(k,80) &
                      + rxt(k,292)*y(k,81) + rxt(k,293)*y(k,82) + rxt(k,309)*y(k,53) &
                 + het_rates(k,217) )
         mat(k,2135) = rxt(k,3)
         mat(k,507) = 2.000_r8*rxt(k,4)
         mat(k,1689) = rxt(k,9)
         mat(k,368) = rxt(k,10)
         mat(k,539) = rxt(k,21)
         mat(k,281) = rxt(k,22)
         mat(k,251) = rxt(k,29)
         mat(k,256) = rxt(k,30)
         mat(k,304) = rxt(k,31)
         mat(k,184) = rxt(k,32)
         mat(k,408) = rxt(k,38)
         mat(k,310) = rxt(k,39)
         mat(k,65) = rxt(k,43)
         mat(k,161) = rxt(k,47)
         mat(k,221) = rxt(k,54)
         mat(k,230) = rxt(k,59)
         mat(k,245) = rxt(k,62)
         mat(k,437) = rxt(k,63)
         mat(k,299) = rxt(k,64)
         mat(k,491) = rxt(k,66)
         mat(k,378) = rxt(k,68)
         mat(k,502) = rxt(k,71)
         mat(k,131) = rxt(k,72)
         mat(k,593) = rxt(k,73)
         mat(k,317) = rxt(k,74)
         mat(k,654) = rxt(k,106)
         mat(k,769) = rxt(k,107)
         mat(k,1812) = .500_r8*rxt(k,527)
         mat(k,1667) = rxt(k,155)*y(k,53)
         mat(k,511) = -( rxt(k,573) + rxt(k,572)*y(k,62) + het_rates(k,218) )
         mat(k,1471) = rxt(k,120) + rxt(k,121) + rxt(k,122) + rxt(k,123) + rxt(k,124) &
                      + rxt(k,125)
         mat(k,1390) = rxt(k,127) + rxt(k,128) + rxt(k,129) + rxt(k,131) + rxt(k,132) &
                      + rxt(k,133)
         mat(k,334) = -( het_rates(k,219) )
         mat(k,712) = -( het_rates(k,220) )
         mat(k,1036) = -( het_rates(k,221) )
         mat(k,969) = .150_r8*rxt(k,70)
         mat(k,997) = -( het_rates(k,222) )
         mat(k,873) = -( het_rates(k,223) )
         mat(k,613) = -( het_rates(k,224) )
         mat(k,1075) = -( het_rates(k,225) )
         mat(k,629) = -( het_rates(k,226) )
         mat(k,397) = -( het_rates(k,227) )
         mat(k,2146) = -( rxt(k,1) + rxt(k,2) + rxt(k,3) + het_rates(k,228) )
         mat(k,68) = rxt(k,136)
         mat(k,1652) = rxt(k,283)*y(k,40) + rxt(k,285)*y(k,42) + rxt(k,286)*y(k,43) &
                      + rxt(k,288)*y(k,45) + rxt(k,293)*y(k,82) + rxt(k,309)*y(k,53)
      end do
      end subroutine linmat03
      subroutine linmat( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
      call linmat01( avec_len, mat, y, rxt, het_rates )
      call linmat02( avec_len, mat, y, rxt, het_rates )
      call linmat03( avec_len, mat, y, rxt, het_rates )
      end subroutine linmat
      end module mo_lin_matrix
