      module mo_nln_matrix
      use shr_kind_mod, only : r8 => shr_kind_r8
      use chem_mods, only: veclen
      private
      public :: nlnmat
      contains
      subroutine nlnmat01( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,554) = -(rxt(k,398)*y(k,217))
         mat(k,1580) = -rxt(k,398)*y(k,1)
         mat(k,1722) = rxt(k,401)*y(k,186)
         mat(k,892) = rxt(k,401)*y(k,121)
         mat(k,531) = -(rxt(k,402)*y(k,217))
         mat(k,1579) = -rxt(k,402)*y(k,2)
         mat(k,891) = rxt(k,399)*y(k,199)
         mat(k,1982) = rxt(k,399)*y(k,186)
         mat(k,853) = -(rxt(k,481)*y(k,123) + rxt(k,482)*y(k,132) + rxt(k,483) &
                      *y(k,217))
         mat(k,2055) = -rxt(k,481)*y(k,5)
         mat(k,1843) = -rxt(k,482)*y(k,5)
         mat(k,1604) = -rxt(k,483)*y(k,5)
         mat(k,87) = -(rxt(k,440)*y(k,217))
         mat(k,1518) = -rxt(k,440)*y(k,6)
         mat(k,277) = -(rxt(k,443)*y(k,217))
         mat(k,1548) = -rxt(k,443)*y(k,7)
         mat(k,380) = rxt(k,441)*y(k,199)
         mat(k,1957) = rxt(k,441)*y(k,187)
         mat(k,88) = .120_r8*rxt(k,440)*y(k,217)
         mat(k,1519) = .120_r8*rxt(k,440)*y(k,6)
         mat(k,850) = .100_r8*rxt(k,482)*y(k,132)
         mat(k,824) = .100_r8*rxt(k,485)*y(k,132)
         mat(k,1832) = .100_r8*rxt(k,482)*y(k,5) + .100_r8*rxt(k,485)*y(k,108)
         mat(k,1709) = .500_r8*rxt(k,442)*y(k,187) + .200_r8*rxt(k,469)*y(k,224) &
                      + .060_r8*rxt(k,475)*y(k,226)
         mat(k,381) = .500_r8*rxt(k,442)*y(k,121)
         mat(k,609) = .200_r8*rxt(k,469)*y(k,121)
         mat(k,625) = .060_r8*rxt(k,475)*y(k,121)
         mat(k,1703) = .200_r8*rxt(k,469)*y(k,224) + .200_r8*rxt(k,475)*y(k,226)
         mat(k,608) = .200_r8*rxt(k,469)*y(k,121)
         mat(k,623) = .200_r8*rxt(k,475)*y(k,121)
         mat(k,1720) = .200_r8*rxt(k,469)*y(k,224) + .150_r8*rxt(k,475)*y(k,226)
         mat(k,611) = .200_r8*rxt(k,469)*y(k,121)
         mat(k,626) = .150_r8*rxt(k,475)*y(k,121)
         mat(k,1704) = .210_r8*rxt(k,475)*y(k,226)
         mat(k,624) = .210_r8*rxt(k,475)*y(k,121)
         mat(k,163) = -(rxt(k,403)*y(k,217))
         mat(k,1530) = -rxt(k,403)*y(k,14)
         mat(k,849) = .050_r8*rxt(k,482)*y(k,132)
         mat(k,823) = .050_r8*rxt(k,485)*y(k,132)
         mat(k,1831) = .050_r8*rxt(k,482)*y(k,5) + .050_r8*rxt(k,485)*y(k,108)
         mat(k,269) = -(rxt(k,369)*y(k,123) + rxt(k,370)*y(k,217))
         mat(k,2048) = -rxt(k,369)*y(k,15)
         mat(k,1547) = -rxt(k,370)*y(k,15)
         mat(k,1326) = -(rxt(k,255)*y(k,41) + rxt(k,256)*y(k,199) + rxt(k,257) &
                      *y(k,132))
         mat(k,1422) = -rxt(k,255)*y(k,16)
         mat(k,2025) = -rxt(k,256)*y(k,16)
         mat(k,1868) = -rxt(k,257)*y(k,16)
         mat(k,1447) = 4.000_r8*rxt(k,258)*y(k,18) + (rxt(k,259)+rxt(k,260))*y(k,58) &
                      + rxt(k,263)*y(k,121) + rxt(k,266)*y(k,130) + rxt(k,508) &
                      *y(k,148) + rxt(k,267)*y(k,217)
         mat(k,1930) = (rxt(k,259)+rxt(k,260))*y(k,18)
         mat(k,758) = rxt(k,268)*y(k,130) + rxt(k,274)*y(k,213) + rxt(k,269)*y(k,217)
         mat(k,1764) = rxt(k,263)*y(k,18)
         mat(k,1487) = rxt(k,266)*y(k,18) + rxt(k,268)*y(k,79)
         mat(k,1293) = rxt(k,508)*y(k,18)
         mat(k,1661) = rxt(k,274)*y(k,79)
         mat(k,1635) = rxt(k,267)*y(k,18) + rxt(k,269)*y(k,79)
         mat(k,1440) = rxt(k,261)*y(k,58)
         mat(k,1923) = rxt(k,261)*y(k,18)
         mat(k,1307) = (rxt(k,551)+rxt(k,556))*y(k,89)
         mat(k,648) = (rxt(k,551)+rxt(k,556))*y(k,83)
         mat(k,1450) = -(4._r8*rxt(k,258)*y(k,18) + (rxt(k,259) + rxt(k,260) + rxt(k,261) &
                      ) * y(k,58) + rxt(k,262)*y(k,199) + rxt(k,263)*y(k,121) &
                      + rxt(k,264)*y(k,122) + rxt(k,266)*y(k,130) + rxt(k,267) &
                      *y(k,217) + rxt(k,508)*y(k,148))
         mat(k,1934) = -(rxt(k,259) + rxt(k,260) + rxt(k,261)) * y(k,18)
         mat(k,2029) = -rxt(k,262)*y(k,18)
         mat(k,1768) = -rxt(k,263)*y(k,18)
         mat(k,1810) = -rxt(k,264)*y(k,18)
         mat(k,1491) = -rxt(k,266)*y(k,18)
         mat(k,1639) = -rxt(k,267)*y(k,18)
         mat(k,1295) = -rxt(k,508)*y(k,18)
         mat(k,1329) = rxt(k,257)*y(k,132)
         mat(k,443) = rxt(k,265)*y(k,130)
         mat(k,759) = rxt(k,275)*y(k,213)
         mat(k,652) = rxt(k,270)*y(k,130)
         mat(k,1491) = mat(k,1491) + rxt(k,265)*y(k,19) + rxt(k,270)*y(k,89)
         mat(k,1872) = rxt(k,257)*y(k,16)
         mat(k,1665) = rxt(k,275)*y(k,79)
         mat(k,440) = -(rxt(k,265)*y(k,130))
         mat(k,1469) = -rxt(k,265)*y(k,19)
         mat(k,1442) = rxt(k,264)*y(k,122)
         mat(k,1788) = rxt(k,264)*y(k,18)
         mat(k,169) = -(rxt(k,444)*y(k,217))
         mat(k,1531) = -rxt(k,444)*y(k,21)
         mat(k,1702) = rxt(k,447)*y(k,188)
         mat(k,319) = rxt(k,447)*y(k,121)
         mat(k,248) = -(rxt(k,446)*y(k,217))
         mat(k,1543) = -rxt(k,446)*y(k,22)
         mat(k,320) = rxt(k,445)*y(k,199)
         mat(k,1955) = rxt(k,445)*y(k,188)
         mat(k,200) = -(rxt(k,318)*y(k,55) + rxt(k,319)*y(k,217))
         mat(k,1887) = -rxt(k,318)*y(k,23)
         mat(k,1536) = -rxt(k,319)*y(k,23)
         mat(k,448) = -(rxt(k,320)*y(k,55) + rxt(k,321)*y(k,132) + rxt(k,346)*y(k,217))
         mat(k,1889) = -rxt(k,320)*y(k,24)
         mat(k,1834) = -rxt(k,321)*y(k,24)
         mat(k,1569) = -rxt(k,346)*y(k,24)
         mat(k,177) = -(rxt(k,326)*y(k,217))
         mat(k,1533) = -rxt(k,326)*y(k,25)
         mat(k,806) = .800_r8*rxt(k,322)*y(k,189) + .200_r8*rxt(k,323)*y(k,193)
         mat(k,1337) = .200_r8*rxt(k,323)*y(k,189)
         mat(k,253) = -(rxt(k,327)*y(k,217))
         mat(k,1544) = -rxt(k,327)*y(k,26)
         mat(k,807) = rxt(k,324)*y(k,199)
         mat(k,1956) = rxt(k,324)*y(k,189)
         mat(k,206) = -(rxt(k,328)*y(k,55) + rxt(k,329)*y(k,217))
         mat(k,1888) = -rxt(k,328)*y(k,27)
         mat(k,1537) = -rxt(k,329)*y(k,27)
         mat(k,935) = -(rxt(k,349)*y(k,123) + rxt(k,350)*y(k,132) + rxt(k,367) &
                      *y(k,217))
         mat(k,2061) = -rxt(k,349)*y(k,28)
         mat(k,1849) = -rxt(k,350)*y(k,28)
         mat(k,1611) = -rxt(k,367)*y(k,28)
         mat(k,786) = .130_r8*rxt(k,427)*y(k,132)
         mat(k,1849) = mat(k,1849) + .130_r8*rxt(k,427)*y(k,96)
         mat(k,301) = -(rxt(k,354)*y(k,217))
         mat(k,1551) = -rxt(k,354)*y(k,29)
         mat(k,722) = rxt(k,352)*y(k,199)
         mat(k,1960) = rxt(k,352)*y(k,190)
         mat(k,56) = -(rxt(k,355)*y(k,217))
         mat(k,1514) = -rxt(k,355)*y(k,30)
         mat(k,181) = -(rxt(k,450)*y(k,217))
         mat(k,1534) = -rxt(k,450)*y(k,31)
         mat(k,522) = rxt(k,448)*y(k,199)
         mat(k,1950) = rxt(k,448)*y(k,191)
         mat(k,1425) = -(rxt(k,219)*y(k,55) + rxt(k,255)*y(k,16) + rxt(k,299)*y(k,199) &
                      + rxt(k,300)*y(k,123) + rxt(k,301)*y(k,130) + rxt(k,302) &
                      *y(k,217))
         mat(k,1906) = -rxt(k,219)*y(k,41)
         mat(k,1328) = -rxt(k,255)*y(k,41)
         mat(k,2028) = -rxt(k,299)*y(k,41)
         mat(k,2086) = -rxt(k,300)*y(k,41)
         mat(k,1490) = -rxt(k,301)*y(k,41)
         mat(k,1638) = -rxt(k,302)*y(k,41)
         mat(k,560) = .400_r8*rxt(k,398)*y(k,217)
         mat(k,864) = .340_r8*rxt(k,482)*y(k,132)
         mat(k,273) = .500_r8*rxt(k,369)*y(k,123)
         mat(k,452) = rxt(k,321)*y(k,132)
         mat(k,943) = .500_r8*rxt(k,350)*y(k,132)
         mat(k,407) = .500_r8*rxt(k,338)*y(k,217)
         mat(k,704) = rxt(k,307)*y(k,217)
         mat(k,309) = .300_r8*rxt(k,308)*y(k,217)
         mat(k,1933) = rxt(k,226)*y(k,193)
         mat(k,988) = .800_r8*rxt(k,343)*y(k,217)
         mat(k,795) = .910_r8*rxt(k,427)*y(k,132)
         mat(k,460) = .300_r8*rxt(k,418)*y(k,217)
         mat(k,1103) = .800_r8*rxt(k,422)*y(k,193)
         mat(k,1117) = .120_r8*rxt(k,380)*y(k,132)
         mat(k,479) = .500_r8*rxt(k,393)*y(k,217)
         mat(k,838) = .340_r8*rxt(k,485)*y(k,132)
         mat(k,1228) = .600_r8*rxt(k,394)*y(k,132)
         mat(k,1767) = .100_r8*rxt(k,400)*y(k,186) + rxt(k,306)*y(k,193) &
                      + .500_r8*rxt(k,371)*y(k,196) + .500_r8*rxt(k,340)*y(k,198) &
                      + .920_r8*rxt(k,410)*y(k,201) + .250_r8*rxt(k,378)*y(k,203) &
                      + rxt(k,387)*y(k,205) + rxt(k,361)*y(k,220) + rxt(k,365) &
                      *y(k,221) + .340_r8*rxt(k,494)*y(k,222) + .320_r8*rxt(k,499) &
                      *y(k,223) + .250_r8*rxt(k,435)*y(k,225)
         mat(k,2086) = mat(k,2086) + .500_r8*rxt(k,369)*y(k,15) + rxt(k,411)*y(k,201) &
                      + .250_r8*rxt(k,377)*y(k,203) + rxt(k,388)*y(k,205)
         mat(k,1871) = .340_r8*rxt(k,482)*y(k,5) + rxt(k,321)*y(k,24) &
                      + .500_r8*rxt(k,350)*y(k,28) + .910_r8*rxt(k,427)*y(k,96) &
                      + .120_r8*rxt(k,380)*y(k,103) + .340_r8*rxt(k,485)*y(k,108) &
                      + .600_r8*rxt(k,394)*y(k,109)
         mat(k,358) = rxt(k,345)*y(k,217)
         mat(k,972) = .680_r8*rxt(k,503)*y(k,217)
         mat(k,901) = .100_r8*rxt(k,400)*y(k,121)
         mat(k,813) = .700_r8*rxt(k,323)*y(k,193)
         mat(k,728) = rxt(k,351)*y(k,193)
         mat(k,1279) = rxt(k,334)*y(k,193) + rxt(k,407)*y(k,201) + .250_r8*rxt(k,374) &
                      *y(k,203) + rxt(k,383)*y(k,205) + .250_r8*rxt(k,432)*y(k,225)
         mat(k,1373) = rxt(k,226)*y(k,58) + .800_r8*rxt(k,422)*y(k,99) + rxt(k,306) &
                      *y(k,121) + .700_r8*rxt(k,323)*y(k,189) + rxt(k,351)*y(k,190) &
                      + rxt(k,334)*y(k,192) + (4.000_r8*rxt(k,303)+2.000_r8*rxt(k,304)) &
                      *y(k,193) + 1.500_r8*rxt(k,408)*y(k,201) + .750_r8*rxt(k,413) &
                      *y(k,202) + .880_r8*rxt(k,375)*y(k,203) + 2.000_r8*rxt(k,384) &
                      *y(k,205) + .750_r8*rxt(k,487)*y(k,212) + .800_r8*rxt(k,363) &
                      *y(k,221) + .930_r8*rxt(k,492)*y(k,222) + .950_r8*rxt(k,497) &
                      *y(k,223) + .800_r8*rxt(k,433)*y(k,225)
         mat(k,472) = .500_r8*rxt(k,371)*y(k,121)
         mat(k,671) = .500_r8*rxt(k,340)*y(k,121)
         mat(k,2028) = mat(k,2028) + .450_r8*rxt(k,385)*y(k,205) + .150_r8*rxt(k,364) &
                      *y(k,221)
         mat(k,1184) = .920_r8*rxt(k,410)*y(k,121) + rxt(k,411)*y(k,123) + rxt(k,407) &
                      *y(k,192) + 1.500_r8*rxt(k,408)*y(k,193)
         mat(k,1156) = .750_r8*rxt(k,413)*y(k,193)
         mat(k,1207) = .250_r8*rxt(k,378)*y(k,121) + .250_r8*rxt(k,377)*y(k,123) &
                      + .250_r8*rxt(k,374)*y(k,192) + .880_r8*rxt(k,375)*y(k,193)
         mat(k,1246) = rxt(k,387)*y(k,121) + rxt(k,388)*y(k,123) + rxt(k,383)*y(k,192) &
                      + 2.000_r8*rxt(k,384)*y(k,193) + .450_r8*rxt(k,385)*y(k,199) &
                      + 4.000_r8*rxt(k,386)*y(k,205)
         mat(k,960) = .750_r8*rxt(k,487)*y(k,193)
         mat(k,1638) = mat(k,1638) + .400_r8*rxt(k,398)*y(k,1) + .500_r8*rxt(k,338) &
                      *y(k,50) + rxt(k,307)*y(k,51) + .300_r8*rxt(k,308)*y(k,52) &
                      + .800_r8*rxt(k,343)*y(k,72) + .300_r8*rxt(k,418)*y(k,97) &
                      + .500_r8*rxt(k,393)*y(k,107) + rxt(k,345)*y(k,137) &
                      + .680_r8*rxt(k,503)*y(k,175)
         mat(k,716) = rxt(k,361)*y(k,121)
         mat(k,1040) = rxt(k,365)*y(k,121) + .800_r8*rxt(k,363)*y(k,193) &
                      + .150_r8*rxt(k,364)*y(k,199)
         mat(k,1002) = .340_r8*rxt(k,494)*y(k,121) + .930_r8*rxt(k,492)*y(k,193)
         mat(k,877) = .320_r8*rxt(k,499)*y(k,121) + .950_r8*rxt(k,497)*y(k,193)
         mat(k,1079) = .250_r8*rxt(k,435)*y(k,121) + .250_r8*rxt(k,432)*y(k,192) &
                      + .800_r8*rxt(k,433)*y(k,193)
      end do
      end subroutine nlnmat01
      subroutine nlnmat02( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,1047) = -(rxt(k,330)*y(k,123) + rxt(k,331)*y(k,217))
         mat(k,2071) = -rxt(k,330)*y(k,44)
         mat(k,1621) = -rxt(k,331)*y(k,44)
         mat(k,558) = .800_r8*rxt(k,398)*y(k,217)
         mat(k,272) = rxt(k,369)*y(k,123)
         mat(k,178) = rxt(k,326)*y(k,217)
         mat(k,255) = .500_r8*rxt(k,327)*y(k,217)
         mat(k,938) = .500_r8*rxt(k,350)*y(k,132)
         mat(k,1220) = .100_r8*rxt(k,394)*y(k,132)
         mat(k,1753) = .400_r8*rxt(k,400)*y(k,186) + rxt(k,325)*y(k,189) &
                      + .270_r8*rxt(k,353)*y(k,190) + rxt(k,371)*y(k,196) + rxt(k,390) &
                      *y(k,207) + rxt(k,361)*y(k,220)
         mat(k,2071) = mat(k,2071) + rxt(k,369)*y(k,15)
         mat(k,1857) = .500_r8*rxt(k,350)*y(k,28) + .100_r8*rxt(k,394)*y(k,109)
         mat(k,897) = .400_r8*rxt(k,400)*y(k,121)
         mat(k,810) = rxt(k,325)*y(k,121) + 3.200_r8*rxt(k,322)*y(k,189) &
                      + .800_r8*rxt(k,323)*y(k,193)
         mat(k,725) = .270_r8*rxt(k,353)*y(k,121)
         mat(k,1360) = .800_r8*rxt(k,323)*y(k,189)
         mat(k,471) = rxt(k,371)*y(k,121)
         mat(k,2012) = .200_r8*rxt(k,389)*y(k,207)
         mat(k,566) = rxt(k,390)*y(k,121) + .200_r8*rxt(k,389)*y(k,199)
         mat(k,1621) = mat(k,1621) + .800_r8*rxt(k,398)*y(k,1) + rxt(k,326)*y(k,25) &
                      + .500_r8*rxt(k,327)*y(k,26)
         mat(k,714) = rxt(k,361)*y(k,121)
         mat(k,53) = -(rxt(k,332)*y(k,217))
         mat(k,1513) = -rxt(k,332)*y(k,46)
         mat(k,906) = -(rxt(k,368)*y(k,217))
         mat(k,1608) = -rxt(k,368)*y(k,47)
         mat(k,557) = .800_r8*rxt(k,398)*y(k,217)
         mat(k,857) = .520_r8*rxt(k,482)*y(k,132)
         mat(k,271) = .500_r8*rxt(k,369)*y(k,123)
         mat(k,831) = .520_r8*rxt(k,485)*y(k,132)
         mat(k,1743) = .250_r8*rxt(k,400)*y(k,186) + .820_r8*rxt(k,353)*y(k,190) &
                      + .500_r8*rxt(k,371)*y(k,196) + .270_r8*rxt(k,494)*y(k,222) &
                      + .040_r8*rxt(k,499)*y(k,223)
         mat(k,2059) = .500_r8*rxt(k,369)*y(k,15)
         mat(k,1847) = .520_r8*rxt(k,482)*y(k,5) + .520_r8*rxt(k,485)*y(k,108)
         mat(k,966) = .500_r8*rxt(k,503)*y(k,217)
         mat(k,896) = .250_r8*rxt(k,400)*y(k,121)
         mat(k,724) = .820_r8*rxt(k,353)*y(k,121) + .820_r8*rxt(k,351)*y(k,193)
         mat(k,1351) = .820_r8*rxt(k,351)*y(k,190) + .150_r8*rxt(k,492)*y(k,222) &
                      + .025_r8*rxt(k,497)*y(k,223)
         mat(k,469) = .500_r8*rxt(k,371)*y(k,121)
         mat(k,1608) = mat(k,1608) + .800_r8*rxt(k,398)*y(k,1) + .500_r8*rxt(k,503) &
                      *y(k,175)
         mat(k,994) = .270_r8*rxt(k,494)*y(k,121) + .150_r8*rxt(k,492)*y(k,193)
         mat(k,875) = .040_r8*rxt(k,499)*y(k,121) + .025_r8*rxt(k,497)*y(k,193)
         mat(k,1124) = -(rxt(k,356)*y(k,123) + rxt(k,357)*y(k,217))
         mat(k,2075) = -rxt(k,356)*y(k,48)
         mat(k,1626) = -rxt(k,357)*y(k,48)
         mat(k,1028) = rxt(k,358)*y(k,217)
         mat(k,1113) = .880_r8*rxt(k,380)*y(k,132)
         mat(k,1221) = .500_r8*rxt(k,394)*y(k,132)
         mat(k,1757) = .170_r8*rxt(k,453)*y(k,194) + .050_r8*rxt(k,416)*y(k,202) &
                      + .250_r8*rxt(k,378)*y(k,203) + .170_r8*rxt(k,459)*y(k,206) &
                      + .400_r8*rxt(k,469)*y(k,224) + .250_r8*rxt(k,435)*y(k,225) &
                      + .540_r8*rxt(k,475)*y(k,226) + .510_r8*rxt(k,478)*y(k,227)
         mat(k,2075) = mat(k,2075) + .050_r8*rxt(k,417)*y(k,202) + .250_r8*rxt(k,377) &
                      *y(k,203) + .250_r8*rxt(k,436)*y(k,225)
         mat(k,774) = rxt(k,359)*y(k,217)
         mat(k,1860) = .880_r8*rxt(k,380)*y(k,103) + .500_r8*rxt(k,394)*y(k,109)
         mat(k,1270) = .250_r8*rxt(k,374)*y(k,203) + .250_r8*rxt(k,432)*y(k,225)
         mat(k,1364) = .240_r8*rxt(k,375)*y(k,203) + .500_r8*rxt(k,363)*y(k,221) &
                      + .100_r8*rxt(k,433)*y(k,225)
         mat(k,642) = .170_r8*rxt(k,453)*y(k,121) + .070_r8*rxt(k,452)*y(k,199)
         mat(k,2017) = .070_r8*rxt(k,452)*y(k,194) + .070_r8*rxt(k,458)*y(k,206)
         mat(k,1149) = .050_r8*rxt(k,416)*y(k,121) + .050_r8*rxt(k,417)*y(k,123)
         mat(k,1202) = .250_r8*rxt(k,378)*y(k,121) + .250_r8*rxt(k,377)*y(k,123) &
                      + .250_r8*rxt(k,374)*y(k,192) + .240_r8*rxt(k,375)*y(k,193)
         mat(k,979) = .170_r8*rxt(k,459)*y(k,121) + .070_r8*rxt(k,458)*y(k,199)
         mat(k,1626) = mat(k,1626) + rxt(k,358)*y(k,93) + rxt(k,359)*y(k,124)
         mat(k,1037) = .500_r8*rxt(k,363)*y(k,193)
         mat(k,618) = .400_r8*rxt(k,469)*y(k,121)
         mat(k,1076) = .250_r8*rxt(k,435)*y(k,121) + .250_r8*rxt(k,436)*y(k,123) &
                      + .250_r8*rxt(k,432)*y(k,192) + .100_r8*rxt(k,433)*y(k,193)
         mat(k,634) = .540_r8*rxt(k,475)*y(k,121)
         mat(k,399) = .510_r8*rxt(k,478)*y(k,121)
         mat(k,464) = -(rxt(k,337)*y(k,217))
         mat(k,1571) = -rxt(k,337)*y(k,49)
         mat(k,931) = .120_r8*rxt(k,350)*y(k,132)
         mat(k,1835) = .120_r8*rxt(k,350)*y(k,28)
         mat(k,1259) = .100_r8*rxt(k,334)*y(k,193) + .150_r8*rxt(k,335)*y(k,199)
         mat(k,1342) = .100_r8*rxt(k,334)*y(k,192)
         mat(k,1976) = .150_r8*rxt(k,335)*y(k,192) + .150_r8*rxt(k,385)*y(k,205)
         mat(k,1239) = .150_r8*rxt(k,385)*y(k,199)
         mat(k,404) = -(rxt(k,338)*y(k,217))
         mat(k,1564) = -rxt(k,338)*y(k,50)
         mat(k,1258) = .400_r8*rxt(k,335)*y(k,199)
         mat(k,1973) = .400_r8*rxt(k,335)*y(k,192) + .400_r8*rxt(k,385)*y(k,205)
         mat(k,1238) = .400_r8*rxt(k,385)*y(k,199)
         mat(k,703) = -(rxt(k,307)*y(k,217))
         mat(k,1591) = -rxt(k,307)*y(k,51)
         mat(k,1089) = .200_r8*rxt(k,422)*y(k,193)
         mat(k,808) = .300_r8*rxt(k,323)*y(k,193)
         mat(k,1343) = .200_r8*rxt(k,422)*y(k,99) + .300_r8*rxt(k,323)*y(k,189) &
                      + 2.000_r8*rxt(k,304)*y(k,193) + .250_r8*rxt(k,408)*y(k,201) &
                      + .250_r8*rxt(k,413)*y(k,202) + .250_r8*rxt(k,375)*y(k,203) &
                      + .250_r8*rxt(k,487)*y(k,212) + .500_r8*rxt(k,363)*y(k,221) &
                      + .250_r8*rxt(k,492)*y(k,222) + .250_r8*rxt(k,497)*y(k,223) &
                      + .300_r8*rxt(k,433)*y(k,225)
         mat(k,1168) = .250_r8*rxt(k,408)*y(k,193)
         mat(k,1137) = .250_r8*rxt(k,413)*y(k,193)
         mat(k,1195) = .250_r8*rxt(k,375)*y(k,193)
         mat(k,953) = .250_r8*rxt(k,487)*y(k,193)
         mat(k,1034) = .500_r8*rxt(k,363)*y(k,193)
         mat(k,993) = .250_r8*rxt(k,492)*y(k,193)
         mat(k,872) = .250_r8*rxt(k,497)*y(k,193)
         mat(k,1070) = .300_r8*rxt(k,433)*y(k,193)
         mat(k,307) = -(rxt(k,308)*y(k,217))
         mat(k,1552) = -rxt(k,308)*y(k,52)
         mat(k,1340) = rxt(k,305)*y(k,199)
         mat(k,1961) = rxt(k,305)*y(k,193)
         mat(k,1915) = -(rxt(k,219)*y(k,41) + rxt(k,221)*y(k,75) + rxt(k,222)*y(k,77) &
                      + (rxt(k,223) + rxt(k,224)) * y(k,199) + rxt(k,225)*y(k,132) &
                      + rxt(k,232)*y(k,59) + rxt(k,241)*y(k,90) + rxt(k,328)*y(k,27))
         mat(k,1434) = -rxt(k,219)*y(k,55)
         mat(k,1065) = -rxt(k,221)*y(k,55)
         mat(k,508) = -rxt(k,222)*y(k,55)
         mat(k,2037) = -(rxt(k,223) + rxt(k,224)) * y(k,55)
         mat(k,1880) = -rxt(k,225)*y(k,55)
         mat(k,927) = -rxt(k,232)*y(k,55)
         mat(k,770) = -rxt(k,241)*y(k,55)
         mat(k,210) = -rxt(k,328)*y(k,55)
         mat(k,1458) = rxt(k,260)*y(k,58)
         mat(k,1942) = rxt(k,260)*y(k,18) + (4.000_r8*rxt(k,227)+2.000_r8*rxt(k,229)) &
                      *y(k,58) + rxt(k,231)*y(k,121) + rxt(k,236)*y(k,130) &
                      + rxt(k,509)*y(k,148) + rxt(k,226)*y(k,193) + rxt(k,237) &
                      *y(k,217)
         mat(k,135) = rxt(k,281)*y(k,213)
         mat(k,1319) = rxt(k,239)*y(k,130) + rxt(k,251)*y(k,213) + rxt(k,240)*y(k,217)
         mat(k,1776) = rxt(k,231)*y(k,58)
         mat(k,1499) = rxt(k,236)*y(k,58) + rxt(k,239)*y(k,83)
         mat(k,1301) = rxt(k,509)*y(k,58)
         mat(k,1379) = rxt(k,226)*y(k,58)
         mat(k,1673) = rxt(k,281)*y(k,64) + rxt(k,251)*y(k,83)
         mat(k,1647) = rxt(k,237)*y(k,58) + rxt(k,240)*y(k,83)
         mat(k,1886) = rxt(k,232)*y(k,59)
         mat(k,1922) = 2.000_r8*rxt(k,228)*y(k,58)
         mat(k,919) = rxt(k,232)*y(k,55) + (rxt(k,549)+rxt(k,554)+rxt(k,559))*y(k,83)
         mat(k,1306) = (rxt(k,549)+rxt(k,554)+rxt(k,559))*y(k,59) + (rxt(k,544) &
                       +rxt(k,550)+rxt(k,555))*y(k,90)
         mat(k,765) = (rxt(k,544)+rxt(k,550)+rxt(k,555))*y(k,83)
         mat(k,1921) = 2.000_r8*rxt(k,253)*y(k,58)
         mat(k,1943) = -(rxt(k,226)*y(k,193) + (4._r8*rxt(k,227) + 4._r8*rxt(k,228) &
                      + 4._r8*rxt(k,229) + 4._r8*rxt(k,253)) * y(k,58) + rxt(k,230) &
                      *y(k,199) + rxt(k,231)*y(k,121) + rxt(k,233)*y(k,122) + rxt(k,236) &
                      *y(k,130) + (rxt(k,237) + rxt(k,238)) * y(k,217) + (rxt(k,259) &
                      + rxt(k,260) + rxt(k,261)) * y(k,18) + rxt(k,509)*y(k,148))
         mat(k,1380) = -rxt(k,226)*y(k,58)
         mat(k,2038) = -rxt(k,230)*y(k,58)
         mat(k,1777) = -rxt(k,231)*y(k,58)
         mat(k,1819) = -rxt(k,233)*y(k,58)
         mat(k,1500) = -rxt(k,236)*y(k,58)
         mat(k,1648) = -(rxt(k,237) + rxt(k,238)) * y(k,58)
         mat(k,1459) = -(rxt(k,259) + rxt(k,260) + rxt(k,261)) * y(k,58)
         mat(k,1302) = -rxt(k,509)*y(k,58)
         mat(k,1916) = rxt(k,241)*y(k,90) + rxt(k,225)*y(k,132) + rxt(k,224)*y(k,199)
         mat(k,928) = rxt(k,234)*y(k,130)
         mat(k,1320) = rxt(k,252)*y(k,213)
         mat(k,771) = rxt(k,241)*y(k,55) + rxt(k,242)*y(k,130) + rxt(k,243)*y(k,217)
         mat(k,1500) = mat(k,1500) + rxt(k,234)*y(k,59) + rxt(k,242)*y(k,90)
         mat(k,1881) = rxt(k,225)*y(k,55)
         mat(k,241) = rxt(k,514)*y(k,148)
         mat(k,1302) = mat(k,1302) + rxt(k,514)*y(k,134)
         mat(k,2038) = mat(k,2038) + rxt(k,224)*y(k,55)
         mat(k,1674) = rxt(k,252)*y(k,83)
         mat(k,1648) = mat(k,1648) + rxt(k,243)*y(k,90)
         mat(k,921) = -(rxt(k,232)*y(k,55) + rxt(k,234)*y(k,130) + rxt(k,235)*y(k,217) &
                      + (rxt(k,549) + rxt(k,554) + rxt(k,559)) * y(k,83))
         mat(k,1896) = -rxt(k,232)*y(k,59)
         mat(k,1482) = -rxt(k,234)*y(k,59)
         mat(k,1610) = -rxt(k,235)*y(k,59)
         mat(k,1310) = -(rxt(k,549) + rxt(k,554) + rxt(k,559)) * y(k,59)
         mat(k,1927) = rxt(k,233)*y(k,122)
         mat(k,1797) = rxt(k,233)*y(k,58)
         mat(k,1023) = -((rxt(k,310) + rxt(k,317)) * y(k,217))
         mat(k,1618) = -(rxt(k,310) + rxt(k,317)) * y(k,61)
         mat(k,860) = .230_r8*rxt(k,482)*y(k,132)
         mat(k,1325) = rxt(k,255)*y(k,41)
         mat(k,203) = .350_r8*rxt(k,319)*y(k,217)
         mat(k,451) = .630_r8*rxt(k,321)*y(k,132)
         mat(k,936) = .560_r8*rxt(k,350)*y(k,132)
         mat(k,1419) = rxt(k,255)*y(k,16) + rxt(k,219)*y(k,55) + rxt(k,300)*y(k,123) &
                      + rxt(k,301)*y(k,130) + rxt(k,302)*y(k,217)
         mat(k,1123) = rxt(k,356)*y(k,123) + rxt(k,357)*y(k,217)
         mat(k,1898) = rxt(k,219)*y(k,41)
         mat(k,803) = rxt(k,344)*y(k,217)
         mat(k,787) = .620_r8*rxt(k,427)*y(k,132)
         mat(k,1111) = .650_r8*rxt(k,380)*y(k,132)
         mat(k,834) = .230_r8*rxt(k,485)*y(k,132)
         mat(k,1218) = .560_r8*rxt(k,394)*y(k,132)
         mat(k,1750) = .170_r8*rxt(k,453)*y(k,194) + .220_r8*rxt(k,378)*y(k,203) &
                      + .400_r8*rxt(k,456)*y(k,204) + .350_r8*rxt(k,459)*y(k,206) &
                      + .225_r8*rxt(k,494)*y(k,222) + .250_r8*rxt(k,435)*y(k,225)
         mat(k,2068) = rxt(k,300)*y(k,41) + rxt(k,356)*y(k,48) + .220_r8*rxt(k,377) &
                      *y(k,203) + .500_r8*rxt(k,436)*y(k,225)
         mat(k,1483) = rxt(k,301)*y(k,41) + rxt(k,504)*y(k,135)
         mat(k,1854) = .230_r8*rxt(k,482)*y(k,5) + .630_r8*rxt(k,321)*y(k,24) &
                      + .560_r8*rxt(k,350)*y(k,28) + .620_r8*rxt(k,427)*y(k,96) &
                      + .650_r8*rxt(k,380)*y(k,103) + .230_r8*rxt(k,485)*y(k,108) &
                      + .560_r8*rxt(k,394)*y(k,109)
         mat(k,264) = rxt(k,504)*y(k,130) + rxt(k,505)*y(k,217)
         mat(k,968) = .700_r8*rxt(k,503)*y(k,217)
         mat(k,1265) = .220_r8*rxt(k,374)*y(k,203) + .250_r8*rxt(k,432)*y(k,225)
         mat(k,1357) = .110_r8*rxt(k,375)*y(k,203) + .125_r8*rxt(k,492)*y(k,222) &
                      + .200_r8*rxt(k,433)*y(k,225)
         mat(k,641) = .170_r8*rxt(k,453)*y(k,121) + .070_r8*rxt(k,452)*y(k,199)
         mat(k,2009) = .070_r8*rxt(k,452)*y(k,194) + .160_r8*rxt(k,455)*y(k,204) &
                      + .140_r8*rxt(k,458)*y(k,206)
         mat(k,1198) = .220_r8*rxt(k,378)*y(k,121) + .220_r8*rxt(k,377)*y(k,123) &
                      + .220_r8*rxt(k,374)*y(k,192) + .110_r8*rxt(k,375)*y(k,193)
         mat(k,604) = .400_r8*rxt(k,456)*y(k,121) + .160_r8*rxt(k,455)*y(k,199)
         mat(k,978) = .350_r8*rxt(k,459)*y(k,121) + .140_r8*rxt(k,458)*y(k,199)
         mat(k,1618) = mat(k,1618) + .350_r8*rxt(k,319)*y(k,23) + rxt(k,302)*y(k,41) &
                      + rxt(k,357)*y(k,48) + rxt(k,344)*y(k,73) + rxt(k,505)*y(k,135) &
                      + .700_r8*rxt(k,503)*y(k,175)
         mat(k,998) = .225_r8*rxt(k,494)*y(k,121) + .125_r8*rxt(k,492)*y(k,193)
         mat(k,1073) = .250_r8*rxt(k,435)*y(k,121) + .500_r8*rxt(k,436)*y(k,123) &
                      + .250_r8*rxt(k,432)*y(k,192) + .200_r8*rxt(k,433)*y(k,193)
      end do
      end subroutine nlnmat02
      subroutine nlnmat03( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,60) = -(rxt(k,280)*y(k,213))
         mat(k,1653) = -rxt(k,280)*y(k,63)
         mat(k,132) = -(rxt(k,281)*y(k,213))
         mat(k,1656) = -rxt(k,281)*y(k,64)
         mat(k,120) = -(rxt(k,451)*y(k,217))
         mat(k,1523) = -rxt(k,451)*y(k,65)
         mat(k,114) = .180_r8*rxt(k,471)*y(k,217)
         mat(k,1523) = mat(k,1523) + .180_r8*rxt(k,471)*y(k,177)
         mat(k,191) = -(rxt(k,518)*y(k,123) + (rxt(k,519) + rxt(k,521)) * y(k,217))
         mat(k,2046) = -rxt(k,518)*y(k,66)
         mat(k,1535) = -(rxt(k,519) + rxt(k,521)) * y(k,66)
         mat(k,666) = rxt(k,339)*y(k,199)
         mat(k,1948) = rxt(k,339)*y(k,198)
         mat(k,658) = -(rxt(k,277)*y(k,75) + rxt(k,278)*y(k,228) + rxt(k,279)*y(k,87))
         mat(k,1057) = -rxt(k,277)*y(k,71)
         mat(k,2124) = -rxt(k,278)*y(k,71)
         mat(k,1680) = -rxt(k,279)*y(k,71)
         mat(k,61) = 2.000_r8*rxt(k,280)*y(k,213)
         mat(k,133) = rxt(k,281)*y(k,213)
         mat(k,1657) = 2.000_r8*rxt(k,280)*y(k,63) + rxt(k,281)*y(k,64)
         mat(k,986) = -(rxt(k,343)*y(k,217))
         mat(k,1615) = -rxt(k,343)*y(k,72)
         mat(k,457) = .700_r8*rxt(k,418)*y(k,217)
         mat(k,350) = .500_r8*rxt(k,419)*y(k,217)
         mat(k,224) = rxt(k,430)*y(k,217)
         mat(k,1747) = .050_r8*rxt(k,416)*y(k,202) + .530_r8*rxt(k,378)*y(k,203) &
                      + .225_r8*rxt(k,494)*y(k,222) + .250_r8*rxt(k,435)*y(k,225)
         mat(k,2065) = .050_r8*rxt(k,417)*y(k,202) + .530_r8*rxt(k,377)*y(k,203) &
                      + .250_r8*rxt(k,436)*y(k,225)
         mat(k,1398) = rxt(k,342)*y(k,197)
         mat(k,1264) = .530_r8*rxt(k,374)*y(k,203) + .250_r8*rxt(k,432)*y(k,225)
         mat(k,1355) = .260_r8*rxt(k,375)*y(k,203) + .125_r8*rxt(k,492)*y(k,222) &
                      + .100_r8*rxt(k,433)*y(k,225)
         mat(k,344) = rxt(k,342)*y(k,131)
         mat(k,1141) = .050_r8*rxt(k,416)*y(k,121) + .050_r8*rxt(k,417)*y(k,123)
         mat(k,1196) = .530_r8*rxt(k,378)*y(k,121) + .530_r8*rxt(k,377)*y(k,123) &
                      + .530_r8*rxt(k,374)*y(k,192) + .260_r8*rxt(k,375)*y(k,193)
         mat(k,1615) = mat(k,1615) + .700_r8*rxt(k,418)*y(k,97) + .500_r8*rxt(k,419) &
                      *y(k,98) + rxt(k,430)*y(k,113)
         mat(k,996) = .225_r8*rxt(k,494)*y(k,121) + .125_r8*rxt(k,492)*y(k,193)
         mat(k,1072) = .250_r8*rxt(k,435)*y(k,121) + .250_r8*rxt(k,436)*y(k,123) &
                      + .250_r8*rxt(k,432)*y(k,192) + .100_r8*rxt(k,433)*y(k,193)
         mat(k,802) = -(rxt(k,344)*y(k,217))
         mat(k,1601) = -rxt(k,344)*y(k,73)
         mat(k,202) = .650_r8*rxt(k,319)*y(k,217)
         mat(k,985) = .200_r8*rxt(k,343)*y(k,217)
         mat(k,751) = rxt(k,431)*y(k,217)
         mat(k,1738) = rxt(k,442)*y(k,187) + .050_r8*rxt(k,416)*y(k,202) &
                      + .400_r8*rxt(k,456)*y(k,204) + .170_r8*rxt(k,459)*y(k,206) &
                      + .700_r8*rxt(k,462)*y(k,219) + .600_r8*rxt(k,469)*y(k,224) &
                      + .250_r8*rxt(k,435)*y(k,225) + .340_r8*rxt(k,475)*y(k,226) &
                      + .170_r8*rxt(k,478)*y(k,227)
         mat(k,2053) = .050_r8*rxt(k,417)*y(k,202) + .250_r8*rxt(k,436)*y(k,225)
         mat(k,384) = rxt(k,442)*y(k,121)
         mat(k,1262) = .250_r8*rxt(k,432)*y(k,225)
         mat(k,1347) = .100_r8*rxt(k,433)*y(k,225)
         mat(k,1998) = .160_r8*rxt(k,455)*y(k,204) + .070_r8*rxt(k,458)*y(k,206)
         mat(k,1139) = .050_r8*rxt(k,416)*y(k,121) + .050_r8*rxt(k,417)*y(k,123)
         mat(k,603) = .400_r8*rxt(k,456)*y(k,121) + .160_r8*rxt(k,455)*y(k,199)
         mat(k,976) = .170_r8*rxt(k,459)*y(k,121) + .070_r8*rxt(k,458)*y(k,199)
         mat(k,1601) = mat(k,1601) + .650_r8*rxt(k,319)*y(k,23) + .200_r8*rxt(k,343) &
                      *y(k,72) + rxt(k,431)*y(k,114)
         mat(k,335) = .700_r8*rxt(k,462)*y(k,121)
         mat(k,615) = .600_r8*rxt(k,469)*y(k,121)
         mat(k,1071) = .250_r8*rxt(k,435)*y(k,121) + .250_r8*rxt(k,436)*y(k,123) &
                      + .250_r8*rxt(k,432)*y(k,192) + .100_r8*rxt(k,433)*y(k,193)
         mat(k,631) = .340_r8*rxt(k,475)*y(k,121)
         mat(k,398) = .170_r8*rxt(k,478)*y(k,121)
         mat(k,2119) = -((rxt(k,177) + rxt(k,178) + rxt(k,179)) * y(k,199) + rxt(k,180) &
                      *y(k,131) + rxt(k,183)*y(k,132))
         mat(k,2041) = -(rxt(k,177) + rxt(k,178) + rxt(k,179)) * y(k,74)
         mat(k,1414) = -rxt(k,180)*y(k,74)
         mat(k,1884) = -rxt(k,183)*y(k,74)
         mat(k,1438) = rxt(k,302)*y(k,217)
         mat(k,1919) = rxt(k,221)*y(k,75)
         mat(k,1026) = rxt(k,317)*y(k,217)
         mat(k,664) = rxt(k,277)*y(k,75)
         mat(k,1067) = rxt(k,221)*y(k,55) + rxt(k,277)*y(k,71) + rxt(k,175)*y(k,130) &
                      + rxt(k,158)*y(k,213) + rxt(k,184)*y(k,217)
         mat(k,763) = rxt(k,275)*y(k,213)
         mat(k,1322) = rxt(k,252)*y(k,213)
         mat(k,747) = rxt(k,207)*y(k,217)
         mat(k,1503) = rxt(k,175)*y(k,75) + rxt(k,187)*y(k,217)
         mat(k,268) = rxt(k,505)*y(k,217)
         mat(k,601) = rxt(k,510)*y(k,217)
         mat(k,1304) = rxt(k,515)*y(k,217)
         mat(k,1677) = rxt(k,158)*y(k,75) + rxt(k,275)*y(k,79) + rxt(k,252)*y(k,83)
         mat(k,1651) = rxt(k,302)*y(k,41) + rxt(k,317)*y(k,61) + rxt(k,184)*y(k,75) &
                      + rxt(k,207)*y(k,110) + rxt(k,187)*y(k,130) + rxt(k,505) &
                      *y(k,135) + rxt(k,510)*y(k,146) + rxt(k,515)*y(k,148)
         mat(k,1058) = -(rxt(k,158)*y(k,213) + rxt(k,175)*y(k,130) + rxt(k,184) &
                      *y(k,217) + rxt(k,221)*y(k,55) + rxt(k,277)*y(k,71))
         mat(k,1659) = -rxt(k,158)*y(k,75)
         mat(k,1484) = -rxt(k,175)*y(k,75)
         mat(k,1622) = -rxt(k,184)*y(k,75)
         mat(k,1900) = -rxt(k,221)*y(k,75)
         mat(k,659) = -rxt(k,277)*y(k,75)
         mat(k,2101) = rxt(k,177)*y(k,199)
         mat(k,2013) = rxt(k,177)*y(k,74)
         mat(k,504) = -(rxt(k,176)*y(k,130) + rxt(k,185)*y(k,217) + rxt(k,222)*y(k,55))
         mat(k,1470) = -rxt(k,176)*y(k,77)
         mat(k,1576) = -rxt(k,185)*y(k,77)
         mat(k,1890) = -rxt(k,222)*y(k,77)
         mat(k,1979) = 2.000_r8*rxt(k,191)*y(k,199)
         mat(k,1576) = mat(k,1576) + 2.000_r8*rxt(k,190)*y(k,217)
         mat(k,172) = rxt(k,517)*y(k,228)
         mat(k,2121) = rxt(k,517)*y(k,150)
         mat(k,757) = -(rxt(k,268)*y(k,130) + rxt(k,269)*y(k,217) + (rxt(k,274) &
                      + rxt(k,275)) * y(k,213))
         mat(k,1479) = -rxt(k,268)*y(k,79)
         mat(k,1597) = -rxt(k,269)*y(k,79)
         mat(k,1658) = -(rxt(k,274) + rxt(k,275)) * y(k,79)
         mat(k,1324) = rxt(k,255)*y(k,41) + rxt(k,256)*y(k,199)
         mat(k,1418) = rxt(k,255)*y(k,16)
         mat(k,1995) = rxt(k,256)*y(k,16)
         mat(k,1311) = -(rxt(k,239)*y(k,130) + rxt(k,240)*y(k,217) + (rxt(k,251) &
                      + rxt(k,252)) * y(k,213) + (rxt(k,544) + rxt(k,550) + rxt(k,555) &
                      ) * y(k,90) + (rxt(k,549) + rxt(k,554) + rxt(k,559)) * y(k,59) &
                      + (rxt(k,551) + rxt(k,556)) * y(k,89))
         mat(k,1486) = -rxt(k,239)*y(k,83)
         mat(k,1634) = -rxt(k,240)*y(k,83)
         mat(k,1660) = -(rxt(k,251) + rxt(k,252)) * y(k,83)
         mat(k,767) = -(rxt(k,544) + rxt(k,550) + rxt(k,555)) * y(k,83)
         mat(k,922) = -(rxt(k,549) + rxt(k,554) + rxt(k,559)) * y(k,83)
         mat(k,650) = -(rxt(k,551) + rxt(k,556)) * y(k,83)
         mat(k,208) = rxt(k,328)*y(k,55)
         mat(k,1421) = rxt(k,219)*y(k,55)
         mat(k,1902) = rxt(k,328)*y(k,27) + rxt(k,219)*y(k,41) + rxt(k,221)*y(k,75) &
                      + rxt(k,222)*y(k,77) + rxt(k,241)*y(k,90) + rxt(k,223)*y(k,199)
         mat(k,1929) = rxt(k,238)*y(k,217)
         mat(k,1059) = rxt(k,221)*y(k,55)
         mat(k,505) = rxt(k,222)*y(k,55)
         mat(k,767) = mat(k,767) + rxt(k,241)*y(k,55)
         mat(k,2024) = rxt(k,223)*y(k,55)
         mat(k,1634) = mat(k,1634) + rxt(k,238)*y(k,58)
         mat(k,104) = -(rxt(k,311)*y(k,217) + rxt(k,316)*y(k,213))
         mat(k,1521) = -rxt(k,311)*y(k,84)
         mat(k,1655) = -rxt(k,316)*y(k,84)
         mat(k,707) = -(rxt(k,312)*y(k,217))
         mat(k,1592) = -rxt(k,312)*y(k,85)
         mat(k,851) = .050_r8*rxt(k,482)*y(k,132)
         mat(k,201) = .350_r8*rxt(k,319)*y(k,217)
         mat(k,450) = .370_r8*rxt(k,321)*y(k,132)
         mat(k,932) = .120_r8*rxt(k,350)*y(k,132)
         mat(k,784) = .110_r8*rxt(k,427)*y(k,132)
         mat(k,1110) = .330_r8*rxt(k,380)*y(k,132)
         mat(k,825) = .050_r8*rxt(k,485)*y(k,132)
         mat(k,1216) = .120_r8*rxt(k,394)*y(k,132)
         mat(k,1732) = rxt(k,315)*y(k,200)
         mat(k,1839) = .050_r8*rxt(k,482)*y(k,5) + .370_r8*rxt(k,321)*y(k,24) &
                      + .120_r8*rxt(k,350)*y(k,28) + .110_r8*rxt(k,427)*y(k,96) &
                      + .330_r8*rxt(k,380)*y(k,103) + .050_r8*rxt(k,485)*y(k,108) &
                      + .120_r8*rxt(k,394)*y(k,109)
         mat(k,1992) = rxt(k,313)*y(k,200)
         mat(k,328) = rxt(k,315)*y(k,121) + rxt(k,313)*y(k,199)
         mat(k,1592) = mat(k,1592) + .350_r8*rxt(k,319)*y(k,23)
         mat(k,657) = rxt(k,277)*y(k,75) + rxt(k,279)*y(k,87) + rxt(k,278)*y(k,228)
         mat(k,1056) = rxt(k,277)*y(k,71)
         mat(k,1679) = rxt(k,279)*y(k,71)
         mat(k,2122) = rxt(k,278)*y(k,71)
         mat(k,1691) = -(rxt(k,216)*y(k,217) + rxt(k,279)*y(k,71))
         mat(k,1643) = -rxt(k,216)*y(k,87)
         mat(k,662) = -rxt(k,279)*y(k,87)
         mat(k,1430) = rxt(k,300)*y(k,123)
         mat(k,1051) = rxt(k,330)*y(k,123)
         mat(k,1127) = rxt(k,356)*y(k,123)
         mat(k,925) = (rxt(k,549)+rxt(k,554)+rxt(k,559))*y(k,83)
         mat(k,194) = rxt(k,518)*y(k,123)
         mat(k,1317) = (rxt(k,549)+rxt(k,554)+rxt(k,559))*y(k,59)
         mat(k,1814) = rxt(k,215)*y(k,217)
         mat(k,2091) = rxt(k,300)*y(k,41) + rxt(k,330)*y(k,44) + rxt(k,356)*y(k,48) &
                      + rxt(k,518)*y(k,66)
         mat(k,1643) = mat(k,1643) + rxt(k,215)*y(k,122)
         mat(k,366) = -(rxt(k,192)*y(k,217))
         mat(k,1560) = -rxt(k,192)*y(k,88)
         mat(k,1786) = rxt(k,213)*y(k,199)
         mat(k,1969) = rxt(k,213)*y(k,122)
         mat(k,649) = -(rxt(k,270)*y(k,130) + (rxt(k,551) + rxt(k,556)) * y(k,83))
         mat(k,1474) = -rxt(k,270)*y(k,89)
         mat(k,1308) = -(rxt(k,551) + rxt(k,556)) * y(k,89)
         mat(k,1443) = rxt(k,262)*y(k,199)
         mat(k,1990) = rxt(k,262)*y(k,18)
         mat(k,766) = -(rxt(k,241)*y(k,55) + rxt(k,242)*y(k,130) + rxt(k,243)*y(k,217) &
                      + (rxt(k,544) + rxt(k,550) + rxt(k,555)) * y(k,83))
         mat(k,1893) = -rxt(k,241)*y(k,90)
         mat(k,1480) = -rxt(k,242)*y(k,90)
         mat(k,1598) = -rxt(k,243)*y(k,90)
         mat(k,1309) = -(rxt(k,544) + rxt(k,550) + rxt(k,555)) * y(k,90)
         mat(k,1925) = rxt(k,230)*y(k,199)
         mat(k,920) = rxt(k,235)*y(k,217)
         mat(k,1996) = rxt(k,230)*y(k,58)
         mat(k,1598) = mat(k,1598) + rxt(k,235)*y(k,59)
         mat(k,1011) = -(rxt(k,373)*y(k,217))
         mat(k,1617) = -rxt(k,373)*y(k,91)
         mat(k,458) = .300_r8*rxt(k,418)*y(k,217)
         mat(k,351) = .500_r8*rxt(k,419)*y(k,217)
         mat(k,1749) = rxt(k,372)*y(k,196) + rxt(k,379)*y(k,203)
         mat(k,470) = rxt(k,372)*y(k,121)
         mat(k,1197) = rxt(k,379)*y(k,121)
         mat(k,1617) = mat(k,1617) + .300_r8*rxt(k,418)*y(k,97) + .500_r8*rxt(k,419) &
                      *y(k,98)
      end do
      end subroutine nlnmat03
      subroutine nlnmat04( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,158) = -(rxt(k,404)*y(k,217))
         mat(k,1529) = -rxt(k,404)*y(k,92)
         mat(k,1027) = -(rxt(k,358)*y(k,217))
         mat(k,1619) = -rxt(k,358)*y(k,93)
         mat(k,459) = .700_r8*rxt(k,418)*y(k,217)
         mat(k,352) = .500_r8*rxt(k,419)*y(k,217)
         mat(k,477) = .500_r8*rxt(k,393)*y(k,217)
         mat(k,1751) = .050_r8*rxt(k,416)*y(k,202) + .220_r8*rxt(k,378)*y(k,203) &
                      + .250_r8*rxt(k,435)*y(k,225)
         mat(k,2069) = .050_r8*rxt(k,417)*y(k,202) + .220_r8*rxt(k,377)*y(k,203) &
                      + .250_r8*rxt(k,436)*y(k,225)
         mat(k,434) = .500_r8*rxt(k,362)*y(k,217)
         mat(k,1266) = .220_r8*rxt(k,374)*y(k,203) + .250_r8*rxt(k,432)*y(k,225)
         mat(k,1358) = .230_r8*rxt(k,375)*y(k,203) + .200_r8*rxt(k,363)*y(k,221) &
                      + .100_r8*rxt(k,433)*y(k,225)
         mat(k,1144) = .050_r8*rxt(k,416)*y(k,121) + .050_r8*rxt(k,417)*y(k,123)
         mat(k,1199) = .220_r8*rxt(k,378)*y(k,121) + .220_r8*rxt(k,377)*y(k,123) &
                      + .220_r8*rxt(k,374)*y(k,192) + .230_r8*rxt(k,375)*y(k,193)
         mat(k,1619) = mat(k,1619) + .700_r8*rxt(k,418)*y(k,97) + .500_r8*rxt(k,419) &
                      *y(k,98) + .500_r8*rxt(k,393)*y(k,107) + .500_r8*rxt(k,362) &
                      *y(k,144)
         mat(k,1035) = .200_r8*rxt(k,363)*y(k,193)
         mat(k,1074) = .250_r8*rxt(k,435)*y(k,121) + .250_r8*rxt(k,436)*y(k,123) &
                      + .250_r8*rxt(k,432)*y(k,192) + .100_r8*rxt(k,433)*y(k,193)
         mat(k,258) = -(rxt(k,405)*y(k,217))
         mat(k,1545) = -rxt(k,405)*y(k,94)
         mat(k,1705) = .870_r8*rxt(k,416)*y(k,202)
         mat(k,2047) = .950_r8*rxt(k,417)*y(k,202)
         mat(k,1256) = rxt(k,412)*y(k,202)
         mat(k,1339) = .750_r8*rxt(k,413)*y(k,202)
         mat(k,1133) = .870_r8*rxt(k,416)*y(k,121) + .950_r8*rxt(k,417)*y(k,123) &
                      + rxt(k,412)*y(k,192) + .750_r8*rxt(k,413)*y(k,193)
         mat(k,69) = -(rxt(k,406)*y(k,217))
         mat(k,1516) = -rxt(k,406)*y(k,95)
         mat(k,572) = .600_r8*rxt(k,429)*y(k,217)
         mat(k,1516) = mat(k,1516) + .600_r8*rxt(k,429)*y(k,101)
         mat(k,785) = -(rxt(k,420)*y(k,123) + rxt(k,427)*y(k,132) + rxt(k,428) &
                      *y(k,217))
         mat(k,2052) = -rxt(k,420)*y(k,96)
         mat(k,1840) = -rxt(k,427)*y(k,96)
         mat(k,1600) = -rxt(k,428)*y(k,96)
         mat(k,456) = -(rxt(k,418)*y(k,217))
         mat(k,1570) = -rxt(k,418)*y(k,97)
         mat(k,1718) = .080_r8*rxt(k,410)*y(k,201)
         mat(k,1166) = .080_r8*rxt(k,410)*y(k,121)
         mat(k,348) = -(rxt(k,419)*y(k,217))
         mat(k,1557) = -rxt(k,419)*y(k,98)
         mat(k,1711) = .080_r8*rxt(k,416)*y(k,202)
         mat(k,1134) = .080_r8*rxt(k,416)*y(k,121)
         mat(k,1097) = -(rxt(k,421)*y(k,192) + rxt(k,422)*y(k,193) + rxt(k,423) &
                      *y(k,199) + rxt(k,424)*y(k,121) + rxt(k,425)*y(k,123))
         mat(k,1268) = -rxt(k,421)*y(k,99)
         mat(k,1362) = -rxt(k,422)*y(k,99)
         mat(k,2015) = -rxt(k,423)*y(k,99)
         mat(k,1755) = -rxt(k,424)*y(k,99)
         mat(k,2073) = -rxt(k,425)*y(k,99)
         mat(k,788) = rxt(k,420)*y(k,123)
         mat(k,2073) = mat(k,2073) + rxt(k,420)*y(k,96)
         mat(k,289) = -(rxt(k,426)*y(k,217))
         mat(k,1549) = -rxt(k,426)*y(k,100)
         mat(k,1087) = rxt(k,423)*y(k,199)
         mat(k,1958) = rxt(k,423)*y(k,99)
         mat(k,573) = -(rxt(k,429)*y(k,217))
         mat(k,1582) = -rxt(k,429)*y(k,101)
         mat(k,1984) = rxt(k,409)*y(k,201) + rxt(k,414)*y(k,202)
         mat(k,1167) = rxt(k,409)*y(k,199)
         mat(k,1136) = rxt(k,414)*y(k,199)
         mat(k,40) = -(rxt(k,536)*y(k,217))
         mat(k,1510) = -rxt(k,536)*y(k,102)
         mat(k,1112) = -(rxt(k,380)*y(k,132) + rxt(k,381)*y(k,217))
         mat(k,1859) = -rxt(k,380)*y(k,103)
         mat(k,1625) = -rxt(k,381)*y(k,103)
         mat(k,789) = .300_r8*rxt(k,427)*y(k,132)
         mat(k,1756) = .360_r8*rxt(k,410)*y(k,201)
         mat(k,2074) = .400_r8*rxt(k,411)*y(k,201)
         mat(k,1859) = mat(k,1859) + .300_r8*rxt(k,427)*y(k,96)
         mat(k,1269) = .390_r8*rxt(k,407)*y(k,201)
         mat(k,1363) = .310_r8*rxt(k,408)*y(k,201)
         mat(k,1176) = .360_r8*rxt(k,410)*y(k,121) + .400_r8*rxt(k,411)*y(k,123) &
                      + .390_r8*rxt(k,407)*y(k,192) + .310_r8*rxt(k,408)*y(k,193)
         mat(k,212) = -(rxt(k,382)*y(k,217))
         mat(k,1538) = -rxt(k,382)*y(k,104)
         mat(k,1951) = rxt(k,376)*y(k,203)
         mat(k,1194) = rxt(k,376)*y(k,199)
         mat(k,410) = -(rxt(k,391)*y(k,217))
         mat(k,1565) = -rxt(k,391)*y(k,105)
         mat(k,1715) = .800_r8*rxt(k,400)*y(k,186)
         mat(k,890) = .800_r8*rxt(k,400)*y(k,121)
         mat(k,217) = -(rxt(k,392)*y(k,217))
         mat(k,1539) = -rxt(k,392)*y(k,106)
         mat(k,1952) = .800_r8*rxt(k,389)*y(k,207)
         mat(k,564) = .800_r8*rxt(k,389)*y(k,199)
         mat(k,476) = -(rxt(k,393)*y(k,217))
         mat(k,1573) = -rxt(k,393)*y(k,107)
         mat(k,1789) = rxt(k,396)*y(k,205)
         mat(k,1240) = rxt(k,396)*y(k,122)
         mat(k,827) = -(rxt(k,484)*y(k,123) + rxt(k,485)*y(k,132) + rxt(k,486) &
                      *y(k,217))
         mat(k,2054) = -rxt(k,484)*y(k,108)
         mat(k,1842) = -rxt(k,485)*y(k,108)
         mat(k,1603) = -rxt(k,486)*y(k,108)
         mat(k,1223) = -(rxt(k,394)*y(k,132) + rxt(k,395)*y(k,217))
         mat(k,1864) = -rxt(k,394)*y(k,109)
         mat(k,1630) = -rxt(k,395)*y(k,109)
         mat(k,792) = .200_r8*rxt(k,427)*y(k,132)
         mat(k,1761) = .560_r8*rxt(k,410)*y(k,201)
         mat(k,2079) = .600_r8*rxt(k,411)*y(k,201)
         mat(k,1864) = mat(k,1864) + .200_r8*rxt(k,427)*y(k,96)
         mat(k,1274) = .610_r8*rxt(k,407)*y(k,201)
         mat(k,1368) = .440_r8*rxt(k,408)*y(k,201)
         mat(k,1180) = .560_r8*rxt(k,410)*y(k,121) + .600_r8*rxt(k,411)*y(k,123) &
                      + .610_r8*rxt(k,407)*y(k,192) + .440_r8*rxt(k,408)*y(k,193)
         mat(k,739) = -(rxt(k,195)*y(k,121) + (rxt(k,196) + rxt(k,197) + rxt(k,198) &
                      ) * y(k,122) + rxt(k,199)*y(k,131) + rxt(k,207)*y(k,217) &
                      + rxt(k,569)*y(k,216))
         mat(k,1735) = -rxt(k,195)*y(k,110)
         mat(k,1794) = -(rxt(k,196) + rxt(k,197) + rxt(k,198)) * y(k,110)
         mat(k,1396) = -rxt(k,199)*y(k,110)
         mat(k,1595) = -rxt(k,207)*y(k,110)
         mat(k,679) = -rxt(k,569)*y(k,110)
         mat(k,1478) = rxt(k,193)*y(k,208) + rxt(k,566)*y(k,211)
         mat(k,1396) = mat(k,1396) + rxt(k,567)*y(k,211)
         mat(k,697) = 1.100_r8*rxt(k,562)*y(k,209) + .200_r8*rxt(k,560)*y(k,210)
         mat(k,428) = rxt(k,193)*y(k,130)
         mat(k,547) = 1.100_r8*rxt(k,562)*y(k,195)
         mat(k,687) = .200_r8*rxt(k,560)*y(k,195)
         mat(k,393) = rxt(k,566)*y(k,130) + rxt(k,567)*y(k,131)
         mat(k,1783) = rxt(k,214)*y(k,123)
         mat(k,2045) = rxt(k,214)*y(k,122)
         mat(k,222) = -(rxt(k,430)*y(k,217))
         mat(k,1540) = -rxt(k,430)*y(k,113)
         mat(k,1086) = .200_r8*rxt(k,422)*y(k,193)
         mat(k,1338) = .200_r8*rxt(k,422)*y(k,99)
         mat(k,749) = -(rxt(k,431)*y(k,217))
         mat(k,1596) = -rxt(k,431)*y(k,114)
         mat(k,1090) = rxt(k,424)*y(k,121) + rxt(k,425)*y(k,123) + rxt(k,421)*y(k,192) &
                      + .800_r8*rxt(k,422)*y(k,193)
         mat(k,1736) = rxt(k,424)*y(k,99)
         mat(k,2050) = rxt(k,425)*y(k,99)
         mat(k,1260) = rxt(k,421)*y(k,99)
         mat(k,1345) = .800_r8*rxt(k,422)*y(k,99)
         mat(k,50) = -(rxt(k,520)*y(k,217))
         mat(k,1512) = -rxt(k,520)*y(k,118)
         mat(k,1773) = -(rxt(k,195)*y(k,110) + rxt(k,204)*y(k,123) + rxt(k,208) &
                      *y(k,199) + rxt(k,209)*y(k,132) + rxt(k,210)*y(k,130) + rxt(k,231) &
                      *y(k,58) + rxt(k,263)*y(k,18) + rxt(k,306)*y(k,193) + rxt(k,315) &
                      *y(k,200) + rxt(k,325)*y(k,189) + rxt(k,336)*y(k,192) + rxt(k,340) &
                      *y(k,198) + rxt(k,353)*y(k,190) + rxt(k,361)*y(k,220) + rxt(k,365) &
                      *y(k,221) + (rxt(k,371) + rxt(k,372)) * y(k,196) + (rxt(k,378) &
                      + rxt(k,379)) * y(k,203) + rxt(k,387)*y(k,205) + rxt(k,390) &
                      *y(k,207) + (rxt(k,400) + rxt(k,401)) * y(k,186) + rxt(k,410) &
                      *y(k,201) + rxt(k,416)*y(k,202) + rxt(k,424)*y(k,99) + rxt(k,435) &
                      *y(k,225) + rxt(k,439)*y(k,185) + rxt(k,442)*y(k,187) + rxt(k,447) &
                      *y(k,188) + rxt(k,449)*y(k,191) + rxt(k,453)*y(k,194) + rxt(k,456) &
                      *y(k,204) + rxt(k,459)*y(k,206) + rxt(k,462)*y(k,219) + rxt(k,469) &
                      *y(k,224) + rxt(k,475)*y(k,226) + rxt(k,478)*y(k,227) + rxt(k,489) &
                      *y(k,212) + rxt(k,494)*y(k,222) + rxt(k,499)*y(k,223) + rxt(k,571) &
                      *y(k,216))
         mat(k,745) = -rxt(k,195)*y(k,121)
         mat(k,2092) = -rxt(k,204)*y(k,121)
         mat(k,2034) = -rxt(k,208)*y(k,121)
         mat(k,1877) = -rxt(k,209)*y(k,121)
         mat(k,1496) = -rxt(k,210)*y(k,121)
         mat(k,1939) = -rxt(k,231)*y(k,121)
         mat(k,1455) = -rxt(k,263)*y(k,121)
         mat(k,1376) = -rxt(k,306)*y(k,121)
         mat(k,330) = -rxt(k,315)*y(k,121)
         mat(k,815) = -rxt(k,325)*y(k,121)
         mat(k,1282) = -rxt(k,336)*y(k,121)
         mat(k,673) = -rxt(k,340)*y(k,121)
         mat(k,730) = -rxt(k,353)*y(k,121)
         mat(k,718) = -rxt(k,361)*y(k,121)
         mat(k,1042) = -rxt(k,365)*y(k,121)
         mat(k,473) = -(rxt(k,371) + rxt(k,372)) * y(k,121)
         mat(k,1210) = -(rxt(k,378) + rxt(k,379)) * y(k,121)
         mat(k,1249) = -rxt(k,387)*y(k,121)
         mat(k,569) = -rxt(k,390)*y(k,121)
         mat(k,903) = -(rxt(k,400) + rxt(k,401)) * y(k,121)
         mat(k,1187) = -rxt(k,410)*y(k,121)
         mat(k,1159) = -rxt(k,416)*y(k,121)
         mat(k,1105) = -rxt(k,424)*y(k,121)
         mat(k,1081) = -rxt(k,435)*y(k,121)
         mat(k,424) = -rxt(k,439)*y(k,121)
         mat(k,386) = -rxt(k,442)*y(k,121)
         mat(k,324) = -rxt(k,447)*y(k,121)
         mat(k,526) = -rxt(k,449)*y(k,121)
         mat(k,645) = -rxt(k,453)*y(k,121)
         mat(k,605) = -rxt(k,456)*y(k,121)
         mat(k,982) = -rxt(k,459)*y(k,121)
         mat(k,337) = -rxt(k,462)*y(k,121)
         mat(k,620) = -rxt(k,469)*y(k,121)
         mat(k,637) = -rxt(k,475)*y(k,121)
         mat(k,401) = -rxt(k,478)*y(k,121)
         mat(k,962) = -rxt(k,489)*y(k,121)
         mat(k,1004) = -rxt(k,494)*y(k,121)
         mat(k,879) = -rxt(k,499)*y(k,121)
         mat(k,683) = -rxt(k,571)*y(k,121)
         mat(k,745) = mat(k,745) + 2.000_r8*rxt(k,197)*y(k,122) + rxt(k,199)*y(k,131) &
                      + rxt(k,207)*y(k,217)
         mat(k,1815) = 2.000_r8*rxt(k,197)*y(k,110) + rxt(k,200)*y(k,130) + rxt(k,511) &
                      *y(k,148)
         mat(k,1496) = mat(k,1496) + rxt(k,200)*y(k,122)
         mat(k,1408) = rxt(k,199)*y(k,110) + rxt(k,194)*y(k,208)
         mat(k,1298) = rxt(k,511)*y(k,122)
         mat(k,431) = rxt(k,194)*y(k,131)
         mat(k,1644) = rxt(k,207)*y(k,110)
      end do
      end subroutine nlnmat04
      subroutine nlnmat05( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,1816) = -((rxt(k,196) + rxt(k,197) + rxt(k,198)) * y(k,110) + (rxt(k,200) &
                      + rxt(k,202)) * y(k,130) + rxt(k,201)*y(k,132) + rxt(k,213) &
                      *y(k,199) + rxt(k,214)*y(k,123) + rxt(k,215)*y(k,217) + rxt(k,233) &
                      *y(k,58) + rxt(k,264)*y(k,18) + rxt(k,347)*y(k,192) + rxt(k,396) &
                      *y(k,205) + rxt(k,454)*y(k,194) + rxt(k,457)*y(k,204) + rxt(k,460) &
                      *y(k,206) + rxt(k,464)*y(k,139) + rxt(k,467)*y(k,185) + rxt(k,511) &
                      *y(k,148))
         mat(k,746) = -(rxt(k,196) + rxt(k,197) + rxt(k,198)) * y(k,122)
         mat(k,1497) = -(rxt(k,200) + rxt(k,202)) * y(k,122)
         mat(k,1878) = -rxt(k,201)*y(k,122)
         mat(k,2035) = -rxt(k,213)*y(k,122)
         mat(k,2093) = -rxt(k,214)*y(k,122)
         mat(k,1645) = -rxt(k,215)*y(k,122)
         mat(k,1940) = -rxt(k,233)*y(k,122)
         mat(k,1456) = -rxt(k,264)*y(k,122)
         mat(k,1283) = -rxt(k,347)*y(k,122)
         mat(k,1250) = -rxt(k,396)*y(k,122)
         mat(k,646) = -rxt(k,454)*y(k,122)
         mat(k,606) = -rxt(k,457)*y(k,122)
         mat(k,983) = -rxt(k,460)*y(k,122)
         mat(k,364) = -rxt(k,464)*y(k,122)
         mat(k,425) = -rxt(k,467)*y(k,122)
         mat(k,1299) = -rxt(k,511)*y(k,122)
         mat(k,562) = rxt(k,398)*y(k,217)
         mat(k,275) = rxt(k,369)*y(k,123)
         mat(k,1456) = mat(k,1456) + rxt(k,263)*y(k,121)
         mat(k,1940) = mat(k,1940) + rxt(k,231)*y(k,121)
         mat(k,369) = rxt(k,192)*y(k,217)
         mat(k,462) = .700_r8*rxt(k,418)*y(k,217)
         mat(k,1106) = rxt(k,424)*y(k,121) + rxt(k,425)*y(k,123)
         mat(k,1774) = rxt(k,263)*y(k,18) + rxt(k,231)*y(k,58) + rxt(k,424)*y(k,99) &
                      + 2.000_r8*rxt(k,204)*y(k,123) + rxt(k,210)*y(k,130) &
                      + rxt(k,209)*y(k,132) + rxt(k,439)*y(k,185) + rxt(k,400) &
                      *y(k,186) + rxt(k,442)*y(k,187) + rxt(k,447)*y(k,188) &
                      + rxt(k,325)*y(k,189) + rxt(k,353)*y(k,190) + rxt(k,449) &
                      *y(k,191) + rxt(k,336)*y(k,192) + rxt(k,306)*y(k,193) &
                      + rxt(k,453)*y(k,194) + rxt(k,371)*y(k,196) + rxt(k,340) &
                      *y(k,198) + rxt(k,208)*y(k,199) + rxt(k,315)*y(k,200) &
                      + .920_r8*rxt(k,410)*y(k,201) + .920_r8*rxt(k,416)*y(k,202) &
                      + rxt(k,378)*y(k,203) + rxt(k,456)*y(k,204) + rxt(k,387) &
                      *y(k,205) + rxt(k,459)*y(k,206) + rxt(k,390)*y(k,207) &
                      + 1.600_r8*rxt(k,489)*y(k,212) + rxt(k,462)*y(k,219) &
                      + rxt(k,361)*y(k,220) + rxt(k,365)*y(k,221) + .900_r8*rxt(k,494) &
                      *y(k,222) + .800_r8*rxt(k,499)*y(k,223) + rxt(k,469)*y(k,224) &
                      + rxt(k,435)*y(k,225) + rxt(k,475)*y(k,226) + rxt(k,478) &
                      *y(k,227)
         mat(k,2093) = mat(k,2093) + rxt(k,369)*y(k,15) + rxt(k,425)*y(k,99) &
                      + 2.000_r8*rxt(k,204)*y(k,121) + rxt(k,205)*y(k,130) &
                      + rxt(k,203)*y(k,199) + rxt(k,411)*y(k,201) + rxt(k,417) &
                      *y(k,202) + rxt(k,377)*y(k,203) + rxt(k,388)*y(k,205) &
                      + 2.000_r8*rxt(k,490)*y(k,212) + rxt(k,206)*y(k,217) &
                      + rxt(k,436)*y(k,225)
         mat(k,778) = rxt(k,359)*y(k,217)
         mat(k,1497) = mat(k,1497) + rxt(k,210)*y(k,121) + rxt(k,205)*y(k,123)
         mat(k,1878) = mat(k,1878) + rxt(k,209)*y(k,121)
         mat(k,418) = rxt(k,496)*y(k,217)
         mat(k,425) = mat(k,425) + rxt(k,439)*y(k,121)
         mat(k,904) = rxt(k,400)*y(k,121)
         mat(k,387) = rxt(k,442)*y(k,121)
         mat(k,325) = rxt(k,447)*y(k,121)
         mat(k,816) = rxt(k,325)*y(k,121)
         mat(k,731) = rxt(k,353)*y(k,121)
         mat(k,527) = rxt(k,449)*y(k,121)
         mat(k,1283) = mat(k,1283) + rxt(k,336)*y(k,121)
         mat(k,1377) = rxt(k,306)*y(k,121) + .500_r8*rxt(k,487)*y(k,212)
         mat(k,646) = mat(k,646) + rxt(k,453)*y(k,121)
         mat(k,474) = rxt(k,371)*y(k,121)
         mat(k,674) = rxt(k,340)*y(k,121)
         mat(k,2035) = mat(k,2035) + rxt(k,208)*y(k,121) + rxt(k,203)*y(k,123)
         mat(k,331) = rxt(k,315)*y(k,121)
         mat(k,1188) = .920_r8*rxt(k,410)*y(k,121) + rxt(k,411)*y(k,123)
         mat(k,1160) = .920_r8*rxt(k,416)*y(k,121) + rxt(k,417)*y(k,123)
         mat(k,1211) = rxt(k,378)*y(k,121) + rxt(k,377)*y(k,123)
         mat(k,606) = mat(k,606) + rxt(k,456)*y(k,121)
         mat(k,1250) = mat(k,1250) + rxt(k,387)*y(k,121) + rxt(k,388)*y(k,123)
         mat(k,983) = mat(k,983) + rxt(k,459)*y(k,121)
         mat(k,570) = rxt(k,390)*y(k,121)
         mat(k,963) = 1.600_r8*rxt(k,489)*y(k,121) + 2.000_r8*rxt(k,490)*y(k,123) &
                      + .500_r8*rxt(k,487)*y(k,193)
         mat(k,1645) = mat(k,1645) + rxt(k,398)*y(k,1) + rxt(k,192)*y(k,88) &
                      + .700_r8*rxt(k,418)*y(k,97) + rxt(k,206)*y(k,123) + rxt(k,359) &
                      *y(k,124) + rxt(k,496)*y(k,172)
         mat(k,338) = rxt(k,462)*y(k,121)
         mat(k,719) = rxt(k,361)*y(k,121)
         mat(k,1043) = rxt(k,365)*y(k,121)
         mat(k,1005) = .900_r8*rxt(k,494)*y(k,121)
         mat(k,880) = .800_r8*rxt(k,499)*y(k,121)
         mat(k,621) = rxt(k,469)*y(k,121)
         mat(k,1082) = rxt(k,435)*y(k,121) + rxt(k,436)*y(k,123)
         mat(k,638) = rxt(k,475)*y(k,121)
         mat(k,402) = rxt(k,478)*y(k,121)
         mat(k,2098) = -(rxt(k,203)*y(k,199) + rxt(k,204)*y(k,121) + rxt(k,205) &
                      *y(k,130) + rxt(k,206)*y(k,217) + rxt(k,214)*y(k,122) + rxt(k,300) &
                      *y(k,41) + rxt(k,330)*y(k,44) + rxt(k,349)*y(k,28) + rxt(k,356) &
                      *y(k,48) + rxt(k,369)*y(k,15) + rxt(k,377)*y(k,203) + rxt(k,388) &
                      *y(k,205) + rxt(k,411)*y(k,201) + rxt(k,417)*y(k,202) + rxt(k,420) &
                      *y(k,96) + rxt(k,425)*y(k,99) + rxt(k,436)*y(k,225) + rxt(k,481) &
                      *y(k,5) + rxt(k,484)*y(k,108) + rxt(k,490)*y(k,212) + rxt(k,501) &
                      *y(k,174) + rxt(k,518)*y(k,66))
         mat(k,2040) = -rxt(k,203)*y(k,123)
         mat(k,1779) = -rxt(k,204)*y(k,123)
         mat(k,1502) = -rxt(k,205)*y(k,123)
         mat(k,1650) = -rxt(k,206)*y(k,123)
         mat(k,1821) = -rxt(k,214)*y(k,123)
         mat(k,1437) = -rxt(k,300)*y(k,123)
         mat(k,1053) = -rxt(k,330)*y(k,123)
         mat(k,949) = -rxt(k,349)*y(k,123)
         mat(k,1129) = -rxt(k,356)*y(k,123)
         mat(k,276) = -rxt(k,369)*y(k,123)
         mat(k,1213) = -rxt(k,377)*y(k,123)
         mat(k,1253) = -rxt(k,388)*y(k,123)
         mat(k,1191) = -rxt(k,411)*y(k,123)
         mat(k,1163) = -rxt(k,417)*y(k,123)
         mat(k,799) = -rxt(k,420)*y(k,123)
         mat(k,1108) = -rxt(k,425)*y(k,123)
         mat(k,1084) = -rxt(k,436)*y(k,123)
         mat(k,868) = -rxt(k,481)*y(k,123)
         mat(k,842) = -rxt(k,484)*y(k,123)
         mat(k,965) = -rxt(k,490)*y(k,123)
         mat(k,889) = -rxt(k,501)*y(k,123)
         mat(k,196) = -rxt(k,518)*y(k,123)
         mat(k,447) = rxt(k,265)*y(k,130)
         mat(k,1918) = rxt(k,232)*y(k,59)
         mat(k,929) = rxt(k,232)*y(k,55) + rxt(k,234)*y(k,130) + rxt(k,235)*y(k,217)
         mat(k,663) = rxt(k,279)*y(k,87)
         mat(k,1698) = rxt(k,279)*y(k,71) + rxt(k,216)*y(k,217)
         mat(k,483) = .500_r8*rxt(k,393)*y(k,217)
         mat(k,1821) = mat(k,1821) + rxt(k,202)*y(k,130) + rxt(k,201)*y(k,132)
         mat(k,1502) = mat(k,1502) + rxt(k,265)*y(k,19) + rxt(k,234)*y(k,59) &
                      + rxt(k,202)*y(k,122)
         mat(k,1883) = rxt(k,201)*y(k,122)
         mat(k,361) = rxt(k,345)*y(k,217)
         mat(k,1650) = mat(k,1650) + rxt(k,235)*y(k,59) + rxt(k,216)*y(k,87) &
                      + .500_r8*rxt(k,393)*y(k,107) + rxt(k,345)*y(k,137)
         mat(k,773) = -(rxt(k,359)*y(k,217))
         mat(k,1599) = -rxt(k,359)*y(k,124)
         mat(k,934) = rxt(k,349)*y(k,123)
         mat(k,349) = .500_r8*rxt(k,419)*y(k,217)
         mat(k,291) = rxt(k,426)*y(k,217)
         mat(k,223) = rxt(k,430)*y(k,217)
         mat(k,750) = rxt(k,431)*y(k,217)
         mat(k,2051) = rxt(k,349)*y(k,28)
         mat(k,1599) = mat(k,1599) + .500_r8*rxt(k,419)*y(k,98) + rxt(k,426)*y(k,100) &
                      + rxt(k,430)*y(k,113) + rxt(k,431)*y(k,114)
         mat(k,227) = -(rxt(k,491)*y(k,217))
         mat(k,1541) = -rxt(k,491)*y(k,125)
         mat(k,1953) = rxt(k,488)*y(k,212)
         mat(k,951) = rxt(k,488)*y(k,199)
         mat(k,1492) = -(rxt(k,172)*y(k,132) + 4._r8*rxt(k,173)*y(k,130) + rxt(k,174) &
                      *y(k,131) + rxt(k,175)*y(k,75) + rxt(k,176)*y(k,77) + rxt(k,181) &
                      *y(k,199) + rxt(k,187)*y(k,217) + (rxt(k,200) + rxt(k,202) &
                      ) * y(k,122) + rxt(k,205)*y(k,123) + rxt(k,210)*y(k,121) &
                      + rxt(k,234)*y(k,59) + rxt(k,236)*y(k,58) + rxt(k,239)*y(k,83) &
                      + rxt(k,242)*y(k,90) + rxt(k,265)*y(k,19) + rxt(k,266)*y(k,18) &
                      + rxt(k,268)*y(k,79) + rxt(k,270)*y(k,89) + rxt(k,301)*y(k,41) &
                      + rxt(k,504)*y(k,135) + (rxt(k,564) + rxt(k,565)) * y(k,209) &
                      + rxt(k,566)*y(k,211))
         mat(k,1873) = -rxt(k,172)*y(k,130)
         mat(k,1405) = -rxt(k,174)*y(k,130)
         mat(k,1061) = -rxt(k,175)*y(k,130)
         mat(k,506) = -rxt(k,176)*y(k,130)
         mat(k,2030) = -rxt(k,181)*y(k,130)
         mat(k,1640) = -rxt(k,187)*y(k,130)
         mat(k,1811) = -(rxt(k,200) + rxt(k,202)) * y(k,130)
         mat(k,2088) = -rxt(k,205)*y(k,130)
         mat(k,1769) = -rxt(k,210)*y(k,130)
         mat(k,923) = -rxt(k,234)*y(k,130)
         mat(k,1935) = -rxt(k,236)*y(k,130)
         mat(k,1314) = -rxt(k,239)*y(k,130)
         mat(k,768) = -rxt(k,242)*y(k,130)
         mat(k,444) = -rxt(k,265)*y(k,130)
         mat(k,1451) = -rxt(k,266)*y(k,130)
         mat(k,760) = -rxt(k,268)*y(k,130)
         mat(k,653) = -rxt(k,270)*y(k,130)
         mat(k,1427) = -rxt(k,301)*y(k,130)
         mat(k,266) = -rxt(k,504)*y(k,130)
         mat(k,550) = -(rxt(k,564) + rxt(k,565)) * y(k,130)
         mat(k,395) = -rxt(k,566)*y(k,130)
         mat(k,2108) = rxt(k,179)*y(k,199)
         mat(k,742) = rxt(k,195)*y(k,121) + rxt(k,196)*y(k,122) + rxt(k,199)*y(k,131) &
                      + rxt(k,569)*y(k,216)
         mat(k,1769) = mat(k,1769) + rxt(k,195)*y(k,110)
         mat(k,1811) = mat(k,1811) + rxt(k,196)*y(k,110)
         mat(k,1405) = mat(k,1405) + rxt(k,199)*y(k,110) + rxt(k,506)*y(k,146) &
                      + rxt(k,512)*y(k,148) + rxt(k,568)*y(k,211) + (rxt(k,161) &
                       +rxt(k,162))*y(k,213) + rxt(k,574)*y(k,218)
         mat(k,598) = rxt(k,506)*y(k,131)
         mat(k,1296) = rxt(k,512)*y(k,131)
         mat(k,700) = rxt(k,560)*y(k,210) + 1.150_r8*rxt(k,561)*y(k,216)
         mat(k,2030) = mat(k,2030) + rxt(k,179)*y(k,74)
         mat(k,689) = rxt(k,560)*y(k,195)
         mat(k,395) = mat(k,395) + rxt(k,568)*y(k,131)
         mat(k,1666) = (rxt(k,161)+rxt(k,162))*y(k,131)
         mat(k,681) = rxt(k,569)*y(k,110) + 1.150_r8*rxt(k,561)*y(k,195)
         mat(k,1640) = mat(k,1640) + 2.000_r8*rxt(k,189)*y(k,217)
         mat(k,517) = rxt(k,574)*y(k,131)
         mat(k,1402) = -(rxt(k,161)*y(k,213) + rxt(k,166)*y(k,214) + rxt(k,174) &
                      *y(k,130) + rxt(k,180)*y(k,74) + rxt(k,194)*y(k,208) + rxt(k,199) &
                      *y(k,110) + rxt(k,342)*y(k,197) + rxt(k,506)*y(k,146) + rxt(k,512) &
                      *y(k,148) + rxt(k,563)*y(k,209) + (rxt(k,567) + rxt(k,568) &
                      ) * y(k,211) + rxt(k,574)*y(k,218))
         mat(k,1663) = -rxt(k,161)*y(k,131)
         mat(k,78) = -rxt(k,166)*y(k,131)
         mat(k,1489) = -rxt(k,174)*y(k,131)
         mat(k,2105) = -rxt(k,180)*y(k,131)
         mat(k,429) = -rxt(k,194)*y(k,131)
         mat(k,741) = -rxt(k,199)*y(k,131)
         mat(k,345) = -rxt(k,342)*y(k,131)
         mat(k,597) = -rxt(k,506)*y(k,131)
         mat(k,1294) = -rxt(k,512)*y(k,131)
         mat(k,549) = -rxt(k,563)*y(k,131)
         mat(k,394) = -(rxt(k,567) + rxt(k,568)) * y(k,131)
         mat(k,516) = -rxt(k,574)*y(k,131)
         mat(k,1327) = rxt(k,257)*y(k,132) + rxt(k,256)*y(k,199)
         mat(k,1448) = 2.000_r8*rxt(k,258)*y(k,18) + (rxt(k,260)+rxt(k,261))*y(k,58) &
                      + rxt(k,266)*y(k,130) + rxt(k,262)*y(k,199)
         mat(k,1905) = rxt(k,225)*y(k,132) + rxt(k,223)*y(k,199)
         mat(k,1932) = (rxt(k,260)+rxt(k,261))*y(k,18) + (2.000_r8*rxt(k,227) &
                       +2.000_r8*rxt(k,228))*y(k,58) + rxt(k,236)*y(k,130) &
                      + rxt(k,230)*y(k,199) + rxt(k,238)*y(k,217)
         mat(k,2105) = mat(k,2105) + rxt(k,183)*y(k,132) + rxt(k,177)*y(k,199)
         mat(k,367) = rxt(k,192)*y(k,217)
         mat(k,741) = mat(k,741) + rxt(k,198)*y(k,122)
         mat(k,1766) = rxt(k,209)*y(k,132) + rxt(k,571)*y(k,216)
         mat(k,1808) = rxt(k,198)*y(k,110) + rxt(k,200)*y(k,130) + rxt(k,201)*y(k,132)
         mat(k,2085) = rxt(k,205)*y(k,130) + rxt(k,203)*y(k,199)
         mat(k,1489) = mat(k,1489) + rxt(k,266)*y(k,18) + rxt(k,236)*y(k,58) &
                      + rxt(k,200)*y(k,122) + rxt(k,205)*y(k,123) &
                      + 2.000_r8*rxt(k,173)*y(k,130) + 2.000_r8*rxt(k,172)*y(k,132) &
                      + rxt(k,181)*y(k,199) + rxt(k,165)*y(k,214) + rxt(k,187) &
                      *y(k,217)
         mat(k,1402) = mat(k,1402) + 2.000_r8*rxt(k,166)*y(k,214)
         mat(k,1870) = rxt(k,257)*y(k,16) + rxt(k,225)*y(k,55) + rxt(k,183)*y(k,74) &
                      + rxt(k,209)*y(k,121) + rxt(k,201)*y(k,122) &
                      + 2.000_r8*rxt(k,172)*y(k,130) + rxt(k,507)*y(k,146) &
                      + rxt(k,513)*y(k,148) + 2.000_r8*rxt(k,182)*y(k,199) &
                      + 2.000_r8*rxt(k,163)*y(k,213) + rxt(k,188)*y(k,217)
         mat(k,597) = mat(k,597) + rxt(k,507)*y(k,132)
         mat(k,1294) = mat(k,1294) + rxt(k,513)*y(k,132)
         mat(k,812) = rxt(k,324)*y(k,199)
         mat(k,727) = rxt(k,352)*y(k,199)
         mat(k,1372) = rxt(k,305)*y(k,199)
         mat(k,2027) = rxt(k,256)*y(k,16) + rxt(k,262)*y(k,18) + rxt(k,223)*y(k,55) &
                      + rxt(k,230)*y(k,58) + rxt(k,177)*y(k,74) + rxt(k,203)*y(k,123) &
                      + rxt(k,181)*y(k,130) + 2.000_r8*rxt(k,182)*y(k,132) &
                      + rxt(k,324)*y(k,189) + rxt(k,352)*y(k,190) + rxt(k,305) &
                      *y(k,193) + 2.000_r8*rxt(k,191)*y(k,199) + rxt(k,186)*y(k,217) &
                      + rxt(k,360)*y(k,220)
         mat(k,1663) = mat(k,1663) + 2.000_r8*rxt(k,163)*y(k,132)
         mat(k,78) = mat(k,78) + rxt(k,165)*y(k,130) + 2.000_r8*rxt(k,166)*y(k,131)
         mat(k,680) = rxt(k,571)*y(k,121)
         mat(k,1637) = rxt(k,238)*y(k,58) + rxt(k,192)*y(k,88) + rxt(k,187)*y(k,130) &
                      + rxt(k,188)*y(k,132) + rxt(k,186)*y(k,199)
         mat(k,715) = rxt(k,360)*y(k,199)
      end do
      end subroutine nlnmat05
      subroutine nlnmat06( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,1879) = -(rxt(k,163)*y(k,213) + rxt(k,172)*y(k,130) + rxt(k,182) &
                      *y(k,199) + rxt(k,183)*y(k,74) + rxt(k,188)*y(k,217) + rxt(k,201) &
                      *y(k,122) + rxt(k,209)*y(k,121) + rxt(k,225)*y(k,55) + rxt(k,257) &
                      *y(k,16) + rxt(k,321)*y(k,24) + rxt(k,350)*y(k,28) + rxt(k,380) &
                      *y(k,103) + rxt(k,394)*y(k,109) + rxt(k,427)*y(k,96) + rxt(k,465) &
                      *y(k,139) + rxt(k,482)*y(k,5) + rxt(k,485)*y(k,108) + rxt(k,507) &
                      *y(k,146) + rxt(k,513)*y(k,148))
         mat(k,1672) = -rxt(k,163)*y(k,132)
         mat(k,1498) = -rxt(k,172)*y(k,132)
         mat(k,2036) = -rxt(k,182)*y(k,132)
         mat(k,2114) = -rxt(k,183)*y(k,132)
         mat(k,1646) = -rxt(k,188)*y(k,132)
         mat(k,1817) = -rxt(k,201)*y(k,132)
         mat(k,1775) = -rxt(k,209)*y(k,132)
         mat(k,1914) = -rxt(k,225)*y(k,132)
         mat(k,1333) = -rxt(k,257)*y(k,132)
         mat(k,454) = -rxt(k,321)*y(k,132)
         mat(k,947) = -rxt(k,350)*y(k,132)
         mat(k,1119) = -rxt(k,380)*y(k,132)
         mat(k,1233) = -rxt(k,394)*y(k,132)
         mat(k,797) = -rxt(k,427)*y(k,132)
         mat(k,365) = -rxt(k,465)*y(k,132)
         mat(k,866) = -rxt(k,482)*y(k,132)
         mat(k,840) = -rxt(k,485)*y(k,132)
         mat(k,600) = -rxt(k,507)*y(k,132)
         mat(k,1300) = -rxt(k,513)*y(k,132)
         mat(k,1498) = mat(k,1498) + rxt(k,174)*y(k,131)
         mat(k,1410) = rxt(k,174)*y(k,130)
         mat(k,1284) = .150_r8*rxt(k,335)*y(k,199)
         mat(k,2036) = mat(k,2036) + .150_r8*rxt(k,335)*y(k,192) + .150_r8*rxt(k,385) &
                      *y(k,205)
         mat(k,1251) = .150_r8*rxt(k,385)*y(k,199)
         mat(k,237) = -(rxt(k,514)*y(k,148))
         mat(k,1289) = -rxt(k,514)*y(k,134)
         mat(k,1441) = rxt(k,259)*y(k,58)
         mat(k,1924) = rxt(k,259)*y(k,18) + 2.000_r8*rxt(k,229)*y(k,58)
         mat(k,261) = -(rxt(k,504)*y(k,130) + rxt(k,505)*y(k,217))
         mat(k,1466) = -rxt(k,504)*y(k,135)
         mat(k,1546) = -rxt(k,505)*y(k,135)
         mat(k,1008) = rxt(k,373)*y(k,217)
         mat(k,1701) = .100_r8*rxt(k,494)*y(k,222)
         mat(k,1517) = rxt(k,373)*y(k,91)
         mat(k,991) = .100_r8*rxt(k,494)*y(k,121)
         mat(k,355) = -(rxt(k,345)*y(k,217))
         mat(k,1558) = -rxt(k,345)*y(k,137)
         mat(k,1784) = rxt(k,347)*y(k,192)
         mat(k,1257) = rxt(k,347)*y(k,122)
         mat(k,1782) = rxt(k,467)*y(k,185)
         mat(k,420) = rxt(k,467)*y(k,122)
         mat(k,362) = -(rxt(k,464)*y(k,122) + rxt(k,465)*y(k,132))
         mat(k,1785) = -rxt(k,464)*y(k,139)
         mat(k,1833) = -rxt(k,465)*y(k,139)
         mat(k,122) = .070_r8*rxt(k,451)*y(k,217)
         mat(k,1712) = rxt(k,449)*y(k,191)
         mat(k,99) = .060_r8*rxt(k,463)*y(k,217)
         mat(k,151) = .070_r8*rxt(k,479)*y(k,217)
         mat(k,523) = rxt(k,449)*y(k,121)
         mat(k,1559) = .070_r8*rxt(k,451)*y(k,65) + .060_r8*rxt(k,463)*y(k,140) &
                      + .070_r8*rxt(k,479)*y(k,181)
         mat(k,97) = -(rxt(k,463)*y(k,217))
         mat(k,1520) = -rxt(k,463)*y(k,140)
         mat(k,89) = .530_r8*rxt(k,440)*y(k,217)
         mat(k,1520) = mat(k,1520) + .530_r8*rxt(k,440)*y(k,6)
         mat(k,242) = -(rxt(k,466)*y(k,217))
         mat(k,1542) = -rxt(k,466)*y(k,141)
         mat(k,1954) = rxt(k,461)*y(k,219)
         mat(k,333) = rxt(k,461)*y(k,199)
         mat(k,432) = -(rxt(k,362)*y(k,217))
         mat(k,1568) = -rxt(k,362)*y(k,144)
         mat(k,1975) = rxt(k,360)*y(k,220)
         mat(k,711) = rxt(k,360)*y(k,199)
         mat(k,295) = -(rxt(k,366)*y(k,217))
         mat(k,1550) = -rxt(k,366)*y(k,145)
         mat(k,1959) = .850_r8*rxt(k,364)*y(k,221)
         mat(k,1033) = .850_r8*rxt(k,364)*y(k,199)
         mat(k,595) = -(rxt(k,506)*y(k,131) + rxt(k,507)*y(k,132) + rxt(k,510) &
                      *y(k,217))
         mat(k,1392) = -rxt(k,506)*y(k,146)
         mat(k,1837) = -rxt(k,507)*y(k,146)
         mat(k,1584) = -rxt(k,510)*y(k,146)
         mat(k,1292) = -(rxt(k,508)*y(k,18) + rxt(k,509)*y(k,58) + rxt(k,511)*y(k,122) &
                      + rxt(k,512)*y(k,131) + rxt(k,513)*y(k,132) + rxt(k,514) &
                      *y(k,134) + rxt(k,515)*y(k,217))
         mat(k,1445) = -rxt(k,508)*y(k,148)
         mat(k,1928) = -rxt(k,509)*y(k,148)
         mat(k,1804) = -rxt(k,511)*y(k,148)
         mat(k,1400) = -rxt(k,512)*y(k,148)
         mat(k,1867) = -rxt(k,513)*y(k,148)
         mat(k,239) = -rxt(k,514)*y(k,148)
         mat(k,1633) = -rxt(k,515)*y(k,148)
         mat(k,1485) = rxt(k,504)*y(k,135)
         mat(k,1400) = mat(k,1400) + rxt(k,506)*y(k,146)
         mat(k,1867) = mat(k,1867) + rxt(k,507)*y(k,146)
         mat(k,265) = rxt(k,504)*y(k,130)
         mat(k,596) = rxt(k,506)*y(k,131) + rxt(k,507)*y(k,132) + rxt(k,510)*y(k,217)
         mat(k,1633) = mat(k,1633) + rxt(k,510)*y(k,146)
         mat(k,913) = -(rxt(k,516)*y(k,217))
         mat(k,1609) = -rxt(k,516)*y(k,149)
         mat(k,1444) = rxt(k,508)*y(k,148)
         mat(k,1926) = rxt(k,509)*y(k,148)
         mat(k,192) = rxt(k,518)*y(k,123) + (rxt(k,519)+.500_r8*rxt(k,521))*y(k,217)
         mat(k,1796) = rxt(k,511)*y(k,148)
         mat(k,2060) = rxt(k,518)*y(k,66)
         mat(k,1397) = rxt(k,512)*y(k,148)
         mat(k,1848) = rxt(k,513)*y(k,148)
         mat(k,238) = rxt(k,514)*y(k,148)
         mat(k,263) = rxt(k,505)*y(k,217)
         mat(k,1291) = rxt(k,508)*y(k,18) + rxt(k,509)*y(k,58) + rxt(k,511)*y(k,122) &
                      + rxt(k,512)*y(k,131) + rxt(k,513)*y(k,132) + rxt(k,514) &
                      *y(k,134) + rxt(k,515)*y(k,217)
         mat(k,1609) = mat(k,1609) + (rxt(k,519)+.500_r8*rxt(k,521))*y(k,66) &
                      + rxt(k,505)*y(k,135) + rxt(k,515)*y(k,148)
         mat(k,173) = -(rxt(k,517)*y(k,228))
         mat(k,2123) = -rxt(k,517)*y(k,150)
         mat(k,912) = rxt(k,516)*y(k,217)
         mat(k,1532) = rxt(k,516)*y(k,149)
         mat(k,844) = .2202005_r8*rxt(k,530)*y(k,132) + .2202005_r8*rxt(k,531) &
                      *y(k,217)
         mat(k,82) = .0023005_r8*rxt(k,532)*y(k,217)
         mat(k,779) = .0031005_r8*rxt(k,535)*y(k,217)
         mat(k,35) = .2381005_r8*rxt(k,536)*y(k,217)
         mat(k,818) = .0508005_r8*rxt(k,538)*y(k,132) + .0508005_r8*rxt(k,539) &
                      *y(k,217)
         mat(k,1824) = .2202005_r8*rxt(k,530)*y(k,5) + .0508005_r8*rxt(k,538)*y(k,108)
         mat(k,41) = .5931005_r8*rxt(k,540)*y(k,217)
         mat(k,108) = .1364005_r8*rxt(k,541)*y(k,217)
         mat(k,136) = .1677005_r8*rxt(k,542)*y(k,217)
         mat(k,1505) = .2202005_r8*rxt(k,531)*y(k,5) + .0023005_r8*rxt(k,532)*y(k,6) &
                      + .0031005_r8*rxt(k,535)*y(k,96) + .2381005_r8*rxt(k,536) &
                      *y(k,102) + .0508005_r8*rxt(k,539)*y(k,108) &
                      + .5931005_r8*rxt(k,540)*y(k,169) + .1364005_r8*rxt(k,541) &
                      *y(k,177) + .1677005_r8*rxt(k,542)*y(k,179)
         mat(k,845) = .2067005_r8*rxt(k,530)*y(k,132) + .2067005_r8*rxt(k,531) &
                      *y(k,217)
         mat(k,83) = .0008005_r8*rxt(k,532)*y(k,217)
         mat(k,780) = .0035005_r8*rxt(k,535)*y(k,217)
         mat(k,36) = .1308005_r8*rxt(k,536)*y(k,217)
         mat(k,819) = .1149005_r8*rxt(k,538)*y(k,132) + .1149005_r8*rxt(k,539) &
                      *y(k,217)
         mat(k,1825) = .2067005_r8*rxt(k,530)*y(k,5) + .1149005_r8*rxt(k,538)*y(k,108)
         mat(k,42) = .1534005_r8*rxt(k,540)*y(k,217)
         mat(k,109) = .0101005_r8*rxt(k,541)*y(k,217)
         mat(k,137) = .0174005_r8*rxt(k,542)*y(k,217)
         mat(k,1506) = .2067005_r8*rxt(k,531)*y(k,5) + .0008005_r8*rxt(k,532)*y(k,6) &
                      + .0035005_r8*rxt(k,535)*y(k,96) + .1308005_r8*rxt(k,536) &
                      *y(k,102) + .1149005_r8*rxt(k,539)*y(k,108) &
                      + .1534005_r8*rxt(k,540)*y(k,169) + .0101005_r8*rxt(k,541) &
                      *y(k,177) + .0174005_r8*rxt(k,542)*y(k,179)
         mat(k,846) = .0653005_r8*rxt(k,530)*y(k,132) + .0653005_r8*rxt(k,531) &
                      *y(k,217)
         mat(k,84) = .0843005_r8*rxt(k,532)*y(k,217)
         mat(k,781) = .0003005_r8*rxt(k,535)*y(k,217)
         mat(k,37) = .0348005_r8*rxt(k,536)*y(k,217)
         mat(k,820) = .0348005_r8*rxt(k,538)*y(k,132) + .0348005_r8*rxt(k,539) &
                      *y(k,217)
         mat(k,1826) = .0653005_r8*rxt(k,530)*y(k,5) + .0348005_r8*rxt(k,538)*y(k,108)
         mat(k,43) = .0459005_r8*rxt(k,540)*y(k,217)
         mat(k,110) = .0763005_r8*rxt(k,541)*y(k,217)
         mat(k,138) = .086_r8*rxt(k,542)*y(k,217)
         mat(k,1507) = .0653005_r8*rxt(k,531)*y(k,5) + .0843005_r8*rxt(k,532)*y(k,6) &
                      + .0003005_r8*rxt(k,535)*y(k,96) + .0348005_r8*rxt(k,536) &
                      *y(k,102) + .0348005_r8*rxt(k,539)*y(k,108) &
                      + .0459005_r8*rxt(k,540)*y(k,169) + .0763005_r8*rxt(k,541) &
                      *y(k,177) + .086_r8*rxt(k,542)*y(k,179)
         mat(k,847) = .1749305_r8*rxt(k,529)*y(k,123) + .1284005_r8*rxt(k,530) &
                      *y(k,132) + .1284005_r8*rxt(k,531)*y(k,217)
         mat(k,85) = .0443005_r8*rxt(k,532)*y(k,217)
         mat(k,782) = .0590245_r8*rxt(k,533)*y(k,123) + .0033005_r8*rxt(k,534) &
                      *y(k,132) + .0271005_r8*rxt(k,535)*y(k,217)
         mat(k,38) = .0076005_r8*rxt(k,536)*y(k,217)
         mat(k,821) = .1749305_r8*rxt(k,537)*y(k,123) + .0554005_r8*rxt(k,538) &
                      *y(k,132) + .0554005_r8*rxt(k,539)*y(k,217)
         mat(k,2043) = .1749305_r8*rxt(k,529)*y(k,5) + .0590245_r8*rxt(k,533)*y(k,96) &
                      + .1749305_r8*rxt(k,537)*y(k,108)
         mat(k,1827) = .1284005_r8*rxt(k,530)*y(k,5) + .0033005_r8*rxt(k,534)*y(k,96) &
                      + .0554005_r8*rxt(k,538)*y(k,108)
         mat(k,44) = .0085005_r8*rxt(k,540)*y(k,217)
         mat(k,111) = .2157005_r8*rxt(k,541)*y(k,217)
         mat(k,139) = .0512005_r8*rxt(k,542)*y(k,217)
         mat(k,1508) = .1284005_r8*rxt(k,531)*y(k,5) + .0443005_r8*rxt(k,532)*y(k,6) &
                      + .0271005_r8*rxt(k,535)*y(k,96) + .0076005_r8*rxt(k,536) &
                      *y(k,102) + .0554005_r8*rxt(k,539)*y(k,108) &
                      + .0085005_r8*rxt(k,540)*y(k,169) + .2157005_r8*rxt(k,541) &
                      *y(k,177) + .0512005_r8*rxt(k,542)*y(k,179)
         mat(k,848) = .5901905_r8*rxt(k,529)*y(k,123) + .114_r8*rxt(k,530)*y(k,132) &
                      + .114_r8*rxt(k,531)*y(k,217)
         mat(k,86) = .1621005_r8*rxt(k,532)*y(k,217)
         mat(k,783) = .0250245_r8*rxt(k,533)*y(k,123) + .0474005_r8*rxt(k,535) &
                      *y(k,217)
         mat(k,39) = .0113005_r8*rxt(k,536)*y(k,217)
         mat(k,822) = .5901905_r8*rxt(k,537)*y(k,123) + .1278005_r8*rxt(k,538) &
                      *y(k,132) + .1278005_r8*rxt(k,539)*y(k,217)
         mat(k,2044) = .5901905_r8*rxt(k,529)*y(k,5) + .0250245_r8*rxt(k,533)*y(k,96) &
                      + .5901905_r8*rxt(k,537)*y(k,108)
         mat(k,1828) = .114_r8*rxt(k,530)*y(k,5) + .1278005_r8*rxt(k,538)*y(k,108)
         mat(k,45) = .0128005_r8*rxt(k,540)*y(k,217)
         mat(k,112) = .0232005_r8*rxt(k,541)*y(k,217)
         mat(k,140) = .1598005_r8*rxt(k,542)*y(k,217)
         mat(k,1509) = .114_r8*rxt(k,531)*y(k,5) + .1621005_r8*rxt(k,532)*y(k,6) &
                      + .0474005_r8*rxt(k,535)*y(k,96) + .0113005_r8*rxt(k,536) &
                      *y(k,102) + .1278005_r8*rxt(k,539)*y(k,108) &
                      + .0128005_r8*rxt(k,540)*y(k,169) + .0232005_r8*rxt(k,541) &
                      *y(k,177) + .1598005_r8*rxt(k,542)*y(k,179)
      end do
      end subroutine nlnmat06
      subroutine nlnmat07( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,46) = -(rxt(k,540)*y(k,217))
         mat(k,1511) = -rxt(k,540)*y(k,169)
         mat(k,115) = .100_r8*rxt(k,471)*y(k,217)
         mat(k,141) = .230_r8*rxt(k,473)*y(k,217)
         mat(k,1524) = .100_r8*rxt(k,471)*y(k,177) + .230_r8*rxt(k,473)*y(k,179)
         mat(k,484) = -(rxt(k,495)*y(k,217))
         mat(k,1574) = -rxt(k,495)*y(k,171)
         mat(k,1977) = rxt(k,493)*y(k,222)
         mat(k,992) = rxt(k,493)*y(k,199)
         mat(k,415) = -(rxt(k,496)*y(k,217))
         mat(k,1566) = -rxt(k,496)*y(k,172)
         mat(k,1716) = .200_r8*rxt(k,489)*y(k,212) + .200_r8*rxt(k,499)*y(k,223)
         mat(k,1341) = .500_r8*rxt(k,487)*y(k,212)
         mat(k,952) = .200_r8*rxt(k,489)*y(k,121) + .500_r8*rxt(k,487)*y(k,193)
         mat(k,871) = .200_r8*rxt(k,499)*y(k,121)
         mat(k,373) = -(rxt(k,500)*y(k,217))
         mat(k,1561) = -rxt(k,500)*y(k,173)
         mat(k,1970) = rxt(k,498)*y(k,223)
         mat(k,870) = rxt(k,498)*y(k,199)
         mat(k,882) = -(rxt(k,501)*y(k,123) + rxt(k,502)*y(k,217))
         mat(k,2057) = -rxt(k,501)*y(k,174)
         mat(k,1606) = -rxt(k,502)*y(k,174)
         mat(k,855) = .330_r8*rxt(k,482)*y(k,132)
         mat(k,829) = .330_r8*rxt(k,485)*y(k,132)
         mat(k,1741) = .800_r8*rxt(k,489)*y(k,212) + .800_r8*rxt(k,499)*y(k,223)
         mat(k,2057) = mat(k,2057) + rxt(k,490)*y(k,212)
         mat(k,1845) = .330_r8*rxt(k,482)*y(k,5) + .330_r8*rxt(k,485)*y(k,108)
         mat(k,416) = rxt(k,496)*y(k,217)
         mat(k,1350) = .500_r8*rxt(k,487)*y(k,212) + rxt(k,497)*y(k,223)
         mat(k,954) = .800_r8*rxt(k,489)*y(k,121) + rxt(k,490)*y(k,123) &
                      + .500_r8*rxt(k,487)*y(k,193)
         mat(k,1606) = mat(k,1606) + rxt(k,496)*y(k,172)
         mat(k,874) = .800_r8*rxt(k,499)*y(k,121) + rxt(k,497)*y(k,193)
         mat(k,967) = -(rxt(k,503)*y(k,217))
         mat(k,1613) = -rxt(k,503)*y(k,175)
         mat(k,859) = .300_r8*rxt(k,482)*y(k,132)
         mat(k,833) = .300_r8*rxt(k,485)*y(k,132)
         mat(k,1745) = .900_r8*rxt(k,494)*y(k,222)
         mat(k,1851) = .300_r8*rxt(k,482)*y(k,5) + .300_r8*rxt(k,485)*y(k,108)
         mat(k,1353) = rxt(k,492)*y(k,222)
         mat(k,995) = .900_r8*rxt(k,494)*y(k,121) + rxt(k,492)*y(k,193)
         mat(k,495) = -(rxt(k,470)*y(k,217))
         mat(k,1575) = -rxt(k,470)*y(k,176)
         mat(k,1978) = rxt(k,468)*y(k,224)
         mat(k,610) = rxt(k,468)*y(k,199)
         mat(k,113) = -(rxt(k,471)*y(k,217))
         mat(k,1522) = -rxt(k,471)*y(k,177)
         mat(k,129) = -(rxt(k,437)*y(k,217))
         mat(k,1525) = -rxt(k,437)*y(k,178)
         mat(k,1949) = rxt(k,434)*y(k,225)
         mat(k,1069) = rxt(k,434)*y(k,199)
         mat(k,142) = -(rxt(k,473)*y(k,217))
         mat(k,1527) = -rxt(k,473)*y(k,179)
         mat(k,584) = -(rxt(k,476)*y(k,217))
         mat(k,1583) = -rxt(k,476)*y(k,180)
         mat(k,1985) = rxt(k,474)*y(k,226)
         mat(k,627) = rxt(k,474)*y(k,199)
         mat(k,150) = -(rxt(k,479)*y(k,217))
         mat(k,1528) = -rxt(k,479)*y(k,181)
         mat(k,143) = .150_r8*rxt(k,473)*y(k,217)
         mat(k,1528) = mat(k,1528) + .150_r8*rxt(k,473)*y(k,179)
         mat(k,313) = -(rxt(k,480)*y(k,217))
         mat(k,1553) = -rxt(k,480)*y(k,182)
         mat(k,1962) = rxt(k,477)*y(k,227)
         mat(k,396) = rxt(k,477)*y(k,199)
         mat(k,421) = -(rxt(k,438)*y(k,199) + rxt(k,439)*y(k,121) + rxt(k,467) &
                      *y(k,122))
         mat(k,1974) = -rxt(k,438)*y(k,185)
         mat(k,1717) = -rxt(k,439)*y(k,185)
         mat(k,1787) = -rxt(k,467)*y(k,185)
         mat(k,170) = rxt(k,444)*y(k,217)
         mat(k,1567) = rxt(k,444)*y(k,21)
         mat(k,895) = -(rxt(k,399)*y(k,199) + (rxt(k,400) + rxt(k,401)) * y(k,121))
         mat(k,2002) = -rxt(k,399)*y(k,186)
         mat(k,1742) = -(rxt(k,400) + rxt(k,401)) * y(k,186)
         mat(k,534) = rxt(k,402)*y(k,217)
         mat(k,164) = rxt(k,403)*y(k,217)
         mat(k,1607) = rxt(k,402)*y(k,2) + rxt(k,403)*y(k,14)
         mat(k,382) = -(rxt(k,441)*y(k,199) + rxt(k,442)*y(k,121))
         mat(k,1971) = -rxt(k,441)*y(k,187)
         mat(k,1713) = -rxt(k,442)*y(k,187)
         mat(k,90) = .350_r8*rxt(k,440)*y(k,217)
         mat(k,279) = rxt(k,443)*y(k,217)
         mat(k,1562) = .350_r8*rxt(k,440)*y(k,6) + rxt(k,443)*y(k,7)
         mat(k,321) = -(rxt(k,445)*y(k,199) + rxt(k,447)*y(k,121))
         mat(k,1963) = -rxt(k,445)*y(k,188)
         mat(k,1706) = -rxt(k,447)*y(k,188)
         mat(k,249) = rxt(k,446)*y(k,217)
         mat(k,116) = .070_r8*rxt(k,471)*y(k,217)
         mat(k,144) = .060_r8*rxt(k,473)*y(k,217)
         mat(k,1554) = rxt(k,446)*y(k,22) + .070_r8*rxt(k,471)*y(k,177) &
                      + .060_r8*rxt(k,473)*y(k,179)
         mat(k,809) = -(4._r8*rxt(k,322)*y(k,189) + rxt(k,323)*y(k,193) + rxt(k,324) &
                      *y(k,199) + rxt(k,325)*y(k,121))
         mat(k,1348) = -rxt(k,323)*y(k,189)
         mat(k,1999) = -rxt(k,324)*y(k,189)
         mat(k,1739) = -rxt(k,325)*y(k,189)
         mat(k,254) = .500_r8*rxt(k,327)*y(k,217)
         mat(k,207) = rxt(k,328)*y(k,55) + rxt(k,329)*y(k,217)
         mat(k,1895) = rxt(k,328)*y(k,27)
         mat(k,1602) = .500_r8*rxt(k,327)*y(k,26) + rxt(k,329)*y(k,27)
         mat(k,723) = -(rxt(k,351)*y(k,193) + rxt(k,352)*y(k,199) + rxt(k,353) &
                      *y(k,121))
         mat(k,1344) = -rxt(k,351)*y(k,190)
         mat(k,1994) = -rxt(k,352)*y(k,190)
         mat(k,1734) = -rxt(k,353)*y(k,190)
         mat(k,302) = rxt(k,354)*y(k,217)
         mat(k,57) = rxt(k,355)*y(k,217)
         mat(k,1594) = rxt(k,354)*y(k,29) + rxt(k,355)*y(k,30)
         mat(k,524) = -(rxt(k,448)*y(k,199) + rxt(k,449)*y(k,121))
         mat(k,1981) = -rxt(k,448)*y(k,191)
         mat(k,1721) = -rxt(k,449)*y(k,191)
         mat(k,183) = rxt(k,450)*y(k,217)
         mat(k,1721) = mat(k,1721) + rxt(k,439)*y(k,185)
         mat(k,1836) = rxt(k,465)*y(k,139)
         mat(k,363) = rxt(k,465)*y(k,132)
         mat(k,422) = rxt(k,439)*y(k,121) + .400_r8*rxt(k,438)*y(k,199)
         mat(k,1981) = mat(k,1981) + .400_r8*rxt(k,438)*y(k,185)
         mat(k,1578) = rxt(k,450)*y(k,31)
         mat(k,1276) = -(4._r8*rxt(k,333)*y(k,192) + rxt(k,334)*y(k,193) + rxt(k,335) &
                      *y(k,199) + rxt(k,336)*y(k,121) + rxt(k,347)*y(k,122) + rxt(k,374) &
                      *y(k,203) + rxt(k,407)*y(k,201) + rxt(k,412)*y(k,202) + rxt(k,421) &
                      *y(k,99) + rxt(k,432)*y(k,225))
         mat(k,1370) = -rxt(k,334)*y(k,192)
         mat(k,2023) = -rxt(k,335)*y(k,192)
         mat(k,1763) = -rxt(k,336)*y(k,192)
         mat(k,1803) = -rxt(k,347)*y(k,192)
         mat(k,1205) = -rxt(k,374)*y(k,192)
         mat(k,1182) = -rxt(k,407)*y(k,192)
         mat(k,1154) = -rxt(k,412)*y(k,192)
         mat(k,1101) = -rxt(k,421)*y(k,192)
         mat(k,1077) = -rxt(k,432)*y(k,192)
         mat(k,863) = .060_r8*rxt(k,482)*y(k,132)
         mat(k,1048) = rxt(k,330)*y(k,123) + rxt(k,331)*y(k,217)
         mat(k,1125) = rxt(k,356)*y(k,123) + rxt(k,357)*y(k,217)
         mat(k,405) = .500_r8*rxt(k,338)*y(k,217)
         mat(k,793) = .080_r8*rxt(k,427)*y(k,132)
         mat(k,1116) = .100_r8*rxt(k,380)*y(k,132)
         mat(k,837) = .060_r8*rxt(k,485)*y(k,132)
         mat(k,1225) = .280_r8*rxt(k,394)*y(k,132)
         mat(k,1763) = mat(k,1763) + .530_r8*rxt(k,378)*y(k,203) + rxt(k,387)*y(k,205) &
                      + rxt(k,390)*y(k,207) + rxt(k,365)*y(k,221)
         mat(k,2081) = rxt(k,330)*y(k,44) + rxt(k,356)*y(k,48) + .530_r8*rxt(k,377) &
                      *y(k,203) + rxt(k,388)*y(k,205)
         mat(k,1866) = .060_r8*rxt(k,482)*y(k,5) + .080_r8*rxt(k,427)*y(k,96) &
                      + .100_r8*rxt(k,380)*y(k,103) + .060_r8*rxt(k,485)*y(k,108) &
                      + .280_r8*rxt(k,394)*y(k,109)
         mat(k,970) = .650_r8*rxt(k,503)*y(k,217)
         mat(k,1276) = mat(k,1276) + .530_r8*rxt(k,374)*y(k,203)
         mat(k,1370) = mat(k,1370) + .260_r8*rxt(k,375)*y(k,203) + rxt(k,384)*y(k,205) &
                      + .300_r8*rxt(k,363)*y(k,221)
         mat(k,2023) = mat(k,2023) + .450_r8*rxt(k,385)*y(k,205) + .200_r8*rxt(k,389) &
                      *y(k,207) + .150_r8*rxt(k,364)*y(k,221)
         mat(k,1205) = mat(k,1205) + .530_r8*rxt(k,378)*y(k,121) + .530_r8*rxt(k,377) &
                      *y(k,123) + .530_r8*rxt(k,374)*y(k,192) + .260_r8*rxt(k,375) &
                      *y(k,193)
         mat(k,1244) = rxt(k,387)*y(k,121) + rxt(k,388)*y(k,123) + rxt(k,384)*y(k,193) &
                      + .450_r8*rxt(k,385)*y(k,199) + 4.000_r8*rxt(k,386)*y(k,205)
         mat(k,567) = rxt(k,390)*y(k,121) + .200_r8*rxt(k,389)*y(k,199)
         mat(k,1632) = rxt(k,331)*y(k,44) + rxt(k,357)*y(k,48) + .500_r8*rxt(k,338) &
                      *y(k,50) + .650_r8*rxt(k,503)*y(k,175)
         mat(k,1038) = rxt(k,365)*y(k,121) + .300_r8*rxt(k,363)*y(k,193) &
                      + .150_r8*rxt(k,364)*y(k,199)
         mat(k,1371) = -(rxt(k,226)*y(k,58) + (4._r8*rxt(k,303) + 4._r8*rxt(k,304) &
                      ) * y(k,193) + rxt(k,305)*y(k,199) + rxt(k,306)*y(k,121) &
                      + rxt(k,323)*y(k,189) + rxt(k,334)*y(k,192) + rxt(k,351) &
                      *y(k,190) + rxt(k,363)*y(k,221) + rxt(k,375)*y(k,203) + rxt(k,384) &
                      *y(k,205) + rxt(k,408)*y(k,201) + rxt(k,413)*y(k,202) + rxt(k,422) &
                      *y(k,99) + rxt(k,433)*y(k,225) + rxt(k,487)*y(k,212) + rxt(k,492) &
                      *y(k,222) + rxt(k,497)*y(k,223))
         mat(k,1931) = -rxt(k,226)*y(k,193)
         mat(k,2026) = -rxt(k,305)*y(k,193)
         mat(k,1765) = -rxt(k,306)*y(k,193)
         mat(k,811) = -rxt(k,323)*y(k,193)
         mat(k,1277) = -rxt(k,334)*y(k,193)
         mat(k,726) = -rxt(k,351)*y(k,193)
         mat(k,1039) = -rxt(k,363)*y(k,193)
         mat(k,1206) = -rxt(k,375)*y(k,193)
         mat(k,1245) = -rxt(k,384)*y(k,193)
         mat(k,1183) = -rxt(k,408)*y(k,193)
         mat(k,1155) = -rxt(k,413)*y(k,193)
         mat(k,1102) = -rxt(k,422)*y(k,193)
         mat(k,1078) = -rxt(k,433)*y(k,193)
         mat(k,959) = -rxt(k,487)*y(k,193)
         mat(k,1001) = -rxt(k,492)*y(k,193)
         mat(k,876) = -rxt(k,497)*y(k,193)
         mat(k,941) = .280_r8*rxt(k,350)*y(k,132)
         mat(k,465) = rxt(k,337)*y(k,217)
         mat(k,308) = .700_r8*rxt(k,308)*y(k,217)
         mat(k,794) = .050_r8*rxt(k,427)*y(k,132)
         mat(k,1102) = mat(k,1102) + rxt(k,421)*y(k,192)
         mat(k,1765) = mat(k,1765) + rxt(k,336)*y(k,192) + .830_r8*rxt(k,453)*y(k,194) &
                      + .170_r8*rxt(k,459)*y(k,206)
         mat(k,1869) = .280_r8*rxt(k,350)*y(k,28) + .050_r8*rxt(k,427)*y(k,96)
         mat(k,1277) = mat(k,1277) + rxt(k,421)*y(k,99) + rxt(k,336)*y(k,121) &
                      + 4.000_r8*rxt(k,333)*y(k,192) + .900_r8*rxt(k,334)*y(k,193) &
                      + .450_r8*rxt(k,335)*y(k,199) + rxt(k,407)*y(k,201) + rxt(k,412) &
                      *y(k,202) + rxt(k,374)*y(k,203) + rxt(k,383)*y(k,205) &
                      + rxt(k,432)*y(k,225)
         mat(k,1371) = mat(k,1371) + .900_r8*rxt(k,334)*y(k,192)
         mat(k,643) = .830_r8*rxt(k,453)*y(k,121) + .330_r8*rxt(k,452)*y(k,199)
         mat(k,2026) = mat(k,2026) + .450_r8*rxt(k,335)*y(k,192) + .330_r8*rxt(k,452) &
                      *y(k,194) + .070_r8*rxt(k,458)*y(k,206)
         mat(k,1183) = mat(k,1183) + rxt(k,407)*y(k,192)
         mat(k,1155) = mat(k,1155) + rxt(k,412)*y(k,192)
         mat(k,1206) = mat(k,1206) + rxt(k,374)*y(k,192)
         mat(k,1245) = mat(k,1245) + rxt(k,383)*y(k,192)
         mat(k,980) = .170_r8*rxt(k,459)*y(k,121) + .070_r8*rxt(k,458)*y(k,199)
         mat(k,1636) = rxt(k,337)*y(k,49) + .700_r8*rxt(k,308)*y(k,52)
         mat(k,1078) = mat(k,1078) + rxt(k,432)*y(k,192)
      end do
      end subroutine nlnmat07
      subroutine nlnmat08( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,640) = -(rxt(k,452)*y(k,199) + rxt(k,453)*y(k,121) + rxt(k,454) &
                      *y(k,122))
         mat(k,1989) = -rxt(k,452)*y(k,194)
         mat(k,1727) = -rxt(k,453)*y(k,194)
         mat(k,1792) = -rxt(k,454)*y(k,194)
         mat(k,696) = -(rxt(k,560)*y(k,210) + rxt(k,561)*y(k,216) + rxt(k,562) &
                      *y(k,209))
         mat(k,686) = -rxt(k,560)*y(k,195)
         mat(k,678) = -rxt(k,561)*y(k,195)
         mat(k,546) = -rxt(k,562)*y(k,195)
         mat(k,468) = -((rxt(k,371) + rxt(k,372)) * y(k,121))
         mat(k,1719) = -(rxt(k,371) + rxt(k,372)) * y(k,196)
         mat(k,270) = rxt(k,370)*y(k,217)
         mat(k,1572) = rxt(k,370)*y(k,15)
         mat(k,343) = -(rxt(k,342)*y(k,131))
         mat(k,1387) = -rxt(k,342)*y(k,197)
         mat(k,1710) = .750_r8*rxt(k,340)*y(k,198)
         mat(k,667) = .750_r8*rxt(k,340)*y(k,121)
         mat(k,668) = -(rxt(k,339)*y(k,199) + rxt(k,340)*y(k,121))
         mat(k,1991) = -rxt(k,339)*y(k,198)
         mat(k,1728) = -rxt(k,340)*y(k,198)
         mat(k,449) = rxt(k,346)*y(k,217)
         mat(k,1590) = rxt(k,346)*y(k,24)
         mat(k,2039) = -((rxt(k,177) + rxt(k,178) + rxt(k,179)) * y(k,74) + rxt(k,181) &
                      *y(k,130) + rxt(k,182)*y(k,132) + rxt(k,186)*y(k,217) &
                      + 4._r8*rxt(k,191)*y(k,199) + rxt(k,203)*y(k,123) + rxt(k,208) &
                      *y(k,121) + rxt(k,213)*y(k,122) + (rxt(k,223) + rxt(k,224) &
                      ) * y(k,55) + rxt(k,230)*y(k,58) + rxt(k,256)*y(k,16) + rxt(k,262) &
                      *y(k,18) + rxt(k,299)*y(k,41) + rxt(k,305)*y(k,193) + rxt(k,313) &
                      *y(k,200) + rxt(k,324)*y(k,189) + rxt(k,335)*y(k,192) + rxt(k,339) &
                      *y(k,198) + rxt(k,352)*y(k,190) + rxt(k,360)*y(k,220) + rxt(k,364) &
                      *y(k,221) + rxt(k,376)*y(k,203) + rxt(k,385)*y(k,205) + rxt(k,389) &
                      *y(k,207) + rxt(k,399)*y(k,186) + rxt(k,409)*y(k,201) + rxt(k,414) &
                      *y(k,202) + rxt(k,423)*y(k,99) + rxt(k,434)*y(k,225) + rxt(k,438) &
                      *y(k,185) + rxt(k,441)*y(k,187) + rxt(k,445)*y(k,188) + rxt(k,448) &
                      *y(k,191) + rxt(k,452)*y(k,194) + rxt(k,455)*y(k,204) + rxt(k,458) &
                      *y(k,206) + rxt(k,461)*y(k,219) + rxt(k,468)*y(k,224) + rxt(k,474) &
                      *y(k,226) + rxt(k,477)*y(k,227) + rxt(k,488)*y(k,212) + rxt(k,493) &
                      *y(k,222) + rxt(k,498)*y(k,223))
         mat(k,2117) = -(rxt(k,177) + rxt(k,178) + rxt(k,179)) * y(k,199)
         mat(k,1501) = -rxt(k,181)*y(k,199)
         mat(k,1882) = -rxt(k,182)*y(k,199)
         mat(k,1649) = -rxt(k,186)*y(k,199)
         mat(k,2097) = -rxt(k,203)*y(k,199)
         mat(k,1778) = -rxt(k,208)*y(k,199)
         mat(k,1820) = -rxt(k,213)*y(k,199)
         mat(k,1917) = -(rxt(k,223) + rxt(k,224)) * y(k,199)
         mat(k,1944) = -rxt(k,230)*y(k,199)
         mat(k,1334) = -rxt(k,256)*y(k,199)
         mat(k,1460) = -rxt(k,262)*y(k,199)
         mat(k,1436) = -rxt(k,299)*y(k,199)
         mat(k,1381) = -rxt(k,305)*y(k,199)
         mat(k,332) = -rxt(k,313)*y(k,199)
         mat(k,817) = -rxt(k,324)*y(k,199)
         mat(k,1285) = -rxt(k,335)*y(k,199)
         mat(k,675) = -rxt(k,339)*y(k,199)
         mat(k,732) = -rxt(k,352)*y(k,199)
         mat(k,720) = -rxt(k,360)*y(k,199)
         mat(k,1044) = -rxt(k,364)*y(k,199)
         mat(k,1212) = -rxt(k,376)*y(k,199)
         mat(k,1252) = -rxt(k,385)*y(k,199)
         mat(k,571) = -rxt(k,389)*y(k,199)
         mat(k,905) = -rxt(k,399)*y(k,199)
         mat(k,1190) = -rxt(k,409)*y(k,199)
         mat(k,1162) = -rxt(k,414)*y(k,199)
         mat(k,1107) = -rxt(k,423)*y(k,199)
         mat(k,1083) = -rxt(k,434)*y(k,199)
         mat(k,426) = -rxt(k,438)*y(k,199)
         mat(k,388) = -rxt(k,441)*y(k,199)
         mat(k,326) = -rxt(k,445)*y(k,199)
         mat(k,529) = -rxt(k,448)*y(k,199)
         mat(k,647) = -rxt(k,452)*y(k,199)
         mat(k,607) = -rxt(k,455)*y(k,199)
         mat(k,984) = -rxt(k,458)*y(k,199)
         mat(k,339) = -rxt(k,461)*y(k,199)
         mat(k,622) = -rxt(k,468)*y(k,199)
         mat(k,639) = -rxt(k,474)*y(k,199)
         mat(k,403) = -rxt(k,477)*y(k,199)
         mat(k,964) = -rxt(k,488)*y(k,199)
         mat(k,1006) = -rxt(k,493)*y(k,199)
         mat(k,881) = -rxt(k,498)*y(k,199)
         mat(k,867) = .570_r8*rxt(k,482)*y(k,132)
         mat(k,92) = .650_r8*rxt(k,440)*y(k,217)
         mat(k,1334) = mat(k,1334) + rxt(k,255)*y(k,41)
         mat(k,1460) = mat(k,1460) + rxt(k,267)*y(k,217)
         mat(k,205) = .350_r8*rxt(k,319)*y(k,217)
         mat(k,455) = .130_r8*rxt(k,321)*y(k,132)
         mat(k,180) = rxt(k,326)*y(k,217)
         mat(k,948) = .280_r8*rxt(k,350)*y(k,132)
         mat(k,1436) = mat(k,1436) + rxt(k,255)*y(k,16) + rxt(k,219)*y(k,55) &
                      + rxt(k,300)*y(k,123) + rxt(k,301)*y(k,130)
         mat(k,55) = rxt(k,332)*y(k,217)
         mat(k,706) = rxt(k,307)*y(k,217)
         mat(k,1917) = mat(k,1917) + rxt(k,219)*y(k,41) + rxt(k,222)*y(k,77)
         mat(k,1944) = mat(k,1944) + rxt(k,226)*y(k,193) + rxt(k,237)*y(k,217)
         mat(k,1025) = rxt(k,310)*y(k,217)
         mat(k,124) = .730_r8*rxt(k,451)*y(k,217)
         mat(k,195) = .500_r8*rxt(k,521)*y(k,217)
         mat(k,990) = rxt(k,343)*y(k,217)
         mat(k,805) = rxt(k,344)*y(k,217)
         mat(k,2117) = mat(k,2117) + rxt(k,180)*y(k,131)
         mat(k,509) = rxt(k,222)*y(k,55) + rxt(k,176)*y(k,130) + rxt(k,185)*y(k,217)
         mat(k,107) = rxt(k,311)*y(k,217)
         mat(k,709) = rxt(k,312)*y(k,217)
         mat(k,1021) = rxt(k,373)*y(k,217)
         mat(k,1032) = rxt(k,358)*y(k,217)
         mat(k,798) = .370_r8*rxt(k,427)*y(k,132)
         mat(k,463) = .300_r8*rxt(k,418)*y(k,217)
         mat(k,354) = rxt(k,419)*y(k,217)
         mat(k,1107) = mat(k,1107) + rxt(k,424)*y(k,121) + rxt(k,425)*y(k,123) &
                      + rxt(k,421)*y(k,192) + 1.200_r8*rxt(k,422)*y(k,193)
         mat(k,294) = rxt(k,426)*y(k,217)
         mat(k,1120) = .140_r8*rxt(k,380)*y(k,132)
         mat(k,216) = .200_r8*rxt(k,382)*y(k,217)
         mat(k,482) = .500_r8*rxt(k,393)*y(k,217)
         mat(k,841) = .570_r8*rxt(k,485)*y(k,132)
         mat(k,1234) = .280_r8*rxt(k,394)*y(k,132)
         mat(k,226) = rxt(k,430)*y(k,217)
         mat(k,756) = rxt(k,431)*y(k,217)
         mat(k,1778) = mat(k,1778) + rxt(k,424)*y(k,99) + rxt(k,400)*y(k,186) &
                      + rxt(k,442)*y(k,187) + rxt(k,447)*y(k,188) + rxt(k,325) &
                      *y(k,189) + rxt(k,353)*y(k,190) + rxt(k,306)*y(k,193) &
                      + .170_r8*rxt(k,453)*y(k,194) + rxt(k,371)*y(k,196) &
                      + .250_r8*rxt(k,340)*y(k,198) + rxt(k,315)*y(k,200) &
                      + .920_r8*rxt(k,410)*y(k,201) + .920_r8*rxt(k,416)*y(k,202) &
                      + .470_r8*rxt(k,378)*y(k,203) + .400_r8*rxt(k,456)*y(k,204) &
                      + .830_r8*rxt(k,459)*y(k,206) + rxt(k,462)*y(k,219) + rxt(k,361) &
                      *y(k,220) + .900_r8*rxt(k,494)*y(k,222) + .800_r8*rxt(k,499) &
                      *y(k,223) + rxt(k,469)*y(k,224) + rxt(k,435)*y(k,225) &
                      + rxt(k,475)*y(k,226) + rxt(k,478)*y(k,227)
         mat(k,2097) = mat(k,2097) + rxt(k,300)*y(k,41) + rxt(k,425)*y(k,99) &
                      + rxt(k,411)*y(k,201) + rxt(k,417)*y(k,202) + .470_r8*rxt(k,377) &
                      *y(k,203) + rxt(k,206)*y(k,217) + rxt(k,436)*y(k,225)
         mat(k,1501) = mat(k,1501) + rxt(k,301)*y(k,41) + rxt(k,176)*y(k,77)
         mat(k,1413) = rxt(k,180)*y(k,74) + rxt(k,342)*y(k,197)
         mat(k,1882) = mat(k,1882) + .570_r8*rxt(k,482)*y(k,5) + .130_r8*rxt(k,321) &
                      *y(k,24) + .280_r8*rxt(k,350)*y(k,28) + .370_r8*rxt(k,427) &
                      *y(k,96) + .140_r8*rxt(k,380)*y(k,103) + .570_r8*rxt(k,485) &
                      *y(k,108) + .280_r8*rxt(k,394)*y(k,109) + rxt(k,188)*y(k,217)
         mat(k,101) = .800_r8*rxt(k,463)*y(k,217)
         mat(k,917) = rxt(k,516)*y(k,217)
         mat(k,974) = .200_r8*rxt(k,503)*y(k,217)
         mat(k,119) = .280_r8*rxt(k,471)*y(k,217)
         mat(k,149) = .380_r8*rxt(k,473)*y(k,217)
         mat(k,154) = .630_r8*rxt(k,479)*y(k,217)
         mat(k,905) = mat(k,905) + rxt(k,400)*y(k,121)
         mat(k,388) = mat(k,388) + rxt(k,442)*y(k,121)
         mat(k,326) = mat(k,326) + rxt(k,447)*y(k,121)
         mat(k,817) = mat(k,817) + rxt(k,325)*y(k,121) + 2.400_r8*rxt(k,322)*y(k,189) &
                      + rxt(k,323)*y(k,193)
         mat(k,732) = mat(k,732) + rxt(k,353)*y(k,121) + rxt(k,351)*y(k,193)
         mat(k,1285) = mat(k,1285) + rxt(k,421)*y(k,99) + .900_r8*rxt(k,334)*y(k,193) &
                      + rxt(k,407)*y(k,201) + rxt(k,412)*y(k,202) + .470_r8*rxt(k,374) &
                      *y(k,203) + rxt(k,432)*y(k,225)
         mat(k,1381) = mat(k,1381) + rxt(k,226)*y(k,58) + 1.200_r8*rxt(k,422)*y(k,99) &
                      + rxt(k,306)*y(k,121) + rxt(k,323)*y(k,189) + rxt(k,351) &
                      *y(k,190) + .900_r8*rxt(k,334)*y(k,192) + 4.000_r8*rxt(k,303) &
                      *y(k,193) + rxt(k,408)*y(k,201) + rxt(k,413)*y(k,202) &
                      + .730_r8*rxt(k,375)*y(k,203) + rxt(k,384)*y(k,205) &
                      + .500_r8*rxt(k,487)*y(k,212) + .300_r8*rxt(k,363)*y(k,221) &
                      + rxt(k,492)*y(k,222) + rxt(k,497)*y(k,223) + .800_r8*rxt(k,433) &
                      *y(k,225)
         mat(k,647) = mat(k,647) + .170_r8*rxt(k,453)*y(k,121) + .070_r8*rxt(k,452) &
                      *y(k,199)
         mat(k,475) = rxt(k,371)*y(k,121)
         mat(k,347) = rxt(k,342)*y(k,131)
         mat(k,675) = mat(k,675) + .250_r8*rxt(k,340)*y(k,121)
         mat(k,2039) = mat(k,2039) + .070_r8*rxt(k,452)*y(k,194) + .160_r8*rxt(k,455) &
                      *y(k,204) + .330_r8*rxt(k,458)*y(k,206)
         mat(k,332) = mat(k,332) + rxt(k,315)*y(k,121)
         mat(k,1190) = mat(k,1190) + .920_r8*rxt(k,410)*y(k,121) + rxt(k,411)*y(k,123) &
                      + rxt(k,407)*y(k,192) + rxt(k,408)*y(k,193)
         mat(k,1162) = mat(k,1162) + .920_r8*rxt(k,416)*y(k,121) + rxt(k,417)*y(k,123) &
                      + rxt(k,412)*y(k,192) + rxt(k,413)*y(k,193)
         mat(k,1212) = mat(k,1212) + .470_r8*rxt(k,378)*y(k,121) + .470_r8*rxt(k,377) &
                      *y(k,123) + .470_r8*rxt(k,374)*y(k,192) + .730_r8*rxt(k,375) &
                      *y(k,193)
         mat(k,607) = mat(k,607) + .400_r8*rxt(k,456)*y(k,121) + .160_r8*rxt(k,455) &
                      *y(k,199)
         mat(k,1252) = mat(k,1252) + rxt(k,384)*y(k,193)
         mat(k,984) = mat(k,984) + .830_r8*rxt(k,459)*y(k,121) + .330_r8*rxt(k,458) &
                      *y(k,199)
         mat(k,964) = mat(k,964) + .500_r8*rxt(k,487)*y(k,193)
         mat(k,1649) = mat(k,1649) + .650_r8*rxt(k,440)*y(k,6) + rxt(k,267)*y(k,18) &
                      + .350_r8*rxt(k,319)*y(k,23) + rxt(k,326)*y(k,25) + rxt(k,332) &
                      *y(k,46) + rxt(k,307)*y(k,51) + rxt(k,237)*y(k,58) + rxt(k,310) &
                      *y(k,61) + .730_r8*rxt(k,451)*y(k,65) + .500_r8*rxt(k,521) &
                      *y(k,66) + rxt(k,343)*y(k,72) + rxt(k,344)*y(k,73) + rxt(k,185) &
                      *y(k,77) + rxt(k,311)*y(k,84) + rxt(k,312)*y(k,85) + rxt(k,373) &
                      *y(k,91) + rxt(k,358)*y(k,93) + .300_r8*rxt(k,418)*y(k,97) &
                      + rxt(k,419)*y(k,98) + rxt(k,426)*y(k,100) + .200_r8*rxt(k,382) &
                      *y(k,104) + .500_r8*rxt(k,393)*y(k,107) + rxt(k,430)*y(k,113) &
                      + rxt(k,431)*y(k,114) + rxt(k,206)*y(k,123) + rxt(k,188) &
                      *y(k,132) + .800_r8*rxt(k,463)*y(k,140) + rxt(k,516)*y(k,149) &
                      + .200_r8*rxt(k,503)*y(k,175) + .280_r8*rxt(k,471)*y(k,177) &
                      + .380_r8*rxt(k,473)*y(k,179) + .630_r8*rxt(k,479)*y(k,181)
         mat(k,339) = mat(k,339) + rxt(k,462)*y(k,121)
         mat(k,720) = mat(k,720) + rxt(k,361)*y(k,121)
         mat(k,1044) = mat(k,1044) + .300_r8*rxt(k,363)*y(k,193)
         mat(k,1006) = mat(k,1006) + .900_r8*rxt(k,494)*y(k,121) + rxt(k,492)*y(k,193)
         mat(k,881) = mat(k,881) + .800_r8*rxt(k,499)*y(k,121) + rxt(k,497)*y(k,193)
         mat(k,622) = mat(k,622) + rxt(k,469)*y(k,121)
         mat(k,1083) = mat(k,1083) + rxt(k,435)*y(k,121) + rxt(k,436)*y(k,123) &
                      + rxt(k,432)*y(k,192) + .800_r8*rxt(k,433)*y(k,193)
         mat(k,639) = mat(k,639) + rxt(k,475)*y(k,121)
         mat(k,403) = mat(k,403) + rxt(k,478)*y(k,121)
      end do
      end subroutine nlnmat08
      subroutine nlnmat09( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,327) = -(rxt(k,313)*y(k,199) + rxt(k,315)*y(k,121))
         mat(k,1964) = -rxt(k,313)*y(k,200)
         mat(k,1707) = -rxt(k,315)*y(k,200)
         mat(k,1416) = rxt(k,299)*y(k,199)
         mat(k,1964) = mat(k,1964) + rxt(k,299)*y(k,41)
         mat(k,1178) = -(rxt(k,407)*y(k,192) + rxt(k,408)*y(k,193) + rxt(k,409) &
                      *y(k,199) + rxt(k,410)*y(k,121) + rxt(k,411)*y(k,123))
         mat(k,1272) = -rxt(k,407)*y(k,201)
         mat(k,1366) = -rxt(k,408)*y(k,201)
         mat(k,2019) = -rxt(k,409)*y(k,201)
         mat(k,1759) = -rxt(k,410)*y(k,201)
         mat(k,2077) = -rxt(k,411)*y(k,201)
         mat(k,791) = .600_r8*rxt(k,428)*y(k,217)
         mat(k,1628) = .600_r8*rxt(k,428)*y(k,96)
         mat(k,1150) = -(rxt(k,412)*y(k,192) + rxt(k,413)*y(k,193) + rxt(k,414) &
                      *y(k,199) + rxt(k,416)*y(k,121) + rxt(k,417)*y(k,123))
         mat(k,1271) = -rxt(k,412)*y(k,202)
         mat(k,1365) = -rxt(k,413)*y(k,202)
         mat(k,2018) = -rxt(k,414)*y(k,202)
         mat(k,1758) = -rxt(k,416)*y(k,202)
         mat(k,2076) = -rxt(k,417)*y(k,202)
         mat(k,790) = .400_r8*rxt(k,428)*y(k,217)
         mat(k,1627) = .400_r8*rxt(k,428)*y(k,96)
         mat(k,1203) = -(rxt(k,374)*y(k,192) + rxt(k,375)*y(k,193) + rxt(k,376) &
                      *y(k,199) + rxt(k,377)*y(k,123) + (rxt(k,378) + rxt(k,379) &
                      ) * y(k,121))
         mat(k,1273) = -rxt(k,374)*y(k,203)
         mat(k,1367) = -rxt(k,375)*y(k,203)
         mat(k,2020) = -rxt(k,376)*y(k,203)
         mat(k,2078) = -rxt(k,377)*y(k,203)
         mat(k,1760) = -(rxt(k,378) + rxt(k,379)) * y(k,203)
         mat(k,1114) = .500_r8*rxt(k,381)*y(k,217)
         mat(k,213) = .200_r8*rxt(k,382)*y(k,217)
         mat(k,1222) = rxt(k,395)*y(k,217)
         mat(k,1629) = .500_r8*rxt(k,381)*y(k,103) + .200_r8*rxt(k,382)*y(k,104) &
                      + rxt(k,395)*y(k,109)
         mat(k,602) = -(rxt(k,455)*y(k,199) + rxt(k,456)*y(k,121) + rxt(k,457) &
                      *y(k,122))
         mat(k,1986) = -rxt(k,455)*y(k,204)
         mat(k,1724) = -rxt(k,456)*y(k,204)
         mat(k,1791) = -rxt(k,457)*y(k,204)
         mat(k,1243) = -(rxt(k,383)*y(k,192) + rxt(k,384)*y(k,193) + rxt(k,385) &
                      *y(k,199) + 4._r8*rxt(k,386)*y(k,205) + rxt(k,387)*y(k,121) &
                      + rxt(k,388)*y(k,123) + rxt(k,396)*y(k,122))
         mat(k,1275) = -rxt(k,383)*y(k,205)
         mat(k,1369) = -rxt(k,384)*y(k,205)
         mat(k,2022) = -rxt(k,385)*y(k,205)
         mat(k,1762) = -rxt(k,387)*y(k,205)
         mat(k,2080) = -rxt(k,388)*y(k,205)
         mat(k,1802) = -rxt(k,396)*y(k,205)
         mat(k,1115) = .500_r8*rxt(k,381)*y(k,217)
         mat(k,214) = .500_r8*rxt(k,382)*y(k,217)
         mat(k,1631) = .500_r8*rxt(k,381)*y(k,103) + .500_r8*rxt(k,382)*y(k,104)
         mat(k,977) = -(rxt(k,458)*y(k,199) + rxt(k,459)*y(k,121) + rxt(k,460) &
                      *y(k,122))
         mat(k,2006) = -rxt(k,458)*y(k,206)
         mat(k,1746) = -rxt(k,459)*y(k,206)
         mat(k,1798) = -rxt(k,460)*y(k,206)
         mat(k,565) = -(rxt(k,389)*y(k,199) + rxt(k,390)*y(k,121))
         mat(k,1983) = -rxt(k,389)*y(k,207)
         mat(k,1723) = -rxt(k,390)*y(k,207)
         mat(k,411) = rxt(k,391)*y(k,217)
         mat(k,218) = rxt(k,392)*y(k,217)
         mat(k,1581) = rxt(k,391)*y(k,105) + rxt(k,392)*y(k,106)
         mat(k,427) = -(rxt(k,193)*y(k,130) + rxt(k,194)*y(k,131))
         mat(k,1468) = -rxt(k,193)*y(k,208)
         mat(k,1389) = -rxt(k,194)*y(k,208)
         mat(k,1468) = mat(k,1468) + rxt(k,564)*y(k,209)
         mat(k,692) = .900_r8*rxt(k,562)*y(k,209) + .800_r8*rxt(k,560)*y(k,210)
         mat(k,541) = rxt(k,564)*y(k,130) + .900_r8*rxt(k,562)*y(k,195)
         mat(k,684) = .800_r8*rxt(k,560)*y(k,195)
         mat(k,543) = -(rxt(k,562)*y(k,195) + rxt(k,563)*y(k,131) + (rxt(k,564) &
                      + rxt(k,565)) * y(k,130))
         mat(k,693) = -rxt(k,562)*y(k,209)
         mat(k,1391) = -rxt(k,563)*y(k,209)
         mat(k,1472) = -(rxt(k,564) + rxt(k,565)) * y(k,209)
         mat(k,685) = -(rxt(k,560)*y(k,195))
         mat(k,695) = -rxt(k,560)*y(k,210)
         mat(k,737) = rxt(k,569)*y(k,216)
         mat(k,1730) = rxt(k,571)*y(k,216)
         mat(k,1476) = rxt(k,564)*y(k,209)
         mat(k,1394) = rxt(k,568)*y(k,211)
         mat(k,545) = rxt(k,564)*y(k,130)
         mat(k,392) = rxt(k,568)*y(k,131)
         mat(k,677) = rxt(k,569)*y(k,110) + rxt(k,571)*y(k,121)
         mat(k,389) = -(rxt(k,566)*y(k,130) + (rxt(k,567) + rxt(k,568)) * y(k,131))
         mat(k,1467) = -rxt(k,566)*y(k,211)
         mat(k,1388) = -(rxt(k,567) + rxt(k,568)) * y(k,211)
         mat(k,955) = -(rxt(k,487)*y(k,193) + rxt(k,488)*y(k,199) + rxt(k,489) &
                      *y(k,121) + rxt(k,490)*y(k,123))
         mat(k,1352) = -rxt(k,487)*y(k,212)
         mat(k,2004) = -rxt(k,488)*y(k,212)
         mat(k,1744) = -rxt(k,489)*y(k,212)
         mat(k,2062) = -rxt(k,490)*y(k,212)
         mat(k,858) = rxt(k,481)*y(k,123)
         mat(k,832) = rxt(k,484)*y(k,123)
         mat(k,2062) = mat(k,2062) + rxt(k,481)*y(k,5) + rxt(k,484)*y(k,108) &
                      + .500_r8*rxt(k,501)*y(k,174)
         mat(k,229) = rxt(k,491)*y(k,217)
         mat(k,883) = .500_r8*rxt(k,501)*y(k,123)
         mat(k,1612) = rxt(k,491)*y(k,125)
         mat(k,1668) = -(rxt(k,158)*y(k,75) + rxt(k,159)*y(k,228) + (rxt(k,161) &
                      + rxt(k,162)) * y(k,131) + rxt(k,163)*y(k,132) + (rxt(k,251) &
                      + rxt(k,252)) * y(k,83) + (rxt(k,274) + rxt(k,275)) * y(k,79) &
                      + rxt(k,280)*y(k,63) + rxt(k,281)*y(k,64) + rxt(k,316)*y(k,84))
         mat(k,1063) = -rxt(k,158)*y(k,213)
         mat(k,2136) = -rxt(k,159)*y(k,213)
         mat(k,1407) = -(rxt(k,161) + rxt(k,162)) * y(k,213)
         mat(k,1875) = -rxt(k,163)*y(k,213)
         mat(k,1316) = -(rxt(k,251) + rxt(k,252)) * y(k,213)
         mat(k,762) = -(rxt(k,274) + rxt(k,275)) * y(k,213)
         mat(k,62) = -rxt(k,280)*y(k,213)
         mat(k,134) = -rxt(k,281)*y(k,213)
         mat(k,106) = -rxt(k,316)*y(k,213)
         mat(k,1407) = mat(k,1407) + rxt(k,194)*y(k,208)
         mat(k,701) = .850_r8*rxt(k,561)*y(k,216)
         mat(k,430) = rxt(k,194)*y(k,131)
         mat(k,682) = .850_r8*rxt(k,561)*y(k,195)
         mat(k,77) = -(rxt(k,165)*y(k,130) + rxt(k,166)*y(k,131))
         mat(k,1464) = -rxt(k,165)*y(k,214)
         mat(k,1385) = -rxt(k,166)*y(k,214)
         mat(k,1464) = mat(k,1464) + rxt(k,169)*y(k,215)
         mat(k,1385) = mat(k,1385) + rxt(k,170)*y(k,215)
         mat(k,1829) = rxt(k,171)*y(k,215)
         mat(k,79) = rxt(k,169)*y(k,130) + rxt(k,170)*y(k,131) + rxt(k,171)*y(k,132)
         mat(k,80) = -(rxt(k,169)*y(k,130) + rxt(k,170)*y(k,131) + rxt(k,171)*y(k,132))
         mat(k,1465) = -rxt(k,169)*y(k,215)
         mat(k,1386) = -rxt(k,170)*y(k,215)
         mat(k,1830) = -rxt(k,171)*y(k,215)
         mat(k,1386) = mat(k,1386) + rxt(k,161)*y(k,213)
         mat(k,1654) = rxt(k,161)*y(k,131)
         mat(k,676) = -(rxt(k,561)*y(k,195) + rxt(k,569)*y(k,110) + rxt(k,571) &
                      *y(k,121))
         mat(k,694) = -rxt(k,561)*y(k,216)
         mat(k,736) = -rxt(k,569)*y(k,216)
         mat(k,1729) = -rxt(k,571)*y(k,216)
         mat(k,1393) = rxt(k,563)*y(k,209) + rxt(k,567)*y(k,211) + rxt(k,574)*y(k,218)
         mat(k,544) = rxt(k,563)*y(k,131)
         mat(k,391) = rxt(k,567)*y(k,131)
         mat(k,512) = rxt(k,574)*y(k,131)
         mat(k,1641) = -(rxt(k,184)*y(k,75) + rxt(k,185)*y(k,77) + rxt(k,186)*y(k,199) &
                      + rxt(k,187)*y(k,130) + rxt(k,188)*y(k,132) + (4._r8*rxt(k,189) &
                      + 4._r8*rxt(k,190)) * y(k,217) + rxt(k,192)*y(k,88) + rxt(k,206) &
                      *y(k,123) + rxt(k,207)*y(k,110) + rxt(k,215)*y(k,122) + rxt(k,216) &
                      *y(k,87) + rxt(k,235)*y(k,59) + (rxt(k,237) + rxt(k,238) &
                      ) * y(k,58) + rxt(k,240)*y(k,83) + rxt(k,243)*y(k,90) + rxt(k,267) &
                      *y(k,18) + rxt(k,269)*y(k,79) + rxt(k,302)*y(k,41) + rxt(k,307) &
                      *y(k,51) + rxt(k,308)*y(k,52) + (rxt(k,310) + rxt(k,317) &
                      ) * y(k,61) + rxt(k,311)*y(k,84) + rxt(k,312)*y(k,85) + rxt(k,319) &
                      *y(k,23) + rxt(k,326)*y(k,25) + rxt(k,327)*y(k,26) + rxt(k,329) &
                      *y(k,27) + rxt(k,331)*y(k,44) + rxt(k,332)*y(k,46) + rxt(k,337) &
                      *y(k,49) + rxt(k,338)*y(k,50) + rxt(k,343)*y(k,72) + rxt(k,344) &
                      *y(k,73) + rxt(k,345)*y(k,137) + rxt(k,346)*y(k,24) + rxt(k,354) &
                      *y(k,29) + rxt(k,355)*y(k,30) + rxt(k,357)*y(k,48) + rxt(k,358) &
                      *y(k,93) + rxt(k,359)*y(k,124) + rxt(k,362)*y(k,144) + rxt(k,366) &
                      *y(k,145) + rxt(k,367)*y(k,28) + rxt(k,368)*y(k,47) + rxt(k,370) &
                      *y(k,15) + rxt(k,373)*y(k,91) + rxt(k,381)*y(k,103) + rxt(k,382) &
                      *y(k,104) + rxt(k,391)*y(k,105) + rxt(k,392)*y(k,106) + rxt(k,393) &
                      *y(k,107) + rxt(k,395)*y(k,109) + rxt(k,398)*y(k,1) + rxt(k,402) &
                      *y(k,2) + rxt(k,403)*y(k,14) + rxt(k,404)*y(k,92) + rxt(k,405) &
                      *y(k,94) + rxt(k,406)*y(k,95) + rxt(k,418)*y(k,97) + rxt(k,419) &
                      *y(k,98) + rxt(k,426)*y(k,100) + rxt(k,428)*y(k,96) + rxt(k,429) &
                      *y(k,101) + rxt(k,430)*y(k,113) + rxt(k,431)*y(k,114) + rxt(k,437) &
                      *y(k,178) + rxt(k,440)*y(k,6) + rxt(k,443)*y(k,7) + rxt(k,444) &
                      *y(k,21) + rxt(k,446)*y(k,22) + rxt(k,450)*y(k,31) + rxt(k,451) &
                      *y(k,65) + rxt(k,463)*y(k,140) + rxt(k,466)*y(k,141) + rxt(k,470) &
                      *y(k,176) + rxt(k,471)*y(k,177) + rxt(k,473)*y(k,179) + rxt(k,476) &
                      *y(k,180) + rxt(k,479)*y(k,181) + rxt(k,480)*y(k,182) + rxt(k,483) &
                      *y(k,5) + rxt(k,486)*y(k,108) + rxt(k,491)*y(k,125) + rxt(k,495) &
                      *y(k,171) + rxt(k,496)*y(k,172) + rxt(k,500)*y(k,173) + rxt(k,502) &
                      *y(k,174) + rxt(k,503)*y(k,175) + rxt(k,505)*y(k,135) + rxt(k,510) &
                      *y(k,146) + rxt(k,515)*y(k,148) + rxt(k,516)*y(k,149) + (rxt(k,519) &
                      + rxt(k,521)) * y(k,66) + rxt(k,520)*y(k,118))
         mat(k,1062) = -rxt(k,184)*y(k,217)
         mat(k,507) = -rxt(k,185)*y(k,217)
         mat(k,2031) = -rxt(k,186)*y(k,217)
         mat(k,1493) = -rxt(k,187)*y(k,217)
         mat(k,1874) = -rxt(k,188)*y(k,217)
         mat(k,368) = -rxt(k,192)*y(k,217)
         mat(k,2089) = -rxt(k,206)*y(k,217)
         mat(k,743) = -rxt(k,207)*y(k,217)
         mat(k,1812) = -rxt(k,215)*y(k,217)
         mat(k,1689) = -rxt(k,216)*y(k,217)
         mat(k,924) = -rxt(k,235)*y(k,217)
         mat(k,1936) = -(rxt(k,237) + rxt(k,238)) * y(k,217)
         mat(k,1315) = -rxt(k,240)*y(k,217)
         mat(k,769) = -rxt(k,243)*y(k,217)
         mat(k,1452) = -rxt(k,267)*y(k,217)
         mat(k,761) = -rxt(k,269)*y(k,217)
         mat(k,1428) = -rxt(k,302)*y(k,217)
         mat(k,705) = -rxt(k,307)*y(k,217)
         mat(k,310) = -rxt(k,308)*y(k,217)
         mat(k,1024) = -(rxt(k,310) + rxt(k,317)) * y(k,217)
         mat(k,105) = -rxt(k,311)*y(k,217)
         mat(k,708) = -rxt(k,312)*y(k,217)
         mat(k,204) = -rxt(k,319)*y(k,217)
         mat(k,179) = -rxt(k,326)*y(k,217)
         mat(k,256) = -rxt(k,327)*y(k,217)
         mat(k,209) = -rxt(k,329)*y(k,217)
         mat(k,1050) = -rxt(k,331)*y(k,217)
         mat(k,54) = -rxt(k,332)*y(k,217)
         mat(k,466) = -rxt(k,337)*y(k,217)
         mat(k,408) = -rxt(k,338)*y(k,217)
         mat(k,989) = -rxt(k,343)*y(k,217)
         mat(k,804) = -rxt(k,344)*y(k,217)
         mat(k,359) = -rxt(k,345)*y(k,217)
         mat(k,453) = -rxt(k,346)*y(k,217)
         mat(k,304) = -rxt(k,354)*y(k,217)
         mat(k,58) = -rxt(k,355)*y(k,217)
         mat(k,1126) = -rxt(k,357)*y(k,217)
         mat(k,1031) = -rxt(k,358)*y(k,217)
         mat(k,777) = -rxt(k,359)*y(k,217)
         mat(k,437) = -rxt(k,362)*y(k,217)
         mat(k,299) = -rxt(k,366)*y(k,217)
         mat(k,944) = -rxt(k,367)*y(k,217)
         mat(k,910) = -rxt(k,368)*y(k,217)
         mat(k,274) = -rxt(k,370)*y(k,217)
         mat(k,1019) = -rxt(k,373)*y(k,217)
         mat(k,1118) = -rxt(k,381)*y(k,217)
         mat(k,215) = -rxt(k,382)*y(k,217)
         mat(k,414) = -rxt(k,391)*y(k,217)
         mat(k,221) = -rxt(k,392)*y(k,217)
         mat(k,480) = -rxt(k,393)*y(k,217)
         mat(k,1229) = -rxt(k,395)*y(k,217)
         mat(k,561) = -rxt(k,398)*y(k,217)
         mat(k,539) = -rxt(k,402)*y(k,217)
         mat(k,165) = -rxt(k,403)*y(k,217)
         mat(k,161) = -rxt(k,404)*y(k,217)
         mat(k,260) = -rxt(k,405)*y(k,217)
         mat(k,71) = -rxt(k,406)*y(k,217)
         mat(k,461) = -rxt(k,418)*y(k,217)
         mat(k,353) = -rxt(k,419)*y(k,217)
         mat(k,292) = -rxt(k,426)*y(k,217)
         mat(k,796) = -rxt(k,428)*y(k,217)
         mat(k,578) = -rxt(k,429)*y(k,217)
         mat(k,225) = -rxt(k,430)*y(k,217)
         mat(k,754) = -rxt(k,431)*y(k,217)
         mat(k,131) = -rxt(k,437)*y(k,217)
         mat(k,91) = -rxt(k,440)*y(k,217)
         mat(k,281) = -rxt(k,443)*y(k,217)
         mat(k,171) = -rxt(k,444)*y(k,217)
         mat(k,251) = -rxt(k,446)*y(k,217)
         mat(k,184) = -rxt(k,450)*y(k,217)
         mat(k,123) = -rxt(k,451)*y(k,217)
         mat(k,100) = -rxt(k,463)*y(k,217)
         mat(k,245) = -rxt(k,466)*y(k,217)
         mat(k,502) = -rxt(k,470)*y(k,217)
         mat(k,118) = -rxt(k,471)*y(k,217)
         mat(k,148) = -rxt(k,473)*y(k,217)
         mat(k,593) = -rxt(k,476)*y(k,217)
         mat(k,153) = -rxt(k,479)*y(k,217)
         mat(k,317) = -rxt(k,480)*y(k,217)
         mat(k,865) = -rxt(k,483)*y(k,217)
         mat(k,839) = -rxt(k,486)*y(k,217)
         mat(k,230) = -rxt(k,491)*y(k,217)
         mat(k,491) = -rxt(k,495)*y(k,217)
         mat(k,417) = -rxt(k,496)*y(k,217)
         mat(k,378) = -rxt(k,500)*y(k,217)
         mat(k,887) = -rxt(k,502)*y(k,217)
         mat(k,973) = -rxt(k,503)*y(k,217)
         mat(k,267) = -rxt(k,505)*y(k,217)
         mat(k,599) = -rxt(k,510)*y(k,217)
         mat(k,1297) = -rxt(k,515)*y(k,217)
         mat(k,916) = -rxt(k,516)*y(k,217)
         mat(k,193) = -(rxt(k,519) + rxt(k,521)) * y(k,217)
         mat(k,51) = -rxt(k,520)*y(k,217)
         mat(k,865) = mat(k,865) + .630_r8*rxt(k,482)*y(k,132)
         mat(k,204) = mat(k,204) + .650_r8*rxt(k,319)*y(k,217)
         mat(k,453) = mat(k,453) + .130_r8*rxt(k,321)*y(k,132)
         mat(k,256) = mat(k,256) + .500_r8*rxt(k,327)*y(k,217)
         mat(k,944) = mat(k,944) + .360_r8*rxt(k,350)*y(k,132)
         mat(k,1428) = mat(k,1428) + rxt(k,301)*y(k,130)
         mat(k,310) = mat(k,310) + .300_r8*rxt(k,308)*y(k,217)
         mat(k,1909) = rxt(k,224)*y(k,199)
         mat(k,661) = rxt(k,278)*y(k,228)
         mat(k,2109) = rxt(k,183)*y(k,132) + 2.000_r8*rxt(k,178)*y(k,199)
         mat(k,1062) = mat(k,1062) + rxt(k,175)*y(k,130) + rxt(k,158)*y(k,213)
         mat(k,507) = mat(k,507) + rxt(k,176)*y(k,130)
         mat(k,761) = mat(k,761) + rxt(k,268)*y(k,130) + rxt(k,274)*y(k,213)
         mat(k,1315) = mat(k,1315) + rxt(k,239)*y(k,130) + rxt(k,251)*y(k,213)
         mat(k,105) = mat(k,105) + rxt(k,316)*y(k,213)
         mat(k,654) = rxt(k,270)*y(k,130)
         mat(k,769) = mat(k,769) + rxt(k,242)*y(k,130)
         mat(k,796) = mat(k,796) + .320_r8*rxt(k,427)*y(k,132)
         mat(k,578) = mat(k,578) + .600_r8*rxt(k,429)*y(k,217)
         mat(k,1118) = mat(k,1118) + .240_r8*rxt(k,380)*y(k,132)
         mat(k,215) = mat(k,215) + .100_r8*rxt(k,382)*y(k,217)
         mat(k,839) = mat(k,839) + .630_r8*rxt(k,485)*y(k,132)
         mat(k,1229) = mat(k,1229) + .360_r8*rxt(k,394)*y(k,132)
         mat(k,1770) = rxt(k,208)*y(k,199)
         mat(k,2089) = mat(k,2089) + rxt(k,203)*y(k,199)
         mat(k,1493) = mat(k,1493) + rxt(k,301)*y(k,41) + rxt(k,175)*y(k,75) &
                      + rxt(k,176)*y(k,77) + rxt(k,268)*y(k,79) + rxt(k,239)*y(k,83) &
                      + rxt(k,270)*y(k,89) + rxt(k,242)*y(k,90) + rxt(k,181)*y(k,199)
         mat(k,1874) = mat(k,1874) + .630_r8*rxt(k,482)*y(k,5) + .130_r8*rxt(k,321) &
                      *y(k,24) + .360_r8*rxt(k,350)*y(k,28) + rxt(k,183)*y(k,74) &
                      + .320_r8*rxt(k,427)*y(k,96) + .240_r8*rxt(k,380)*y(k,103) &
                      + .630_r8*rxt(k,485)*y(k,108) + .360_r8*rxt(k,394)*y(k,109) &
                      + rxt(k,182)*y(k,199)
         mat(k,437) = mat(k,437) + .500_r8*rxt(k,362)*y(k,217)
         mat(k,131) = mat(k,131) + .500_r8*rxt(k,437)*y(k,217)
         mat(k,423) = .400_r8*rxt(k,438)*y(k,199)
         mat(k,1280) = .450_r8*rxt(k,335)*y(k,199)
         mat(k,644) = .400_r8*rxt(k,452)*y(k,199)
         mat(k,2031) = mat(k,2031) + rxt(k,224)*y(k,55) + 2.000_r8*rxt(k,178)*y(k,74) &
                      + rxt(k,208)*y(k,121) + rxt(k,203)*y(k,123) + rxt(k,181) &
                      *y(k,130) + rxt(k,182)*y(k,132) + .400_r8*rxt(k,438)*y(k,185) &
                      + .450_r8*rxt(k,335)*y(k,192) + .400_r8*rxt(k,452)*y(k,194) &
                      + .450_r8*rxt(k,385)*y(k,205) + .400_r8*rxt(k,458)*y(k,206) &
                      + .200_r8*rxt(k,389)*y(k,207) + .150_r8*rxt(k,364)*y(k,221)
         mat(k,1247) = .450_r8*rxt(k,385)*y(k,199)
         mat(k,981) = .400_r8*rxt(k,458)*y(k,199)
         mat(k,568) = .200_r8*rxt(k,389)*y(k,199)
         mat(k,1667) = rxt(k,158)*y(k,75) + rxt(k,274)*y(k,79) + rxt(k,251)*y(k,83) &
                      + rxt(k,316)*y(k,84) + 2.000_r8*rxt(k,159)*y(k,228)
         mat(k,1641) = mat(k,1641) + .650_r8*rxt(k,319)*y(k,23) + .500_r8*rxt(k,327) &
                      *y(k,26) + .300_r8*rxt(k,308)*y(k,52) + .600_r8*rxt(k,429) &
                      *y(k,101) + .100_r8*rxt(k,382)*y(k,104) + .500_r8*rxt(k,362) &
                      *y(k,144) + .500_r8*rxt(k,437)*y(k,178)
         mat(k,1041) = .150_r8*rxt(k,364)*y(k,199)
         mat(k,2135) = rxt(k,278)*y(k,71) + 2.000_r8*rxt(k,159)*y(k,213)
      end do
      end subroutine nlnmat09
      subroutine nlnmat10( avec_len, mat, y, rxt )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k,511) = -(rxt(k,574)*y(k,131))
         mat(k,1390) = -rxt(k,574)*y(k,218)
         mat(k,1471) = rxt(k,565)*y(k,209) + rxt(k,566)*y(k,211)
         mat(k,542) = rxt(k,565)*y(k,130)
         mat(k,390) = rxt(k,566)*y(k,130)
         mat(k,334) = -(rxt(k,461)*y(k,199) + rxt(k,462)*y(k,121))
         mat(k,1965) = -rxt(k,461)*y(k,219)
         mat(k,1708) = -rxt(k,462)*y(k,219)
         mat(k,121) = .200_r8*rxt(k,451)*y(k,217)
         mat(k,98) = .140_r8*rxt(k,463)*y(k,217)
         mat(k,243) = rxt(k,466)*y(k,217)
         mat(k,1555) = .200_r8*rxt(k,451)*y(k,65) + .140_r8*rxt(k,463)*y(k,140) &
                      + rxt(k,466)*y(k,141)
         mat(k,712) = -(rxt(k,360)*y(k,199) + rxt(k,361)*y(k,121))
         mat(k,1993) = -rxt(k,360)*y(k,220)
         mat(k,1733) = -rxt(k,361)*y(k,220)
         mat(k,933) = rxt(k,367)*y(k,217)
         mat(k,433) = .500_r8*rxt(k,362)*y(k,217)
         mat(k,1593) = rxt(k,367)*y(k,28) + .500_r8*rxt(k,362)*y(k,144)
         mat(k,1036) = -(rxt(k,363)*y(k,193) + rxt(k,364)*y(k,199) + rxt(k,365) &
                      *y(k,121))
         mat(k,1359) = -rxt(k,363)*y(k,221)
         mat(k,2011) = -rxt(k,364)*y(k,221)
         mat(k,1752) = -rxt(k,365)*y(k,221)
         mat(k,861) = .060_r8*rxt(k,482)*y(k,132)
         mat(k,907) = rxt(k,368)*y(k,217)
         mat(k,835) = .060_r8*rxt(k,485)*y(k,132)
         mat(k,1856) = .060_r8*rxt(k,482)*y(k,5) + .060_r8*rxt(k,485)*y(k,108)
         mat(k,296) = rxt(k,366)*y(k,217)
         mat(k,969) = .150_r8*rxt(k,503)*y(k,217)
         mat(k,1620) = rxt(k,368)*y(k,47) + rxt(k,366)*y(k,145) + .150_r8*rxt(k,503) &
                      *y(k,175)
         mat(k,997) = -(rxt(k,492)*y(k,193) + rxt(k,493)*y(k,199) + rxt(k,494) &
                      *y(k,121))
         mat(k,1356) = -rxt(k,492)*y(k,222)
         mat(k,2008) = -rxt(k,493)*y(k,222)
         mat(k,1748) = -rxt(k,494)*y(k,222)
         mat(k,2066) = .500_r8*rxt(k,501)*y(k,174)
         mat(k,488) = rxt(k,495)*y(k,217)
         mat(k,885) = .500_r8*rxt(k,501)*y(k,123) + rxt(k,502)*y(k,217)
         mat(k,1616) = rxt(k,495)*y(k,171) + rxt(k,502)*y(k,174)
         mat(k,873) = -(rxt(k,497)*y(k,193) + rxt(k,498)*y(k,199) + rxt(k,499) &
                      *y(k,121))
         mat(k,1349) = -rxt(k,497)*y(k,223)
         mat(k,2000) = -rxt(k,498)*y(k,223)
         mat(k,1740) = -rxt(k,499)*y(k,223)
         mat(k,854) = rxt(k,483)*y(k,217)
         mat(k,828) = rxt(k,486)*y(k,217)
         mat(k,374) = rxt(k,500)*y(k,217)
         mat(k,1605) = rxt(k,483)*y(k,5) + rxt(k,486)*y(k,108) + rxt(k,500)*y(k,173)
         mat(k,613) = -(rxt(k,468)*y(k,199) + rxt(k,469)*y(k,121))
         mat(k,1987) = -rxt(k,468)*y(k,224)
         mat(k,1725) = -rxt(k,469)*y(k,224)
         mat(k,498) = rxt(k,470)*y(k,217)
         mat(k,117) = .650_r8*rxt(k,471)*y(k,217)
         mat(k,1586) = rxt(k,470)*y(k,176) + .650_r8*rxt(k,471)*y(k,177)
         mat(k,1075) = -(rxt(k,432)*y(k,192) + rxt(k,433)*y(k,193) + rxt(k,434) &
                      *y(k,199) + rxt(k,435)*y(k,121) + rxt(k,436)*y(k,123))
         mat(k,1267) = -rxt(k,432)*y(k,225)
         mat(k,1361) = -rxt(k,433)*y(k,225)
         mat(k,2014) = -rxt(k,434)*y(k,225)
         mat(k,1754) = -rxt(k,435)*y(k,225)
         mat(k,2072) = -rxt(k,436)*y(k,225)
         mat(k,160) = rxt(k,404)*y(k,217)
         mat(k,259) = rxt(k,405)*y(k,217)
         mat(k,70) = rxt(k,406)*y(k,217)
         mat(k,574) = .400_r8*rxt(k,429)*y(k,217)
         mat(k,130) = .500_r8*rxt(k,437)*y(k,217)
         mat(k,1623) = rxt(k,404)*y(k,92) + rxt(k,405)*y(k,94) + rxt(k,406)*y(k,95) &
                      + .400_r8*rxt(k,429)*y(k,101) + .500_r8*rxt(k,437)*y(k,178)
         mat(k,629) = -(rxt(k,474)*y(k,199) + rxt(k,475)*y(k,121))
         mat(k,1988) = -rxt(k,474)*y(k,226)
         mat(k,1726) = -rxt(k,475)*y(k,226)
         mat(k,145) = .560_r8*rxt(k,473)*y(k,217)
         mat(k,586) = rxt(k,476)*y(k,217)
         mat(k,1587) = .560_r8*rxt(k,473)*y(k,179) + rxt(k,476)*y(k,180)
         mat(k,397) = -(rxt(k,477)*y(k,199) + rxt(k,478)*y(k,121))
         mat(k,1972) = -rxt(k,477)*y(k,227)
         mat(k,1714) = -rxt(k,478)*y(k,227)
         mat(k,152) = .300_r8*rxt(k,479)*y(k,217)
         mat(k,314) = rxt(k,480)*y(k,217)
         mat(k,1563) = .300_r8*rxt(k,479)*y(k,181) + rxt(k,480)*y(k,182)
         mat(k,2146) = -(rxt(k,159)*y(k,213) + rxt(k,278)*y(k,71) + rxt(k,517) &
                      *y(k,150))
         mat(k,1678) = -rxt(k,159)*y(k,228)
         mat(k,665) = -rxt(k,278)*y(k,228)
         mat(k,176) = -rxt(k,517)*y(k,228)
         mat(k,211) = rxt(k,329)*y(k,217)
         mat(k,306) = rxt(k,354)*y(k,217)
         mat(k,59) = rxt(k,355)*y(k,217)
         mat(k,1439) = rxt(k,302)*y(k,217)
         mat(k,1055) = rxt(k,331)*y(k,217)
         mat(k,911) = rxt(k,368)*y(k,217)
         mat(k,1131) = rxt(k,357)*y(k,217)
         mat(k,467) = rxt(k,337)*y(k,217)
         mat(k,409) = rxt(k,338)*y(k,217)
         mat(k,312) = rxt(k,308)*y(k,217)
         mat(k,2120) = rxt(k,179)*y(k,199)
         mat(k,1068) = rxt(k,184)*y(k,217)
         mat(k,510) = rxt(k,185)*y(k,217)
         mat(k,764) = rxt(k,269)*y(k,217)
         mat(k,1323) = (rxt(k,551)+rxt(k,556))*y(k,89) + (rxt(k,544)+rxt(k,550) &
                       +rxt(k,555))*y(k,90) + rxt(k,240)*y(k,217)
         mat(k,710) = rxt(k,312)*y(k,217)
         mat(k,1700) = rxt(k,216)*y(k,217)
         mat(k,372) = rxt(k,192)*y(k,217)
         mat(k,656) = (rxt(k,551)+rxt(k,556))*y(k,83)
         mat(k,772) = (rxt(k,544)+rxt(k,550)+rxt(k,555))*y(k,83) + rxt(k,243)*y(k,217)
         mat(k,1122) = .500_r8*rxt(k,381)*y(k,217)
         mat(k,52) = rxt(k,520)*y(k,217)
         mat(k,439) = rxt(k,362)*y(k,217)
         mat(k,300) = rxt(k,366)*y(k,217)
         mat(k,2042) = rxt(k,179)*y(k,74) + rxt(k,186)*y(k,217)
         mat(k,1652) = rxt(k,329)*y(k,27) + rxt(k,354)*y(k,29) + rxt(k,355)*y(k,30) &
                      + rxt(k,302)*y(k,41) + rxt(k,331)*y(k,44) + rxt(k,368)*y(k,47) &
                      + rxt(k,357)*y(k,48) + rxt(k,337)*y(k,49) + rxt(k,338)*y(k,50) &
                      + rxt(k,308)*y(k,52) + rxt(k,184)*y(k,75) + rxt(k,185)*y(k,77) &
                      + rxt(k,269)*y(k,79) + rxt(k,240)*y(k,83) + rxt(k,312)*y(k,85) &
                      + rxt(k,216)*y(k,87) + rxt(k,192)*y(k,88) + rxt(k,243)*y(k,90) &
                      + .500_r8*rxt(k,381)*y(k,103) + rxt(k,520)*y(k,118) + rxt(k,362) &
                      *y(k,144) + rxt(k,366)*y(k,145) + rxt(k,186)*y(k,199) &
                      + 2.000_r8*rxt(k,189)*y(k,217)
      end do
      end subroutine nlnmat10
      subroutine nlnmat_finit( avec_len, mat, lmat, dti )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(veclen,nzcnt)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
      do k = 1,avec_len
         mat(k, 1) = lmat(k, 1)
         mat(k, 2) = lmat(k, 2)
         mat(k, 3) = lmat(k, 3)
         mat(k, 4) = lmat(k, 4)
         mat(k, 5) = lmat(k, 5)
         mat(k, 6) = lmat(k, 6)
         mat(k, 7) = lmat(k, 7)
         mat(k, 8) = lmat(k, 8)
         mat(k, 9) = lmat(k, 9)
         mat(k, 10) = lmat(k, 10)
         mat(k, 11) = lmat(k, 11)
         mat(k, 12) = lmat(k, 12)
         mat(k, 13) = lmat(k, 13)
         mat(k, 14) = lmat(k, 14)
         mat(k, 15) = lmat(k, 15)
         mat(k, 16) = lmat(k, 16)
         mat(k, 17) = lmat(k, 17)
         mat(k, 18) = lmat(k, 18)
         mat(k, 19) = lmat(k, 19)
         mat(k, 20) = lmat(k, 20)
         mat(k, 21) = lmat(k, 21)
         mat(k, 22) = lmat(k, 22)
         mat(k, 23) = lmat(k, 23)
         mat(k, 24) = lmat(k, 24)
         mat(k, 25) = lmat(k, 25)
         mat(k, 26) = lmat(k, 26)
         mat(k, 27) = lmat(k, 27)
         mat(k, 28) = lmat(k, 28)
         mat(k, 29) = lmat(k, 29)
         mat(k, 30) = lmat(k, 30)
         mat(k, 31) = lmat(k, 31)
         mat(k, 32) = lmat(k, 32)
         mat(k, 33) = lmat(k, 33)
         mat(k, 34) = lmat(k, 34)
         mat(k, 40) = mat(k, 40) + lmat(k, 40)
         mat(k, 46) = mat(k, 46) + lmat(k, 46)
         mat(k, 47) = lmat(k, 47)
         mat(k, 48) = lmat(k, 48)
         mat(k, 49) = lmat(k, 49)
         mat(k, 50) = mat(k, 50) + lmat(k, 50)
         mat(k, 53) = mat(k, 53) + lmat(k, 53)
         mat(k, 56) = mat(k, 56) + lmat(k, 56)
         mat(k, 60) = mat(k, 60) + lmat(k, 60)
         mat(k, 61) = mat(k, 61) + lmat(k, 61)
         mat(k, 63) = lmat(k, 63)
         mat(k, 64) = lmat(k, 64)
         mat(k, 65) = lmat(k, 65)
         mat(k, 66) = lmat(k, 66)
         mat(k, 67) = lmat(k, 67)
         mat(k, 68) = lmat(k, 68)
         mat(k, 69) = mat(k, 69) + lmat(k, 69)
         mat(k, 72) = lmat(k, 72)
         mat(k, 73) = lmat(k, 73)
         mat(k, 74) = lmat(k, 74)
         mat(k, 75) = lmat(k, 75)
         mat(k, 76) = lmat(k, 76)
         mat(k, 77) = mat(k, 77) + lmat(k, 77)
         mat(k, 78) = mat(k, 78) + lmat(k, 78)
         mat(k, 79) = mat(k, 79) + lmat(k, 79)
         mat(k, 80) = mat(k, 80) + lmat(k, 80)
         mat(k, 81) = lmat(k, 81)
         mat(k, 87) = mat(k, 87) + lmat(k, 87)
         mat(k, 93) = lmat(k, 93)
         mat(k, 94) = lmat(k, 94)
         mat(k, 95) = lmat(k, 95)
         mat(k, 96) = lmat(k, 96)
         mat(k, 97) = mat(k, 97) + lmat(k, 97)
         mat(k, 102) = lmat(k, 102)
         mat(k, 103) = lmat(k, 103)
         mat(k, 104) = mat(k, 104) + lmat(k, 104)
         mat(k, 113) = mat(k, 113) + lmat(k, 113)
         mat(k, 120) = mat(k, 120) + lmat(k, 120)
         mat(k, 125) = lmat(k, 125)
         mat(k, 126) = lmat(k, 126)
         mat(k, 127) = lmat(k, 127)
         mat(k, 128) = lmat(k, 128)
         mat(k, 129) = mat(k, 129) + lmat(k, 129)
         mat(k, 131) = mat(k, 131) + lmat(k, 131)
         mat(k, 132) = mat(k, 132) + lmat(k, 132)
         mat(k, 133) = mat(k, 133) + lmat(k, 133)
         mat(k, 135) = mat(k, 135) + lmat(k, 135)
         mat(k, 142) = mat(k, 142) + lmat(k, 142)
         mat(k, 150) = mat(k, 150) + lmat(k, 150)
         mat(k, 155) = lmat(k, 155)
         mat(k, 156) = lmat(k, 156)
         mat(k, 157) = lmat(k, 157)
         mat(k, 158) = mat(k, 158) + lmat(k, 158)
         mat(k, 159) = lmat(k, 159)
         mat(k, 161) = mat(k, 161) + lmat(k, 161)
         mat(k, 162) = lmat(k, 162)
         mat(k, 163) = mat(k, 163) + lmat(k, 163)
         mat(k, 166) = lmat(k, 166)
         mat(k, 167) = lmat(k, 167)
         mat(k, 168) = lmat(k, 168)
         mat(k, 169) = mat(k, 169) + lmat(k, 169)
         mat(k, 173) = mat(k, 173) + lmat(k, 173)
         mat(k, 174) = lmat(k, 174)
         mat(k, 175) = lmat(k, 175)
         mat(k, 177) = mat(k, 177) + lmat(k, 177)
         mat(k, 181) = mat(k, 181) + lmat(k, 181)
         mat(k, 182) = lmat(k, 182)
         mat(k, 184) = mat(k, 184) + lmat(k, 184)
         mat(k, 185) = lmat(k, 185)
         mat(k, 186) = lmat(k, 186)
         mat(k, 187) = lmat(k, 187)
         mat(k, 188) = lmat(k, 188)
         mat(k, 189) = lmat(k, 189)
         mat(k, 190) = lmat(k, 190)
         mat(k, 191) = mat(k, 191) + lmat(k, 191)
         mat(k, 197) = lmat(k, 197)
         mat(k, 198) = lmat(k, 198)
         mat(k, 199) = lmat(k, 199)
         mat(k, 200) = mat(k, 200) + lmat(k, 200)
         mat(k, 206) = mat(k, 206) + lmat(k, 206)
         mat(k, 212) = mat(k, 212) + lmat(k, 212)
         mat(k, 217) = mat(k, 217) + lmat(k, 217)
         mat(k, 219) = lmat(k, 219)
         mat(k, 220) = lmat(k, 220)
         mat(k, 221) = mat(k, 221) + lmat(k, 221)
         mat(k, 222) = mat(k, 222) + lmat(k, 222)
         mat(k, 227) = mat(k, 227) + lmat(k, 227)
         mat(k, 228) = lmat(k, 228)
         mat(k, 230) = mat(k, 230) + lmat(k, 230)
         mat(k, 231) = lmat(k, 231)
         mat(k, 232) = lmat(k, 232)
         mat(k, 233) = lmat(k, 233)
         mat(k, 234) = lmat(k, 234)
         mat(k, 235) = lmat(k, 235)
         mat(k, 236) = lmat(k, 236)
         mat(k, 237) = mat(k, 237) + lmat(k, 237)
         mat(k, 240) = lmat(k, 240)
         mat(k, 241) = mat(k, 241) + lmat(k, 241)
         mat(k, 242) = mat(k, 242) + lmat(k, 242)
         mat(k, 244) = lmat(k, 244)
         mat(k, 245) = mat(k, 245) + lmat(k, 245)
         mat(k, 246) = lmat(k, 246)
         mat(k, 247) = lmat(k, 247)
         mat(k, 248) = mat(k, 248) + lmat(k, 248)
         mat(k, 251) = mat(k, 251) + lmat(k, 251)
         mat(k, 252) = lmat(k, 252)
         mat(k, 253) = mat(k, 253) + lmat(k, 253)
         mat(k, 255) = mat(k, 255) + lmat(k, 255)
         mat(k, 256) = mat(k, 256) + lmat(k, 256)
         mat(k, 257) = lmat(k, 257)
         mat(k, 258) = mat(k, 258) + lmat(k, 258)
         mat(k, 261) = mat(k, 261) + lmat(k, 261)
         mat(k, 262) = lmat(k, 262)
         mat(k, 264) = mat(k, 264) + lmat(k, 264)
         mat(k, 269) = mat(k, 269) + lmat(k, 269)
         mat(k, 277) = mat(k, 277) + lmat(k, 277)
         mat(k, 278) = lmat(k, 278)
         mat(k, 280) = lmat(k, 280)
         mat(k, 281) = mat(k, 281) + lmat(k, 281)
         mat(k, 282) = lmat(k, 282)
         mat(k, 283) = lmat(k, 283)
         mat(k, 284) = lmat(k, 284)
         mat(k, 285) = lmat(k, 285)
         mat(k, 286) = lmat(k, 286)
         mat(k, 287) = lmat(k, 287)
         mat(k, 288) = lmat(k, 288)
         mat(k, 289) = mat(k, 289) + lmat(k, 289)
         mat(k, 290) = lmat(k, 290)
         mat(k, 293) = lmat(k, 293)
         mat(k, 294) = mat(k, 294) + lmat(k, 294)
         mat(k, 295) = mat(k, 295) + lmat(k, 295)
         mat(k, 297) = lmat(k, 297)
         mat(k, 298) = lmat(k, 298)
         mat(k, 299) = mat(k, 299) + lmat(k, 299)
         mat(k, 301) = mat(k, 301) + lmat(k, 301)
         mat(k, 303) = lmat(k, 303)
         mat(k, 304) = mat(k, 304) + lmat(k, 304)
         mat(k, 305) = lmat(k, 305)
         mat(k, 307) = mat(k, 307) + lmat(k, 307)
         mat(k, 309) = mat(k, 309) + lmat(k, 309)
         mat(k, 310) = mat(k, 310) + lmat(k, 310)
         mat(k, 311) = lmat(k, 311)
         mat(k, 313) = mat(k, 313) + lmat(k, 313)
         mat(k, 315) = lmat(k, 315)
         mat(k, 316) = lmat(k, 316)
         mat(k, 317) = mat(k, 317) + lmat(k, 317)
         mat(k, 318) = lmat(k, 318)
         mat(k, 321) = mat(k, 321) + lmat(k, 321)
         mat(k, 327) = mat(k, 327) + lmat(k, 327)
         mat(k, 329) = lmat(k, 329)
         mat(k, 332) = mat(k, 332) + lmat(k, 332)
         mat(k, 334) = mat(k, 334) + lmat(k, 334)
         mat(k, 340) = lmat(k, 340)
         mat(k, 341) = lmat(k, 341)
         mat(k, 342) = lmat(k, 342)
         mat(k, 343) = mat(k, 343) + lmat(k, 343)
         mat(k, 346) = lmat(k, 346)
         mat(k, 347) = mat(k, 347) + lmat(k, 347)
         mat(k, 348) = mat(k, 348) + lmat(k, 348)
         mat(k, 355) = mat(k, 355) + lmat(k, 355)
         mat(k, 356) = lmat(k, 356)
         mat(k, 357) = lmat(k, 357)
         mat(k, 360) = lmat(k, 360)
         mat(k, 361) = mat(k, 361) + lmat(k, 361)
         mat(k, 362) = mat(k, 362) + lmat(k, 362)
         mat(k, 366) = mat(k, 366) + lmat(k, 366)
         mat(k, 368) = mat(k, 368) + lmat(k, 368)
         mat(k, 369) = mat(k, 369) + lmat(k, 369)
         mat(k, 370) = lmat(k, 370)
         mat(k, 371) = lmat(k, 371)
         mat(k, 373) = mat(k, 373) + lmat(k, 373)
         mat(k, 375) = lmat(k, 375)
         mat(k, 376) = lmat(k, 376)
         mat(k, 377) = lmat(k, 377)
         mat(k, 378) = mat(k, 378) + lmat(k, 378)
         mat(k, 379) = lmat(k, 379)
         mat(k, 382) = mat(k, 382) + lmat(k, 382)
         mat(k, 389) = mat(k, 389) + lmat(k, 389)
         mat(k, 397) = mat(k, 397) + lmat(k, 397)
         mat(k, 404) = mat(k, 404) + lmat(k, 404)
         mat(k, 406) = lmat(k, 406)
         mat(k, 408) = mat(k, 408) + lmat(k, 408)
         mat(k, 410) = mat(k, 410) + lmat(k, 410)
         mat(k, 412) = lmat(k, 412)
         mat(k, 413) = lmat(k, 413)
         mat(k, 415) = mat(k, 415) + lmat(k, 415)
         mat(k, 416) = mat(k, 416) + lmat(k, 416)
         mat(k, 418) = mat(k, 418) + lmat(k, 418)
         mat(k, 419) = lmat(k, 419)
         mat(k, 421) = mat(k, 421) + lmat(k, 421)
         mat(k, 427) = mat(k, 427) + lmat(k, 427)
         mat(k, 432) = mat(k, 432) + lmat(k, 432)
         mat(k, 435) = lmat(k, 435)
         mat(k, 436) = lmat(k, 436)
         mat(k, 437) = mat(k, 437) + lmat(k, 437)
         mat(k, 438) = lmat(k, 438)
         mat(k, 440) = mat(k, 440) + lmat(k, 440)
         mat(k, 441) = lmat(k, 441)
         mat(k, 442) = lmat(k, 442)
         mat(k, 443) = mat(k, 443) + lmat(k, 443)
         mat(k, 445) = lmat(k, 445)
         mat(k, 446) = lmat(k, 446)
         mat(k, 447) = mat(k, 447) + lmat(k, 447)
         mat(k, 448) = mat(k, 448) + lmat(k, 448)
         mat(k, 456) = mat(k, 456) + lmat(k, 456)
         mat(k, 464) = mat(k, 464) + lmat(k, 464)
         mat(k, 468) = mat(k, 468) + lmat(k, 468)
         mat(k, 476) = mat(k, 476) + lmat(k, 476)
         mat(k, 478) = lmat(k, 478)
         mat(k, 481) = lmat(k, 481)
         mat(k, 484) = mat(k, 484) + lmat(k, 484)
         mat(k, 485) = lmat(k, 485)
         mat(k, 486) = lmat(k, 486)
         mat(k, 487) = lmat(k, 487)
         mat(k, 489) = lmat(k, 489)
         mat(k, 490) = lmat(k, 490)
         mat(k, 491) = mat(k, 491) + lmat(k, 491)
         mat(k, 492) = lmat(k, 492)
         mat(k, 493) = lmat(k, 493)
         mat(k, 494) = lmat(k, 494)
         mat(k, 495) = mat(k, 495) + lmat(k, 495)
         mat(k, 496) = lmat(k, 496)
         mat(k, 500) = lmat(k, 500)
         mat(k, 501) = lmat(k, 501)
         mat(k, 502) = mat(k, 502) + lmat(k, 502)
         mat(k, 503) = lmat(k, 503)
         mat(k, 504) = mat(k, 504) + lmat(k, 504)
         mat(k, 507) = mat(k, 507) + lmat(k, 507)
         mat(k, 511) = mat(k, 511) + lmat(k, 511)
         mat(k, 512) = mat(k, 512) + lmat(k, 512)
         mat(k, 513) = lmat(k, 513)
         mat(k, 514) = lmat(k, 514)
         mat(k, 515) = lmat(k, 515)
         mat(k, 518) = lmat(k, 518)
         mat(k, 519) = lmat(k, 519)
         mat(k, 520) = lmat(k, 520)
         mat(k, 521) = lmat(k, 521)
         mat(k, 524) = mat(k, 524) + lmat(k, 524)
         mat(k, 530) = lmat(k, 530)
         mat(k, 531) = mat(k, 531) + lmat(k, 531)
         mat(k, 535) = lmat(k, 535)
         mat(k, 536) = lmat(k, 536)
         mat(k, 538) = lmat(k, 538)
         mat(k, 539) = mat(k, 539) + lmat(k, 539)
         mat(k, 540) = lmat(k, 540)
         mat(k, 543) = mat(k, 543) + lmat(k, 543)
         mat(k, 553) = lmat(k, 553)
         mat(k, 554) = mat(k, 554) + lmat(k, 554)
         mat(k, 557) = mat(k, 557) + lmat(k, 557)
         mat(k, 558) = mat(k, 558) + lmat(k, 558)
         mat(k, 560) = mat(k, 560) + lmat(k, 560)
         mat(k, 562) = mat(k, 562) + lmat(k, 562)
         mat(k, 563) = lmat(k, 563)
         mat(k, 565) = mat(k, 565) + lmat(k, 565)
         mat(k, 573) = mat(k, 573) + lmat(k, 573)
         mat(k, 575) = lmat(k, 575)
         mat(k, 576) = lmat(k, 576)
         mat(k, 577) = lmat(k, 577)
         mat(k, 579) = lmat(k, 579)
         mat(k, 580) = lmat(k, 580)
         mat(k, 581) = lmat(k, 581)
         mat(k, 582) = lmat(k, 582)
         mat(k, 583) = lmat(k, 583)
         mat(k, 584) = mat(k, 584) + lmat(k, 584)
         mat(k, 588) = lmat(k, 588)
         mat(k, 591) = lmat(k, 591)
         mat(k, 593) = mat(k, 593) + lmat(k, 593)
         mat(k, 594) = lmat(k, 594)
         mat(k, 595) = mat(k, 595) + lmat(k, 595)
         mat(k, 602) = mat(k, 602) + lmat(k, 602)
         mat(k, 613) = mat(k, 613) + lmat(k, 613)
         mat(k, 629) = mat(k, 629) + lmat(k, 629)
         mat(k, 640) = mat(k, 640) + lmat(k, 640)
         mat(k, 649) = mat(k, 649) + lmat(k, 649)
         mat(k, 651) = lmat(k, 651)
         mat(k, 654) = mat(k, 654) + lmat(k, 654)
         mat(k, 657) = mat(k, 657) + lmat(k, 657)
         mat(k, 658) = mat(k, 658) + lmat(k, 658)
         mat(k, 660) = lmat(k, 660)
         mat(k, 668) = mat(k, 668) + lmat(k, 668)
         mat(k, 676) = mat(k, 676) + lmat(k, 676)
         mat(k, 677) = mat(k, 677) + lmat(k, 677)
         mat(k, 683) = mat(k, 683) + lmat(k, 683)
         mat(k, 685) = mat(k, 685) + lmat(k, 685)
         mat(k, 696) = mat(k, 696) + lmat(k, 696)
         mat(k, 703) = mat(k, 703) + lmat(k, 703)
         mat(k, 707) = mat(k, 707) + lmat(k, 707)
         mat(k, 712) = mat(k, 712) + lmat(k, 712)
         mat(k, 723) = mat(k, 723) + lmat(k, 723)
         mat(k, 734) = lmat(k, 734)
         mat(k, 738) = lmat(k, 738)
         mat(k, 739) = mat(k, 739) + lmat(k, 739)
         mat(k, 748) = lmat(k, 748)
         mat(k, 749) = mat(k, 749) + lmat(k, 749)
         mat(k, 755) = lmat(k, 755)
         mat(k, 756) = mat(k, 756) + lmat(k, 756)
         mat(k, 757) = mat(k, 757) + lmat(k, 757)
         mat(k, 758) = mat(k, 758) + lmat(k, 758)
         mat(k, 763) = mat(k, 763) + lmat(k, 763)
         mat(k, 766) = mat(k, 766) + lmat(k, 766)
         mat(k, 769) = mat(k, 769) + lmat(k, 769)
         mat(k, 770) = mat(k, 770) + lmat(k, 770)
         mat(k, 773) = mat(k, 773) + lmat(k, 773)
         mat(k, 775) = lmat(k, 775)
         mat(k, 776) = lmat(k, 776)
         mat(k, 778) = mat(k, 778) + lmat(k, 778)
         mat(k, 785) = mat(k, 785) + lmat(k, 785)
         mat(k, 801) = lmat(k, 801)
         mat(k, 802) = mat(k, 802) + lmat(k, 802)
         mat(k, 803) = mat(k, 803) + lmat(k, 803)
         mat(k, 805) = mat(k, 805) + lmat(k, 805)
         mat(k, 809) = mat(k, 809) + lmat(k, 809)
         mat(k, 827) = mat(k, 827) + lmat(k, 827)
         mat(k, 853) = mat(k, 853) + lmat(k, 853)
         mat(k, 873) = mat(k, 873) + lmat(k, 873)
         mat(k, 882) = mat(k, 882) + lmat(k, 882)
         mat(k, 884) = lmat(k, 884)
         mat(k, 886) = lmat(k, 886)
         mat(k, 888) = lmat(k, 888)
         mat(k, 895) = mat(k, 895) + lmat(k, 895)
         mat(k, 906) = mat(k, 906) + lmat(k, 906)
         mat(k, 908) = lmat(k, 908)
         mat(k, 909) = lmat(k, 909)
         mat(k, 913) = mat(k, 913) + lmat(k, 913)
         mat(k, 914) = lmat(k, 914)
         mat(k, 915) = lmat(k, 915)
         mat(k, 920) = mat(k, 920) + lmat(k, 920)
         mat(k, 921) = mat(k, 921) + lmat(k, 921)
         mat(k, 925) = mat(k, 925) + lmat(k, 925)
         mat(k, 926) = lmat(k, 926)
         mat(k, 927) = mat(k, 927) + lmat(k, 927)
         mat(k, 928) = mat(k, 928) + lmat(k, 928)
         mat(k, 929) = mat(k, 929) + lmat(k, 929)
         mat(k, 935) = mat(k, 935) + lmat(k, 935)
         mat(k, 955) = mat(k, 955) + lmat(k, 955)
         mat(k, 966) = mat(k, 966) + lmat(k, 966)
         mat(k, 967) = mat(k, 967) + lmat(k, 967)
         mat(k, 968) = mat(k, 968) + lmat(k, 968)
         mat(k, 969) = mat(k, 969) + lmat(k, 969)
         mat(k, 970) = mat(k, 970) + lmat(k, 970)
         mat(k, 972) = mat(k, 972) + lmat(k, 972)
         mat(k, 974) = mat(k, 974) + lmat(k, 974)
         mat(k, 977) = mat(k, 977) + lmat(k, 977)
         mat(k, 986) = mat(k, 986) + lmat(k, 986)
         mat(k, 987) = lmat(k, 987)
         mat(k, 988) = mat(k, 988) + lmat(k, 988)
         mat(k, 990) = mat(k, 990) + lmat(k, 990)
         mat(k, 997) = mat(k, 997) + lmat(k, 997)
         mat(k,1009) = lmat(k,1009)
         mat(k,1010) = lmat(k,1010)
         mat(k,1011) = mat(k,1011) + lmat(k,1011)
         mat(k,1012) = lmat(k,1012)
         mat(k,1013) = lmat(k,1013)
         mat(k,1015) = lmat(k,1015)
         mat(k,1016) = lmat(k,1016)
         mat(k,1018) = lmat(k,1018)
         mat(k,1020) = lmat(k,1020)
         mat(k,1021) = mat(k,1021) + lmat(k,1021)
         mat(k,1023) = mat(k,1023) + lmat(k,1023)
         mat(k,1027) = mat(k,1027) + lmat(k,1027)
         mat(k,1029) = lmat(k,1029)
         mat(k,1030) = lmat(k,1030)
         mat(k,1032) = mat(k,1032) + lmat(k,1032)
         mat(k,1036) = mat(k,1036) + lmat(k,1036)
         mat(k,1046) = lmat(k,1046)
         mat(k,1047) = mat(k,1047) + lmat(k,1047)
         mat(k,1049) = lmat(k,1049)
         mat(k,1052) = lmat(k,1052)
         mat(k,1058) = mat(k,1058) + lmat(k,1058)
         mat(k,1075) = mat(k,1075) + lmat(k,1075)
         mat(k,1097) = mat(k,1097) + lmat(k,1097)
         mat(k,1111) = mat(k,1111) + lmat(k,1111)
         mat(k,1112) = mat(k,1112) + lmat(k,1112)
         mat(k,1115) = mat(k,1115) + lmat(k,1115)
         mat(k,1116) = mat(k,1116) + lmat(k,1116)
         mat(k,1117) = mat(k,1117) + lmat(k,1117)
         mat(k,1120) = mat(k,1120) + lmat(k,1120)
         mat(k,1123) = mat(k,1123) + lmat(k,1123)
         mat(k,1124) = mat(k,1124) + lmat(k,1124)
         mat(k,1125) = mat(k,1125) + lmat(k,1125)
         mat(k,1128) = lmat(k,1128)
         mat(k,1132) = lmat(k,1132)
         mat(k,1150) = mat(k,1150) + lmat(k,1150)
         mat(k,1162) = mat(k,1162) + lmat(k,1162)
         mat(k,1178) = mat(k,1178) + lmat(k,1178)
         mat(k,1203) = mat(k,1203) + lmat(k,1203)
         mat(k,1217) = lmat(k,1217)
         mat(k,1218) = mat(k,1218) + lmat(k,1218)
         mat(k,1223) = mat(k,1223) + lmat(k,1223)
         mat(k,1225) = mat(k,1225) + lmat(k,1225)
         mat(k,1226) = lmat(k,1226)
         mat(k,1243) = mat(k,1243) + lmat(k,1243)
         mat(k,1276) = mat(k,1276) + lmat(k,1276)
         mat(k,1290) = lmat(k,1290)
         mat(k,1292) = mat(k,1292) + lmat(k,1292)
         mat(k,1296) = mat(k,1296) + lmat(k,1296)
         mat(k,1311) = mat(k,1311) + lmat(k,1311)
         mat(k,1319) = mat(k,1319) + lmat(k,1319)
         mat(k,1322) = mat(k,1322) + lmat(k,1322)
         mat(k,1326) = mat(k,1326) + lmat(k,1326)
         mat(k,1371) = mat(k,1371) + lmat(k,1371)
         mat(k,1390) = mat(k,1390) + lmat(k,1390)
         mat(k,1393) = mat(k,1393) + lmat(k,1393)
         mat(k,1395) = lmat(k,1395)
         mat(k,1402) = mat(k,1402) + lmat(k,1402)
         mat(k,1405) = mat(k,1405) + lmat(k,1405)
         mat(k,1407) = mat(k,1407) + lmat(k,1407)
         mat(k,1419) = mat(k,1419) + lmat(k,1419)
         mat(k,1420) = lmat(k,1420)
         mat(k,1425) = mat(k,1425) + lmat(k,1425)
         mat(k,1438) = mat(k,1438) + lmat(k,1438)
         mat(k,1447) = mat(k,1447) + lmat(k,1447)
         mat(k,1450) = mat(k,1450) + lmat(k,1450)
         mat(k,1451) = mat(k,1451) + lmat(k,1451)
         mat(k,1471) = mat(k,1471) + lmat(k,1471)
         mat(k,1477) = lmat(k,1477)
         mat(k,1492) = mat(k,1492) + lmat(k,1492)
         mat(k,1515) = lmat(k,1515)
         mat(k,1526) = lmat(k,1526)
         mat(k,1635) = mat(k,1635) + lmat(k,1635)
         mat(k,1636) = mat(k,1636) + lmat(k,1636)
         mat(k,1641) = mat(k,1641) + lmat(k,1641)
         mat(k,1647) = mat(k,1647) + lmat(k,1647)
         mat(k,1649) = mat(k,1649) + lmat(k,1649)
         mat(k,1652) = mat(k,1652) + lmat(k,1652)
         mat(k,1653) = mat(k,1653) + lmat(k,1653)
         mat(k,1656) = mat(k,1656) + lmat(k,1656)
         mat(k,1657) = mat(k,1657) + lmat(k,1657)
         mat(k,1659) = mat(k,1659) + lmat(k,1659)
         mat(k,1661) = mat(k,1661) + lmat(k,1661)
         mat(k,1662) = lmat(k,1662)
         mat(k,1663) = mat(k,1663) + lmat(k,1663)
         mat(k,1664) = lmat(k,1664)
         mat(k,1666) = mat(k,1666) + lmat(k,1666)
         mat(k,1667) = mat(k,1667) + lmat(k,1667)
         mat(k,1668) = mat(k,1668) + lmat(k,1668)
         mat(k,1670) = lmat(k,1670)
         mat(k,1673) = mat(k,1673) + lmat(k,1673)
         mat(k,1675) = lmat(k,1675)
         mat(k,1677) = mat(k,1677) + lmat(k,1677)
         mat(k,1689) = mat(k,1689) + lmat(k,1689)
         mat(k,1691) = mat(k,1691) + lmat(k,1691)
         mat(k,1693) = lmat(k,1693)
         mat(k,1730) = mat(k,1730) + lmat(k,1730)
         mat(k,1731) = lmat(k,1731)
         mat(k,1735) = mat(k,1735) + lmat(k,1735)
         mat(k,1769) = mat(k,1769) + lmat(k,1769)
         mat(k,1773) = mat(k,1773) + lmat(k,1773)
         mat(k,1811) = mat(k,1811) + lmat(k,1811)
         mat(k,1812) = mat(k,1812) + lmat(k,1812)
         mat(k,1814) = mat(k,1814) + lmat(k,1814)
         mat(k,1815) = mat(k,1815) + lmat(k,1815)
         mat(k,1816) = mat(k,1816) + lmat(k,1816)
         mat(k,1829) = mat(k,1829) + lmat(k,1829)
         mat(k,1870) = mat(k,1870) + lmat(k,1870)
         mat(k,1873) = mat(k,1873) + lmat(k,1873)
         mat(k,1875) = mat(k,1875) + lmat(k,1875)
         mat(k,1879) = mat(k,1879) + lmat(k,1879)
         mat(k,1898) = mat(k,1898) + lmat(k,1898)
         mat(k,1902) = mat(k,1902) + lmat(k,1902)
         mat(k,1903) = lmat(k,1903)
         mat(k,1904) = lmat(k,1904)
         mat(k,1915) = mat(k,1915) + lmat(k,1915)
         mat(k,1917) = mat(k,1917) + lmat(k,1917)
         mat(k,1935) = mat(k,1935) + lmat(k,1935)
         mat(k,1942) = mat(k,1942) + lmat(k,1942)
         mat(k,1943) = mat(k,1943) + lmat(k,1943)
         mat(k,1979) = mat(k,1979) + lmat(k,1979)
         mat(k,2039) = mat(k,2039) + lmat(k,2039)
         mat(k,2085) = mat(k,2085) + lmat(k,2085)
         mat(k,2088) = mat(k,2088) + lmat(k,2088)
         mat(k,2091) = mat(k,2091) + lmat(k,2091)
         mat(k,2092) = mat(k,2092) + lmat(k,2092)
         mat(k,2093) = mat(k,2093) + lmat(k,2093)
         mat(k,2098) = mat(k,2098) + lmat(k,2098)
         mat(k,2119) = mat(k,2119) + lmat(k,2119)
         mat(k,2126) = lmat(k,2126)
         mat(k,2134) = lmat(k,2134)
         mat(k,2135) = mat(k,2135) + lmat(k,2135)
         mat(k,2136) = mat(k,2136) + lmat(k,2136)
         mat(k,2145) = lmat(k,2145)
         mat(k,2146) = mat(k,2146) + lmat(k,2146)
         mat(k, 146) = 0._r8
         mat(k, 147) = 0._r8
         mat(k, 250) = 0._r8
         mat(k, 322) = 0._r8
         mat(k, 323) = 0._r8
         mat(k, 336) = 0._r8
         mat(k, 383) = 0._r8
         mat(k, 385) = 0._r8
         mat(k, 400) = 0._r8
         mat(k, 497) = 0._r8
         mat(k, 499) = 0._r8
         mat(k, 525) = 0._r8
         mat(k, 528) = 0._r8
         mat(k, 532) = 0._r8
         mat(k, 533) = 0._r8
         mat(k, 537) = 0._r8
         mat(k, 548) = 0._r8
         mat(k, 551) = 0._r8
         mat(k, 552) = 0._r8
         mat(k, 555) = 0._r8
         mat(k, 556) = 0._r8
         mat(k, 559) = 0._r8
         mat(k, 585) = 0._r8
         mat(k, 587) = 0._r8
         mat(k, 589) = 0._r8
         mat(k, 590) = 0._r8
         mat(k, 592) = 0._r8
         mat(k, 612) = 0._r8
         mat(k, 614) = 0._r8
         mat(k, 616) = 0._r8
         mat(k, 617) = 0._r8
         mat(k, 619) = 0._r8
         mat(k, 628) = 0._r8
         mat(k, 630) = 0._r8
         mat(k, 632) = 0._r8
         mat(k, 633) = 0._r8
         mat(k, 635) = 0._r8
         mat(k, 636) = 0._r8
         mat(k, 655) = 0._r8
         mat(k, 669) = 0._r8
         mat(k, 670) = 0._r8
         mat(k, 672) = 0._r8
         mat(k, 688) = 0._r8
         mat(k, 690) = 0._r8
         mat(k, 691) = 0._r8
         mat(k, 698) = 0._r8
         mat(k, 699) = 0._r8
         mat(k, 702) = 0._r8
         mat(k, 713) = 0._r8
         mat(k, 717) = 0._r8
         mat(k, 721) = 0._r8
         mat(k, 729) = 0._r8
         mat(k, 733) = 0._r8
         mat(k, 735) = 0._r8
         mat(k, 740) = 0._r8
         mat(k, 744) = 0._r8
         mat(k, 752) = 0._r8
         mat(k, 753) = 0._r8
         mat(k, 800) = 0._r8
         mat(k, 814) = 0._r8
         mat(k, 826) = 0._r8
         mat(k, 830) = 0._r8
         mat(k, 836) = 0._r8
         mat(k, 843) = 0._r8
         mat(k, 852) = 0._r8
         mat(k, 856) = 0._r8
         mat(k, 862) = 0._r8
         mat(k, 869) = 0._r8
         mat(k, 878) = 0._r8
         mat(k, 893) = 0._r8
         mat(k, 894) = 0._r8
         mat(k, 898) = 0._r8
         mat(k, 899) = 0._r8
         mat(k, 900) = 0._r8
         mat(k, 902) = 0._r8
         mat(k, 918) = 0._r8
         mat(k, 930) = 0._r8
         mat(k, 937) = 0._r8
         mat(k, 939) = 0._r8
         mat(k, 940) = 0._r8
         mat(k, 942) = 0._r8
         mat(k, 945) = 0._r8
         mat(k, 946) = 0._r8
         mat(k, 950) = 0._r8
         mat(k, 956) = 0._r8
         mat(k, 957) = 0._r8
         mat(k, 958) = 0._r8
         mat(k, 961) = 0._r8
         mat(k, 971) = 0._r8
         mat(k, 975) = 0._r8
         mat(k, 999) = 0._r8
         mat(k,1000) = 0._r8
         mat(k,1003) = 0._r8
         mat(k,1007) = 0._r8
         mat(k,1014) = 0._r8
         mat(k,1017) = 0._r8
         mat(k,1022) = 0._r8
         mat(k,1045) = 0._r8
         mat(k,1054) = 0._r8
         mat(k,1060) = 0._r8
         mat(k,1064) = 0._r8
         mat(k,1066) = 0._r8
         mat(k,1080) = 0._r8
         mat(k,1085) = 0._r8
         mat(k,1088) = 0._r8
         mat(k,1091) = 0._r8
         mat(k,1092) = 0._r8
         mat(k,1093) = 0._r8
         mat(k,1094) = 0._r8
         mat(k,1095) = 0._r8
         mat(k,1096) = 0._r8
         mat(k,1098) = 0._r8
         mat(k,1099) = 0._r8
         mat(k,1100) = 0._r8
         mat(k,1104) = 0._r8
         mat(k,1109) = 0._r8
         mat(k,1121) = 0._r8
         mat(k,1130) = 0._r8
         mat(k,1135) = 0._r8
         mat(k,1138) = 0._r8
         mat(k,1140) = 0._r8
         mat(k,1142) = 0._r8
         mat(k,1143) = 0._r8
         mat(k,1145) = 0._r8
         mat(k,1146) = 0._r8
         mat(k,1147) = 0._r8
         mat(k,1148) = 0._r8
         mat(k,1151) = 0._r8
         mat(k,1152) = 0._r8
         mat(k,1153) = 0._r8
         mat(k,1157) = 0._r8
         mat(k,1158) = 0._r8
         mat(k,1161) = 0._r8
         mat(k,1164) = 0._r8
         mat(k,1165) = 0._r8
         mat(k,1169) = 0._r8
         mat(k,1170) = 0._r8
         mat(k,1171) = 0._r8
         mat(k,1172) = 0._r8
         mat(k,1173) = 0._r8
         mat(k,1174) = 0._r8
         mat(k,1175) = 0._r8
         mat(k,1177) = 0._r8
         mat(k,1179) = 0._r8
         mat(k,1181) = 0._r8
         mat(k,1185) = 0._r8
         mat(k,1186) = 0._r8
         mat(k,1189) = 0._r8
         mat(k,1192) = 0._r8
         mat(k,1193) = 0._r8
         mat(k,1200) = 0._r8
         mat(k,1201) = 0._r8
         mat(k,1204) = 0._r8
         mat(k,1208) = 0._r8
         mat(k,1209) = 0._r8
         mat(k,1214) = 0._r8
         mat(k,1215) = 0._r8
         mat(k,1219) = 0._r8
         mat(k,1224) = 0._r8
         mat(k,1227) = 0._r8
         mat(k,1230) = 0._r8
         mat(k,1231) = 0._r8
         mat(k,1232) = 0._r8
         mat(k,1235) = 0._r8
         mat(k,1236) = 0._r8
         mat(k,1237) = 0._r8
         mat(k,1241) = 0._r8
         mat(k,1242) = 0._r8
         mat(k,1248) = 0._r8
         mat(k,1254) = 0._r8
         mat(k,1255) = 0._r8
         mat(k,1261) = 0._r8
         mat(k,1263) = 0._r8
         mat(k,1278) = 0._r8
         mat(k,1281) = 0._r8
         mat(k,1286) = 0._r8
         mat(k,1287) = 0._r8
         mat(k,1288) = 0._r8
         mat(k,1303) = 0._r8
         mat(k,1305) = 0._r8
         mat(k,1312) = 0._r8
         mat(k,1313) = 0._r8
         mat(k,1318) = 0._r8
         mat(k,1321) = 0._r8
         mat(k,1330) = 0._r8
         mat(k,1331) = 0._r8
         mat(k,1332) = 0._r8
         mat(k,1335) = 0._r8
         mat(k,1336) = 0._r8
         mat(k,1346) = 0._r8
         mat(k,1354) = 0._r8
         mat(k,1374) = 0._r8
         mat(k,1375) = 0._r8
         mat(k,1378) = 0._r8
         mat(k,1382) = 0._r8
         mat(k,1383) = 0._r8
         mat(k,1384) = 0._r8
         mat(k,1399) = 0._r8
         mat(k,1401) = 0._r8
         mat(k,1403) = 0._r8
         mat(k,1404) = 0._r8
         mat(k,1406) = 0._r8
         mat(k,1409) = 0._r8
         mat(k,1411) = 0._r8
         mat(k,1412) = 0._r8
         mat(k,1415) = 0._r8
         mat(k,1417) = 0._r8
         mat(k,1423) = 0._r8
         mat(k,1424) = 0._r8
         mat(k,1426) = 0._r8
         mat(k,1429) = 0._r8
         mat(k,1431) = 0._r8
         mat(k,1432) = 0._r8
         mat(k,1433) = 0._r8
         mat(k,1435) = 0._r8
         mat(k,1446) = 0._r8
         mat(k,1449) = 0._r8
         mat(k,1453) = 0._r8
         mat(k,1454) = 0._r8
         mat(k,1457) = 0._r8
         mat(k,1461) = 0._r8
         mat(k,1462) = 0._r8
         mat(k,1463) = 0._r8
         mat(k,1473) = 0._r8
         mat(k,1475) = 0._r8
         mat(k,1481) = 0._r8
         mat(k,1488) = 0._r8
         mat(k,1494) = 0._r8
         mat(k,1495) = 0._r8
         mat(k,1504) = 0._r8
         mat(k,1556) = 0._r8
         mat(k,1577) = 0._r8
         mat(k,1585) = 0._r8
         mat(k,1588) = 0._r8
         mat(k,1589) = 0._r8
         mat(k,1614) = 0._r8
         mat(k,1624) = 0._r8
         mat(k,1642) = 0._r8
         mat(k,1669) = 0._r8
         mat(k,1671) = 0._r8
         mat(k,1676) = 0._r8
         mat(k,1681) = 0._r8
         mat(k,1682) = 0._r8
         mat(k,1683) = 0._r8
         mat(k,1684) = 0._r8
         mat(k,1685) = 0._r8
         mat(k,1686) = 0._r8
         mat(k,1687) = 0._r8
         mat(k,1688) = 0._r8
         mat(k,1690) = 0._r8
         mat(k,1692) = 0._r8
         mat(k,1694) = 0._r8
         mat(k,1695) = 0._r8
         mat(k,1696) = 0._r8
         mat(k,1697) = 0._r8
         mat(k,1699) = 0._r8
         mat(k,1737) = 0._r8
         mat(k,1771) = 0._r8
         mat(k,1772) = 0._r8
         mat(k,1780) = 0._r8
         mat(k,1781) = 0._r8
         mat(k,1790) = 0._r8
         mat(k,1793) = 0._r8
         mat(k,1795) = 0._r8
         mat(k,1799) = 0._r8
         mat(k,1800) = 0._r8
         mat(k,1801) = 0._r8
         mat(k,1805) = 0._r8
         mat(k,1806) = 0._r8
         mat(k,1807) = 0._r8
         mat(k,1809) = 0._r8
         mat(k,1813) = 0._r8
         mat(k,1818) = 0._r8
         mat(k,1822) = 0._r8
         mat(k,1823) = 0._r8
         mat(k,1838) = 0._r8
         mat(k,1841) = 0._r8
         mat(k,1844) = 0._r8
         mat(k,1846) = 0._r8
         mat(k,1850) = 0._r8
         mat(k,1852) = 0._r8
         mat(k,1853) = 0._r8
         mat(k,1855) = 0._r8
         mat(k,1858) = 0._r8
         mat(k,1861) = 0._r8
         mat(k,1862) = 0._r8
         mat(k,1863) = 0._r8
         mat(k,1865) = 0._r8
         mat(k,1876) = 0._r8
         mat(k,1885) = 0._r8
         mat(k,1891) = 0._r8
         mat(k,1892) = 0._r8
         mat(k,1894) = 0._r8
         mat(k,1897) = 0._r8
         mat(k,1899) = 0._r8
         mat(k,1901) = 0._r8
         mat(k,1907) = 0._r8
         mat(k,1908) = 0._r8
         mat(k,1910) = 0._r8
         mat(k,1911) = 0._r8
         mat(k,1912) = 0._r8
         mat(k,1913) = 0._r8
         mat(k,1920) = 0._r8
         mat(k,1937) = 0._r8
         mat(k,1938) = 0._r8
         mat(k,1941) = 0._r8
         mat(k,1945) = 0._r8
         mat(k,1946) = 0._r8
         mat(k,1947) = 0._r8
         mat(k,1966) = 0._r8
         mat(k,1967) = 0._r8
         mat(k,1968) = 0._r8
         mat(k,1980) = 0._r8
         mat(k,1997) = 0._r8
         mat(k,2001) = 0._r8
         mat(k,2003) = 0._r8
         mat(k,2005) = 0._r8
         mat(k,2007) = 0._r8
         mat(k,2010) = 0._r8
         mat(k,2016) = 0._r8
         mat(k,2021) = 0._r8
         mat(k,2032) = 0._r8
         mat(k,2033) = 0._r8
         mat(k,2049) = 0._r8
         mat(k,2056) = 0._r8
         mat(k,2058) = 0._r8
         mat(k,2063) = 0._r8
         mat(k,2064) = 0._r8
         mat(k,2067) = 0._r8
         mat(k,2070) = 0._r8
         mat(k,2082) = 0._r8
         mat(k,2083) = 0._r8
         mat(k,2084) = 0._r8
         mat(k,2087) = 0._r8
         mat(k,2090) = 0._r8
         mat(k,2094) = 0._r8
         mat(k,2095) = 0._r8
         mat(k,2096) = 0._r8
         mat(k,2099) = 0._r8
         mat(k,2100) = 0._r8
         mat(k,2102) = 0._r8
         mat(k,2103) = 0._r8
         mat(k,2104) = 0._r8
         mat(k,2106) = 0._r8
         mat(k,2107) = 0._r8
         mat(k,2110) = 0._r8
         mat(k,2111) = 0._r8
         mat(k,2112) = 0._r8
         mat(k,2113) = 0._r8
         mat(k,2115) = 0._r8
         mat(k,2116) = 0._r8
         mat(k,2118) = 0._r8
         mat(k,2125) = 0._r8
         mat(k,2127) = 0._r8
         mat(k,2128) = 0._r8
         mat(k,2129) = 0._r8
         mat(k,2130) = 0._r8
         mat(k,2131) = 0._r8
         mat(k,2132) = 0._r8
         mat(k,2133) = 0._r8
         mat(k,2137) = 0._r8
         mat(k,2138) = 0._r8
         mat(k,2139) = 0._r8
         mat(k,2140) = 0._r8
         mat(k,2141) = 0._r8
         mat(k,2142) = 0._r8
         mat(k,2143) = 0._r8
         mat(k,2144) = 0._r8
         mat(k, 1) = mat(k, 1) - dti
         mat(k, 2) = mat(k, 2) - dti
         mat(k, 3) = mat(k, 3) - dti
         mat(k, 4) = mat(k, 4) - dti
         mat(k, 5) = mat(k, 5) - dti
         mat(k, 6) = mat(k, 6) - dti
         mat(k, 7) = mat(k, 7) - dti
         mat(k, 8) = mat(k, 8) - dti
         mat(k, 9) = mat(k, 9) - dti
         mat(k, 10) = mat(k, 10) - dti
         mat(k, 11) = mat(k, 11) - dti
         mat(k, 12) = mat(k, 12) - dti
         mat(k, 13) = mat(k, 13) - dti
         mat(k, 14) = mat(k, 14) - dti
         mat(k, 15) = mat(k, 15) - dti
         mat(k, 16) = mat(k, 16) - dti
         mat(k, 17) = mat(k, 17) - dti
         mat(k, 18) = mat(k, 18) - dti
         mat(k, 19) = mat(k, 19) - dti
         mat(k, 20) = mat(k, 20) - dti
         mat(k, 21) = mat(k, 21) - dti
         mat(k, 22) = mat(k, 22) - dti
         mat(k, 23) = mat(k, 23) - dti
         mat(k, 24) = mat(k, 24) - dti
         mat(k, 25) = mat(k, 25) - dti
         mat(k, 26) = mat(k, 26) - dti
         mat(k, 27) = mat(k, 27) - dti
         mat(k, 28) = mat(k, 28) - dti
         mat(k, 29) = mat(k, 29) - dti
         mat(k, 30) = mat(k, 30) - dti
         mat(k, 31) = mat(k, 31) - dti
         mat(k, 32) = mat(k, 32) - dti
         mat(k, 33) = mat(k, 33) - dti
         mat(k, 34) = mat(k, 34) - dti
         mat(k, 40) = mat(k, 40) - dti
         mat(k, 46) = mat(k, 46) - dti
         mat(k, 47) = mat(k, 47) - dti
         mat(k, 50) = mat(k, 50) - dti
         mat(k, 53) = mat(k, 53) - dti
         mat(k, 56) = mat(k, 56) - dti
         mat(k, 60) = mat(k, 60) - dti
         mat(k, 63) = mat(k, 63) - dti
         mat(k, 66) = mat(k, 66) - dti
         mat(k, 69) = mat(k, 69) - dti
         mat(k, 72) = mat(k, 72) - dti
         mat(k, 74) = mat(k, 74) - dti
         mat(k, 77) = mat(k, 77) - dti
         mat(k, 80) = mat(k, 80) - dti
         mat(k, 87) = mat(k, 87) - dti
         mat(k, 93) = mat(k, 93) - dti
         mat(k, 97) = mat(k, 97) - dti
         mat(k, 102) = mat(k, 102) - dti
         mat(k, 104) = mat(k, 104) - dti
         mat(k, 113) = mat(k, 113) - dti
         mat(k, 120) = mat(k, 120) - dti
         mat(k, 125) = mat(k, 125) - dti
         mat(k, 129) = mat(k, 129) - dti
         mat(k, 132) = mat(k, 132) - dti
         mat(k, 142) = mat(k, 142) - dti
         mat(k, 150) = mat(k, 150) - dti
         mat(k, 155) = mat(k, 155) - dti
         mat(k, 158) = mat(k, 158) - dti
         mat(k, 163) = mat(k, 163) - dti
         mat(k, 166) = mat(k, 166) - dti
         mat(k, 169) = mat(k, 169) - dti
         mat(k, 173) = mat(k, 173) - dti
         mat(k, 177) = mat(k, 177) - dti
         mat(k, 181) = mat(k, 181) - dti
         mat(k, 185) = mat(k, 185) - dti
         mat(k, 191) = mat(k, 191) - dti
         mat(k, 197) = mat(k, 197) - dti
         mat(k, 200) = mat(k, 200) - dti
         mat(k, 206) = mat(k, 206) - dti
         mat(k, 212) = mat(k, 212) - dti
         mat(k, 217) = mat(k, 217) - dti
         mat(k, 222) = mat(k, 222) - dti
         mat(k, 227) = mat(k, 227) - dti
         mat(k, 232) = mat(k, 232) - dti
         mat(k, 237) = mat(k, 237) - dti
         mat(k, 242) = mat(k, 242) - dti
         mat(k, 248) = mat(k, 248) - dti
         mat(k, 253) = mat(k, 253) - dti
         mat(k, 258) = mat(k, 258) - dti
         mat(k, 261) = mat(k, 261) - dti
         mat(k, 269) = mat(k, 269) - dti
         mat(k, 277) = mat(k, 277) - dti
         mat(k, 283) = mat(k, 283) - dti
         mat(k, 289) = mat(k, 289) - dti
         mat(k, 295) = mat(k, 295) - dti
         mat(k, 301) = mat(k, 301) - dti
         mat(k, 307) = mat(k, 307) - dti
         mat(k, 313) = mat(k, 313) - dti
         mat(k, 321) = mat(k, 321) - dti
         mat(k, 327) = mat(k, 327) - dti
         mat(k, 334) = mat(k, 334) - dti
         mat(k, 340) = mat(k, 340) - dti
         mat(k, 343) = mat(k, 343) - dti
         mat(k, 348) = mat(k, 348) - dti
         mat(k, 355) = mat(k, 355) - dti
         mat(k, 362) = mat(k, 362) - dti
         mat(k, 366) = mat(k, 366) - dti
         mat(k, 373) = mat(k, 373) - dti
         mat(k, 382) = mat(k, 382) - dti
         mat(k, 389) = mat(k, 389) - dti
         mat(k, 397) = mat(k, 397) - dti
         mat(k, 404) = mat(k, 404) - dti
         mat(k, 410) = mat(k, 410) - dti
         mat(k, 415) = mat(k, 415) - dti
         mat(k, 421) = mat(k, 421) - dti
         mat(k, 427) = mat(k, 427) - dti
         mat(k, 432) = mat(k, 432) - dti
         mat(k, 440) = mat(k, 440) - dti
         mat(k, 448) = mat(k, 448) - dti
         mat(k, 456) = mat(k, 456) - dti
         mat(k, 464) = mat(k, 464) - dti
         mat(k, 468) = mat(k, 468) - dti
         mat(k, 476) = mat(k, 476) - dti
         mat(k, 484) = mat(k, 484) - dti
         mat(k, 495) = mat(k, 495) - dti
         mat(k, 504) = mat(k, 504) - dti
         mat(k, 511) = mat(k, 511) - dti
         mat(k, 518) = mat(k, 518) - dti
         mat(k, 524) = mat(k, 524) - dti
         mat(k, 531) = mat(k, 531) - dti
         mat(k, 543) = mat(k, 543) - dti
         mat(k, 554) = mat(k, 554) - dti
         mat(k, 565) = mat(k, 565) - dti
         mat(k, 573) = mat(k, 573) - dti
         mat(k, 584) = mat(k, 584) - dti
         mat(k, 595) = mat(k, 595) - dti
         mat(k, 602) = mat(k, 602) - dti
         mat(k, 613) = mat(k, 613) - dti
         mat(k, 629) = mat(k, 629) - dti
         mat(k, 640) = mat(k, 640) - dti
         mat(k, 649) = mat(k, 649) - dti
         mat(k, 658) = mat(k, 658) - dti
         mat(k, 668) = mat(k, 668) - dti
         mat(k, 676) = mat(k, 676) - dti
         mat(k, 685) = mat(k, 685) - dti
         mat(k, 696) = mat(k, 696) - dti
         mat(k, 703) = mat(k, 703) - dti
         mat(k, 707) = mat(k, 707) - dti
         mat(k, 712) = mat(k, 712) - dti
         mat(k, 723) = mat(k, 723) - dti
         mat(k, 739) = mat(k, 739) - dti
         mat(k, 749) = mat(k, 749) - dti
         mat(k, 757) = mat(k, 757) - dti
         mat(k, 766) = mat(k, 766) - dti
         mat(k, 773) = mat(k, 773) - dti
         mat(k, 785) = mat(k, 785) - dti
         mat(k, 802) = mat(k, 802) - dti
         mat(k, 809) = mat(k, 809) - dti
         mat(k, 827) = mat(k, 827) - dti
         mat(k, 853) = mat(k, 853) - dti
         mat(k, 873) = mat(k, 873) - dti
         mat(k, 882) = mat(k, 882) - dti
         mat(k, 895) = mat(k, 895) - dti
         mat(k, 906) = mat(k, 906) - dti
         mat(k, 913) = mat(k, 913) - dti
         mat(k, 921) = mat(k, 921) - dti
         mat(k, 935) = mat(k, 935) - dti
         mat(k, 955) = mat(k, 955) - dti
         mat(k, 967) = mat(k, 967) - dti
         mat(k, 977) = mat(k, 977) - dti
         mat(k, 986) = mat(k, 986) - dti
         mat(k, 997) = mat(k, 997) - dti
         mat(k,1011) = mat(k,1011) - dti
         mat(k,1023) = mat(k,1023) - dti
         mat(k,1027) = mat(k,1027) - dti
         mat(k,1036) = mat(k,1036) - dti
         mat(k,1047) = mat(k,1047) - dti
         mat(k,1058) = mat(k,1058) - dti
         mat(k,1075) = mat(k,1075) - dti
         mat(k,1097) = mat(k,1097) - dti
         mat(k,1112) = mat(k,1112) - dti
         mat(k,1124) = mat(k,1124) - dti
         mat(k,1150) = mat(k,1150) - dti
         mat(k,1178) = mat(k,1178) - dti
         mat(k,1203) = mat(k,1203) - dti
         mat(k,1223) = mat(k,1223) - dti
         mat(k,1243) = mat(k,1243) - dti
         mat(k,1276) = mat(k,1276) - dti
         mat(k,1292) = mat(k,1292) - dti
         mat(k,1311) = mat(k,1311) - dti
         mat(k,1326) = mat(k,1326) - dti
         mat(k,1371) = mat(k,1371) - dti
         mat(k,1402) = mat(k,1402) - dti
         mat(k,1425) = mat(k,1425) - dti
         mat(k,1450) = mat(k,1450) - dti
         mat(k,1492) = mat(k,1492) - dti
         mat(k,1641) = mat(k,1641) - dti
         mat(k,1668) = mat(k,1668) - dti
         mat(k,1691) = mat(k,1691) - dti
         mat(k,1773) = mat(k,1773) - dti
         mat(k,1816) = mat(k,1816) - dti
         mat(k,1879) = mat(k,1879) - dti
         mat(k,1915) = mat(k,1915) - dti
         mat(k,1943) = mat(k,1943) - dti
         mat(k,2039) = mat(k,2039) - dti
         mat(k,2098) = mat(k,2098) - dti
         mat(k,2119) = mat(k,2119) - dti
         mat(k,2146) = mat(k,2146) - dti
      end do
      end subroutine nlnmat_finit
      subroutine nlnmat( avec_len, mat, y, rxt, lmat, dti )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(veclen,nzcnt)
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
      call nlnmat01( avec_len, mat, y, rxt )
      call nlnmat02( avec_len, mat, y, rxt )
      call nlnmat03( avec_len, mat, y, rxt )
      call nlnmat04( avec_len, mat, y, rxt )
      call nlnmat05( avec_len, mat, y, rxt )
      call nlnmat06( avec_len, mat, y, rxt )
      call nlnmat07( avec_len, mat, y, rxt )
      call nlnmat08( avec_len, mat, y, rxt )
      call nlnmat09( avec_len, mat, y, rxt )
      call nlnmat10( avec_len, mat, y, rxt )
      call nlnmat_finit( avec_len, mat, lmat, dti )
      end subroutine nlnmat
      end module mo_nln_matrix
